#include "pwc-ctrl-autoircut.h"
#ifdef _AUTO_IRCUT_
extern struct gpio_status gs;
extern int CurrentExposure;
extern void topro_set_gpio(struct pwc_device *pdev) ;
//---------------state diagram-----------------
//none ->day(night)
//day ->night
//night->day(ir-light)
//ir-light ->none
//--------------------------------------------
//in order to proceess the situation "has a ir light",always switch between D/N
//this is just a temp solution.
void check_ir_light_on_off(AUTO_IRCUT_UNIT *unit)
{
	unit->switch_times ++;
	
	if(1==unit->switch_times)
	{
		unit->first_switch_time = jiffies;
	}
	if(time_after(jiffies , unit->first_switch_time+TOLERANCE_TIMES))
	{
		unit->switch_times = 0;
		//Set to day mode
		gs.qpio_status = GPIO_STATUS_HIGH;
		topro_set_gpio(unit->pdev);
		//check day to night condition
		unit->state = AUTO_IRCUT_CHECK_DAY_MODE;
	}
	else
	{
		if(TOLERANCE_SWITCH_TIMES==unit->switch_times)
		{
			//ok we suppose ir light is on ,still in night mode
			//just change state to has ir light
			unit->state = AUTO_IRCUT_IR_LIGHT;
			unit->ir_light_exposure= CurrentExposure;
			unit->ir_light_tolerance_time = jiffies;
			unit->switch_times = 0;
		}
		else
		{
			//Set to day mode
			gs.qpio_status = GPIO_STATUS_HIGH;
			topro_set_gpio(unit->pdev);
			//check day to night condition
			unit->state = AUTO_IRCUT_CHECK_DAY_MODE;
		}		
	}
}
//only enable auto ircut when exposure change larger than 10 and standing TOLERANCE_TIME1
void wait_exposure_change(AUTO_IRCUT_UNIT *unit)
{
	if ( abs(CurrentExposure - unit->ir_light_exposure) > WAIT_EXPOSURE_CHANGE_NUM
				|| CurrentExposure == 137)
	{
		if(time_after(jiffies , unit->ir_light_tolerance_time+WAIT_EXPOSURE_CHANGE_TOLERANCE_TIME))
		{
			//yes,we enable auto_ircut again
			unit->state = AUTO_IRCUT_NONE;
		}
	}
	else
	{
		unit->ir_light_tolerance_time = jiffies;
	}
}
void check_day_to_night_condition(AUTO_IRCUT_UNIT *unit)
{
	if(unit->accy < D2N_ACCY)
	{
		if(time_after(jiffies , unit->tolerance_time+TOLERANCE_TIME))/*always 10 secs*/
		{
			unit->tolerance_time = jiffies;	
			//Set to night mode
			gs.qpio_status = GPIO_STATUS_LOW;
			topro_set_gpio(unit->pdev);
			//check night to day condition
			unit->state = AUTO_IRCUT_CHECK_NIGHT_MODE;
		}
	}
	else
	{
		unit->tolerance_time = jiffies;	
	}	
}

void check_night_to_day_condition(AUTO_IRCUT_UNIT *unit)
{
	if(unit->accy > N2D_ACCY)
	{
		if(time_after(jiffies , unit->tolerance_time+TOLERANCE_TIME))
		{
			unit->tolerance_time = jiffies;	
			//may be this switch is made by ir light 
			check_ir_light_on_off(unit);
		}
	}
	else
	{
		unit->tolerance_time = jiffies;	
	}
}

void auto_ircut_main(AUTO_IRCUT_UNIT *unit)
{
	//printk("state=%d,accy=%d,switch_times=%d,first_switch_time=%lu,jiffies=%d,ir_light_exposure=%d(%d)\n",
	//	unit->state,unit->accy,unit->switch_times,unit->first_switch_time,jiffies,unit->ir_light_exposure,CurrentExposure);
	switch(unit->state)
	{
	case AUTO_IRCUT_CHECK_DAY_MODE:
		check_day_to_night_condition(unit);
		break;
	case AUTO_IRCUT_CHECK_NIGHT_MODE:
		check_night_to_day_condition(unit);
		break;
	case AUTO_IRCUT_NONE:
		//need to initial tolerance_time
		unit->tolerance_time = jiffies;
		if(unit->accy > N2D_ACCY)
		{
			//Set to day mode
			gs.qpio_status = GPIO_STATUS_HIGH;
			topro_set_gpio(unit->pdev);
			unit->state = AUTO_IRCUT_CHECK_DAY_MODE;
		}
		else if(unit->accy < D2N_ACCY)
		{
			//Set to night mode
			gs.qpio_status = GPIO_STATUS_LOW;
			topro_set_gpio(unit->pdev);
			unit->state = AUTO_IRCUT_CHECK_NIGHT_MODE;
		}
		else
		{
			//keep the stat;
		}
		break;
	case AUTO_IRCUT_IR_LIGHT:
		wait_exposure_change(unit);
		break;
	default:
		break;
	}
}
#endif

