#include "sc_config.h"
#ifdef _AUTO_IRCUT_
#include "pwc-ioctl.h"
#ifdef __KERNEL__
#include <asm/uaccess.h>
#endif
#include <asm/errno.h>
#include <linux/usb.h>
#include "pwc.h"

enum {
	AUTO_IRCUT_NONE = 0,
	AUTO_IRCUT_CHECK_DAY_MODE,
	AUTO_IRCUT_CHECK_NIGHT_MODE,
	AUTO_IRCUT_IR_LIGHT
};

#define D2N_ACCY        80
#define N2D_ACCY        120

//normal tolerance time
#define TOLERANCE_TIME  10*100		/*10 secs*/
#define TOLERANCE_SWITCH_TIMES 2	
//TOLERANCE_SWITCH_TIMES = 2 
//interval = 2*TOLERANCE_TIME = 20 secs
//we enlarge TOLERANCE_TIMES to 30 secs for security
#define TOLERANCE_TIMES 30*100

#define WAIT_EXPOSURE_CHANGE_NUM 10
#define WAIT_EXPOSURE_CHANGE_TOLERANCE_TIME  30*100		/*30 secs*/

typedef struct 
{
	int state;
	int accy;
	int ir_light_exposure;
	unsigned long tolerance_time;
	unsigned long ir_light_tolerance_time;
	unsigned long first_switch_time;
	int switch_times;
	struct pwc_device *pdev;
} AUTO_IRCUT_UNIT;
void auto_ircut_main(AUTO_IRCUT_UNIT *unit);
#endif
