
/***************************************************************
 * (C) COPYRIGHT SerComm Corporation All Rights Reserved, 2008.
 *
 *      Use of this software is restricted to the terms and
 *      conditions of SerComm's software license agreement.
 *
 *                        www.sercomm.com
 ****************************************************************/
#include <stdlib.h>
#include <getopt.h>
#include <sys/soundcard.h>
#include <stdio.h>
#include <stdint.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/ioctl.h>
#include <fcntl.h>
#include <unistd.h>
#include <errno.h>
#include "sc_tool.h"

#define MIXER_AC97_READ(dev)		_IOR('A', dev, int)
#define MIXER_AC97_WRITE(dev)		_IOW('A', dev, int)

#define MIXER_DEV   "/dev/sound/mixer"


int hex2int(char *hex)
{
	int j, s = 0;

	if(strlen(hex) > 2 && hex[0] == '0' && hex[1] == 'x')
	{
		j = 2;
	}
	else
	{
		j = 0;
	}

	for(; j < strlen(hex); j++)
	{
		s *= 16;
		if(hex[j] >= 97)
		{
			s += (hex[j] - 97 + 10);
		}
		else if(hex[j] >= 65)
		{
			s += (hex[j] - 65 + 10);
		}
		else
		{
			s += (hex[j] - 48);
		}
	}

	return s;
}

void show_usage()
{
	printf("Write only!!!\n");
	printf("Write:\t<reg> <value>\n");
}

int main(int argc, char **argv)
{
	int rc = 0, addr = 0, val = 0;
	int mixer = 0;
	
	mixer = open(MIXER_DEV, O_RDWR);
	if (mixer < 0) 
	{
		printf("Failed to open device %s\n", MIXER_DEV);
		return -1;
	}
	if(argc < 2)
	{
		show_usage();
	}

	
	if(argc >= 2)
	{
		if(strlen(argv[1]) > 2 && argv[1][0] == '0' && argv[1][1] == 'x')
		{
			printf("%s\n", argv[1]);
			addr = hex2int(argv[1]);;
		}
		else
		{
			addr = atoi(argv[1]);
		}

		if((addr < 0 || addr > 9) && (addr != 15))
		{
			printf("Invaild range.\n");
			goto EXIT;
		}
	}

	if(argc >= 3)
	{
		if(strlen(argv[2]) > 2 && argv[2][0] == '0' && argv[2][1] == 'x')
		{
			printf("%s\n", argv[2]);
			val = hex2int(argv[2]);;
		}
		else
		{
			val = atoi(argv[2]);
		}
	}


	if(argc == 2)
	{
		printf("Can not read !!!\n");
	}
	else if(argc == 3)
	{
		rc = ioctl(mixer, MIXER_AC97_WRITE(addr), &val);
		printf("write(0x%04x, %d) = %d \n", addr, val, rc);
	}




EXIT:
	if (mixer)
	{
		close(mixer);
	}

    return 0;
}

