#ifndef __OV7670_H__
#define __OV7670_H__

#if 1
#define	OV7670_DBG(fmt, args...)	{		\
	printf("%s(%d): ", __FILE__, __LINE__);	\
	printf(fmt, ##args);					\
}
#define	OV7670_LINE	printk("(%s:%d) @ %s\n", __FUNCTION__, __LINE__, __FILE__)
#else
#define	OV7670_DBG(fmt, args...)
#define	OV7670_LINE
#endif

#define	OV7670_SYSCTL_READ		0x1000
#define	OV7670_SYSCTL_WRITE		0x1001

#define OV7670REG_GAIN			0x00
#define OV7670REG_BLUE			0x01
#define OV7670REG_RED			0x02
#define OV7670REG_VREF			0x03
#define OV7670REG_COM1			0x04
#define OV7670REG_BAVE			0x05
#define	OV7670REG_GbAVE			0x06
#define	OV7670REG_AECHH			0x07
#define OV7670REG_RAVE			0x08
#define OV7670REG_COM2			0x09
#define OV7670REG_PID			0x0A
#define OV7670REG_VER			0x0B
#define OV7670REG_COM3			0x0C
#define OV7670REG_COM4			0x0D
#define OV7670REG_COM5			0x0E
#define OV7670REG_COM6			0x0F
#define OV7670REG_AECH			0x10
#define OV7670REG_CLKRC			0x11
#define OV7670REG_COM7			0x12
#define OV7670REG_COM8			0x13
#define OV7670REG_COM9			0x14
#define OV7670REG_COM10			0x15
//	reserved					0x16
#define OV7670REG_HSTART		0x17
#define OV7670REG_HSTOP			0x18
#define OV7670REG_VSTART		0x19
#define OV7670REG_VSTOP			0x1A
#define OV7670REG_PSHFT			0x1B
#define OV7670REG_MIDH			0x1C
#define OV7670REG_MIDL			0x1D
#define OV7670REG_MVFP			0x1E
#define OV7670REG_LAEC			0x1F
#define OV7670REG_ADCCTR0		0x20
#define OV7670REG_ADCCTR1		0x21
#define OV7670REG_ADCCTR2		0x22
#define OV7670REG_ADCCTR3		0x23
#define OV7670REG_AEW			0x24
#define OV7670REG_AEB			0x25
#define OV7670REG_VPT			0x26
#define OV7670REG_BBIAS			0x27
#define OV7670REG_GbBIAS		0x28
// Reserved 0x29
#define OV7670REG_EXHCH			0x2A
#define OV7670REG_EXHCL			0x2B
#define OV7670REG_RBIAS			0x2C
#define OV7670REG_ADVFL			0x2D
#define OV7670REG_ADVFH			0x2E
#define OV7670REG_YAVE			0x2F
#define OV7670REG_HSYST			0x30
#define OV7670REG_HSYEN			0x31
#define OV7670REG_HREF			0x32
#define OV7670REG_CHLF			0x33
#define OV7670REG_ARBLM			0x34
//	reserved					0x35
//	reserved					0x36
#define OV7670REG_ADC			0x37
#define OV7670REG_ACOM			0x38
#define OV7670REG_OFON			0x39
#define OV7670REG_TSLB			0x3A
#define OV7670REG_COM11			0x3B
#define OV7670REG_COM12			0x3C
#define OV7670REG_COM13			0x3D
#define OV7670REG_COM14			0x3E
#define OV7670REG_EDGE			0x3F
#define OV7670REG_COM15			0x40
#define OV7670REG_COM16			0x41
#define OV7670REG_COM17			0x42
#define	OV7670REG_AWBC1			0x43
#define	OV7670REG_AWBC2			0x44
#define	OV7670REG_AWBC3			0x45
#define	OV7670REG_AWBC4			0x46
#define	OV7670REG_AWBC5			0x47
#define	OV7670REG_AWBC6			0x48
// Reserved 0x49 - 0x4A
#define	OV7670REG_REG4B			0x4B
#define	OV7670REG_DNSTH			0x4C
// Reserved 0x4D - 0x4E
#define OV7670REG_MTX1			0x4F
#define OV7670REG_MTX2			0x50
#define OV7670REG_MTX3			0x51
#define OV7670REG_MTX4			0x52
#define OV7670REG_MTX5			0x53
#define OV7670REG_MTX6			0x54
#define	OV7670REG_BRIGHT		0x55
#define	OV7670REG_CONTRAS		0x56
#define	OV7670REG_CONTRAS_CENTER	0x57
#define OV7670REG_MTXS			0x58
//	reserved					0x59~0x61
#define OV7670REG_LCC1			0x62
#define OV7670REG_LCC2			0x63
#define OV7670REG_LCC3			0x64
#define OV7670REG_LCC4			0x65
#define OV7670REG_LCC5			0x66
#define OV7670REG_MANU			0x67
#define OV7670REG_MANV			0x68
#define OV7670REG_GFIX			0x69
#define OV7670REG_GGAIN			0x6A
#define OV7670REG_DBLV			0x6B
#define OV7670REG_AWBCTR3		0x6C
#define	OV7670REG_AWBCTR2		0x6D
#define	OV7670REG_AWBCTR1		0x6E
#define	OV7670REG_AWBCTR0		0x6F
#define	OV7670REG_SCALING_XSC	0x70
#define	OV7670REG_SCALING_YSC	0x71
#define	OV7670REG_SCALING_DCWCTR	0x72
#define	OV7670REG_SCALING_PCLK_DIV	0x73
#define	OV7670REG_REG74			0x74
#define	OV7670REG_REG75			0x75
#define	OV7670REG_REG76			0x76
#define	OV7670REG_REG77			0x77
// Reserved 0x78 - 0x79
#define	OV7670REG_SLOP			0x7A
#define	OV7670REG_GAM1			0x7B
#define	OV7670REG_GAM2			0x7C
#define	OV7670REG_GAM3			0x7D
#define	OV7670REG_GAM4			0x7E
#define	OV7670REG_GAM5			0x7F
#define	OV7670REG_GAM6			0x80
#define	OV7670REG_GAM7			0x81
#define	OV7670REG_GAM8			0x82
#define	OV7670REG_GAM9			0x83
#define	OV7670REG_GAM10			0x84
#define	OV7670REG_GAM11			0x85
#define	OV7670REG_GAM12			0x86
#define	OV7670REG_GAM13			0x87
#define	OV7670REG_GAM14			0x88
#define	OV7670REG_GAM15			0x89
// Reserved 0x8A - 0x8B
#define	OV7670REG_RGB444		0x8C
// Reserved 0x8D - 0x91
#define	OV7670REG_DM_LNL		0x92
#define	OV7670REG_DM_LNH		0x93
#define	OV7670REG_LCC6			0x94
#define	OV7670REG_LCC7			0x95
// Reserved 0x96 - 0x9C
#define	OV7670REG_BD50ST		0x9D
#define	OV7670REG_BD60ST		0x9E
#define	OV7670REG_HAECC1		0x9F
#define	OV7670REG_HAECC2		0xA0
// Reserved 0xA1
#define	OV7670REG_SCALING_PCLK_DELAY	0xA2
// Reserved 0xA3
#define	OV7670REG_NT_CTRL		0xA4
#define	OV7670REG_DB50MAX		0xA5
#define	OV7670REG_HAECC3		0xA6
#define	OV7670REG_HAECC4		0xA7
#define	OV7670REG_HAECC5		0xA8
#define	OV7670REG_HAECC6		0xA9
#define	OV7670REG_HAECC7		0xAA
#define	OV7670REG_DB60MAX		0xAB
#define	OV7670REG_STR_OPT		0xAC
#define	OV7670REG_STR_R			0xAD
#define	OV7670REG_STR_G			0xAE
#define	OV7670REG_STR_B			0xAF
// Reserved 0xB0
#define	OV7670REG_ABLC1			0xB1
// Reserved 0xB2
#define	OV7670REG_THL_ST		0xB3
// Reserved 0xB4
#define	OV7670REG_THL_DLT		0xB5
// Reserved 0xB6 - 0xBD
#define	OV7670REG_AD_CHB		0xBE
#define	OV7670REG_AD_CHR		0xBF
#define	OV7670REG_AD_CHGb		0xC0
#define	OV7670REG_AD_CHGr		0xC1
// Reserved 0xC2 - 0xC8
#define	OV7670REG_SATCTR		0xC9

#define	OV7670_I2C_IOADDR		((0x42 & 0xFE) >> 1)

#define OV7670_PID				0x76
#define OV7670_VER				0x73

#define COM7_SXVGA				0x00
#define COM7_VGA				0x40
#define COM7_CIF				0x20
#define COM7_QVGA				0x10
#define COM7_QCIF				0x08
#define COM7_RGB				0x04
#define COM7_RAWRGB				0x05

#if 0
typedef struct _tagOV7670Data 
{
	int 				nSysCtlID;
	struct semaphore	UpdateLock;
	char 				cValid;			// !=0 if following fields are valid
	unsigned long		uLastUpdated;	// In jiffies 
	unsigned short		wReg;
	unsigned char 		wRead, wWrite;	// Register values
	devfs_handle_t		DevFS;
	struct i2c_client	*pClient;
	PSENSOR				pSensor;
} 	OV7670DATA;
typedef OV7670DATA *POV7670DATA;
#endif

#endif
