/*
 *
 *    copyright (C) 2001-2002 SerComm Corporation  ALL RIGHTS RESERVED  
 *                                                                     
 *             SerComm CORPORATION PROPRIETARY INFORMATION         
 *                                                                    	
 *     This software is supplied under the terms of a license agree-   	
 *     ment or non-disclosure agreement with SerComm Corporation         
 *     and may not be copied nor disclosed except in accordance       
 *     with the terms of that agreement.                              
 *                                                                   
 */

#ifndef __SC_CONFIG_H__
#define __SC_CONFIG_H__

/* OEM-Model MACRO GLOBAL Define 
 * Same as defined in the shell: makeall
 */
#include "sc_model.h"

//#define _LINKTYPE_CHG_AUTO_

/*
 * Can have multiple streamings for MP4, for MJPEG
 */
//#define _SC_SUPPORT_MULTI_STREAM_

#define _SC_SUPPORT_2_RTC_AUTO_

#define _ONE_FW_MULTI_LOCATION_

// Has a status flag in configuration file to indicate whether the camera is set?
#define _HAS_CONF_STATUS_CONTROL_

#ifdef _WLAN_
#define _WLAN_HAS_WSC_
#endif

#ifndef  _NO_PUSHBUTTON_3_10_
#ifndef _PUSHBUTTON_3_10_
#define _PUSHBUTTON_3_10_
#endif
#endif

// Fully support MP4S or M4S2, Suzhou update at 12/25/2007
/*
 * Currently:
 *		The is-object-layer-identifire of all MPEG4 is 0
 *		ASF streaming, all of trigger file(asf/avi/mp4/3gp) use MP4S format without VOS header
 *		RTP use VOS header
 */
#define _SC_MPEG4_IS_MP4S_	
//#define _SC_MPEG4_IS_OBJECT_LAYER_IDENTIFIER_
// but RTP packets have vos header
#define _SC_RTP_MPEG4_HAS_VOS_

// Display the default name, and can config the device name
#define _SC_EDIT_DEVICE_NAME_

#define _SZ_REDUCE_MEM_

#define _SC_GROUP_CGI_SOLUTION_NEW_

// Fixed the bug can't crypt the string whose length is bigger than 8
#define _SC_FIX_CRYPT_BUG_

#define UPG_FILE		"/tmp/sc1100.bin"

#define _CHECK_VIDEO_ACESS_ENABLE_

// From Taipei's function of new query CGI
#define BOA_REMOTE_USER	

#define _HIDDEN_SESSION_FOR_ALERTOCX_ADMIN_

#define SC_RESVRVED_FW_INFO_FILE		"/tmp/sc_resv_info"

#define ARPCHECK

#define _RTSP_
#define _RTCP_
#define _FTP_
#define _FTP_2_
#define _IO_
#define _IP_FILTER_
#define _SMTP_AUTH_
#define _ENCRYPT_CFG_EN_
#define _ENCRYPT_CHKSUM_EN_

#define _MOBILE_SETTING_
#define _OPT_BITRATE_QUALITY_EN_

#define _MT_AUDIO_
#define _ALTNATIVE_PORT_

#define _HAVE_UPNP_
#define _DHCPCLIENT_
#define HAVE_ATTACHED
#define _WINDOW_NAME_
#define _MOTION_

//#define _SC_UPNP_HAS_PNPX_		// Suzhou add
#ifndef _SC_UPNPIGD_CP_SUPP_
#define _SC_UPNPIGD_DEL_PORT_IN_FACTORY_DEF_
#ifdef _SC_UPNPIGD_DEL_PORT_IN_FACTORY_DEF_
//Notice: Don't set UPNPIGD_WAIT_TIMES_MAX as a big value.
//Because camera may wait 2*UPNPIGD_WAIT_TIMES_MAX seconds when doing factory default 
//in some case(camera bootes with running UpnPPartMapping and before this UpnPPartMapping quit.
#define UPNPIGD_WAIT_TIMES_MAX		2
#endif
#endif

//Suzhou update.For control hydra memory using.
#define _SC_HYDRA_MEM_CAL_SOL_

#ifdef _SC_HYDRA_MEM_CAL_SOL_
//#define _SC_CHANGE_FPS_WHEN_IMAGE_LARGE_
#endif

//#define	_CGI_SCHEDULE_USE_ACTION_
#define _CGI_SCHEDULE_USE_SAVE_ALL_SOLUTION_

//For control schedule,when schedule is enable,but list is empty,we will think schdule is disable
#define _SC_SCHEDULE_NULL_IS_ALL_

//#include "conf_sec.h"
#define _SC_SET_GET_WEP_KEYS_STRING_

/*
#ifndef _WEBUPG_IN_LOADER_
#define _WEBUPG_IN_LOADER_
#endif
*/

#define MTD_MAC					"/dev/mtdblock/2"		// 8K
#define MTD_LOGO				"/dev/mtdblock/4"		// 8K
#define MTD_FLASH_CONF			"/dev/mtdblock/8"		// 64K
#define MTD_ALLFLASH			"/dev/mtdblock/6"

#ifdef _DEF_CONF_FILE_IN_FLASH_
#define MTD_FLASH_CONF_DEF		MTD_LOGO		// Make sure maximal is less than 8K
#endif

#ifndef _WEBUPG_IN_LOADER_
#define MTD_HTTPS_CA			"/dev/mtdblock/7"		// 8K
#define MTD_RESERVE				"/dev/mtdblock/9"		// 8K
#endif

#ifdef _WLAN_
#define _SC_DHCP_SEND_MORE_PACKETS_FOR_WIRELESS_ // Because wireless loss packets in noisy office
																									// It is easy time out for DHCP, so sending DHCP packets frequently 
																									// to enhance the chance of success when DHCP 

#endif
//#define _WPA_WPA2_ENTERPRISE_

#define SYS_DATE_MIN		2005
#define SYS_DATE_MAX		2037

#endif



