///////////////////////////////////////////////////////////////
// Topro PC Camera Parameter Table
///////////////////////////////////////////////////////////////
#ifndef TP_PARAM_H
#define TP_PARAM_H

#include "tp_def.h"

//////////////////////////////////////////////////////////////////////
// Micron MT9M001
//////////////////////////////////////////////////////////////////////
/*
UCHAR Micron_MT9M001[] =
    {
	SIF_TYPE,0x04,
	SIF_CONTROL,0x00,
	MCLK_SEL, 0x11,
	CLK_CFG, 0x3a,
	PCLK_CFG, 0x21,
	ISP_MODE, 0x00,
	VIDEO_TIMING, 0x11,
	VIDEO_PTN, 0x02,
	GAGEN_CTL, 0x01,
	GDIFF_THRLD, 0x80,
	MCLK_CFG, 0x03,

      FUNCTION_SEL, 0x02,
      CCIR_MODE,0x81,
    };*/
//;
struct topro_sregs init_Micron_MT9M001[] =
{
	{SIF_TYPE		, 0x04},
	{SIF_CONTROL, 0x00},
	{MCLK_SEL		, 0x11},
	{CLK_CFG		, 0x3a},
	{PCLK_CFG		, 0x21},

	{ISP_MODE			, 0x00},
	{VIDEO_TIMING	, 0x11},
	{VIDEO_PTN		, 0x02},
	{GAGEN_CTL		, 0x01},
	{GDIFF_THRLD	, 0x80},
	{MCLK_CFG			, 0x03},

	{FUNCTION_SEL	, 0x02},
	{CCIR_MODE		, 0x81},      
  
	{END_REG, 0x00}
};

/*
UCHAR Micron_MT9M001_VGA[] =
    {
	CFA_PIXEL_START_L,0x06,   CFA_PIXEL_START_H,0x00,
	CFA_LINE_START_L,0x01,   CFA_LINE_START_H,0x00,
	CFA_FRAME_WIDTH_L,0x7F,	CFA_FRAME_WIDTH_H,0x02,	
	CFA_FRAME_HEIGHT_L,0xDF,	CFA_FRAME_HEIGHT_H,0x01,
    };
UCHAR Micron_MT9M001_QVGA[] =
    {
	CFA_PIXEL_START_L,0x06,   CFA_PIXEL_START_H,0x00,
	CFA_LINE_START_L,0x01,   CFA_LINE_START_H,0x00,
	CFA_FRAME_WIDTH_L,0x7F,	CFA_FRAME_WIDTH_H,0x02,	
	CFA_FRAME_HEIGHT_L,0xDF,	CFA_FRAME_HEIGHT_H,0x01,
    };*/
struct topro_sregs vga_micron_MT9M001_vga[] =
{
	{CFA_PIXEL_START_L,0x06},   {CFA_PIXEL_START_H,0x00},
		{CFA_LINE_START_L,0x01},   {CFA_LINE_START_H,0x00},
		{CFA_FRAME_WIDTH_L,0x7F},	{CFA_FRAME_WIDTH_H,0x02},	
		{CFA_FRAME_HEIGHT_L,0xDF},	{CFA_FRAME_HEIGHT_H,0x01},
	{END_REG, 0x00}
};
struct topro_sregs qvga_micron_MT9M001_qvga[] =
{
	{CFA_PIXEL_START_L,0x06},   {CFA_PIXEL_START_H,0x00},
	{CFA_LINE_START_L,0x01},   {CFA_LINE_START_H,0x00},
	{CFA_FRAME_WIDTH_L,0x7F},	{CFA_FRAME_WIDTH_H,0x02},	
	{CFA_FRAME_HEIGHT_L,0xDF},	{CFA_FRAME_HEIGHT_H,0x01},
	{END_REG, 0x00}
};
#if 1
//;[
/*
struct topro_sregs topro_qvga_micron_MT9V011[] =
{
	{CFA_PIXEL_START_L,0x06},   {CFA_PIXEL_START_H,0x00},
	{CFA_LINE_START_L,0x01},   {CFA_LINE_START_H,0x00},
	{CFA_FRAME_WIDTH_L,0x7F},	{CFA_FRAME_WIDTH_H,0x02},
	{CFA_FRAME_HEIGHT_L,0xDF},	{CFA_FRAME_HEIGHT_H,0x01},
	{END_REG, 0x00}
};
struct topro_sregs topro_qcif_micron_MT9V011[] =   //TP6800_QCIF
{
	{CFA_PIXEL_START_L,0x06},   {CFA_PIXEL_START_H,0x00},
	{CFA_LINE_START_L,0x01},   {CFA_LINE_START_H,0x00},
	{CFA_FRAME_WIDTH_L,0x5F},	{CFA_FRAME_WIDTH_H,0x01},
	{CFA_FRAME_HEIGHT_L,0x1F},	{CFA_FRAME_HEIGHT_H,0x01},
	{END_REG, 0x00}
};*/
//;]
struct topro_sregs qcif_micron_MT9M001_qcif[] =   //TP6800_QCIF
{
	{CFA_PIXEL_START_L,0x06},   {CFA_PIXEL_START_H,0x00},
	{CFA_LINE_START_L,0x01},   {CFA_LINE_START_H,0x00},
	{CFA_FRAME_WIDTH_L,0x5F},	{CFA_FRAME_WIDTH_H,0x01},
	{CFA_FRAME_HEIGHT_L,0x1F},	{CFA_FRAME_HEIGHT_H,0x01},
	{END_REG, 0x00}
};
#endif

/*
UCHAR Micron_MT9M001_I2C[] =
    {
//default from Micron MT9M001
//	  0x5D,0x0D,0x00,0x01, 0x5D,0x0D,0x00,0x00, 
	  0x5D,0x07,0x00,0x03, 
	  0x5D,0x01,0x00,0x0C, 0x5D,0x02,0x00,0x14, 
	  0x5D,0x03,0x04,0x02, 0x5D,0x04,0x05,0x00, 
	  0x5D,0x05,0x00,0x20, 0x5D,0x06,0x00,0x30,
	  0x5D,0x09,0x01,0x00, 
	  0x5D,0x0B,0x00,0x00,
	  0x5D,0x0C,0x00,0x00, 
	  0x5D,0x1E,0x80,0x00, 0x5D,0x20,0x13,0x04,
	  0x5D,0x2B,0x00,0x08, 0x5D,0x2C,0x00,0x08, 0x5D,0x2D,0x00,0x08, 
	  0x5D,0x2E,0x00,0x08, 0x5D,0x35,0x30,0x00,
	  0x5D,0x5F,0xA3,0x1D, 0x5D,0x60,0x00,0x00, 0x5D,0x61,0x00,0x00, 
	  0x5D,0x62,0x04,0x11, 0x5D,0x63,0x00,0x00, 0x5D,0x64,0x00,0x00,
      0x5D,0xf1,0x00,0x01,
	  0x5D,0x07,0x00,0x02, 
};*/

#define LNXReg_s2d2(s1,s2,td1,td2) {SIF_ADDR_S1,s1},{SIF_ADDR_S2,s2},{SIF_TX_DATA1,td1},{SIF_TX_DATA2,td2},{SIF_CONTROL,0x01}
	//	Model: {SIF_ADDR_S1,0x5d},{SIF_ADDR_S2,0x07},{SIF_TX_DATA1,0x30},{SIF_TX_DATA2,0x03},{SIF_CONTROL,0x01},

struct topro_sregs i2c_Micron_MT9M001_I2C[] =
{  
  // device address  word address       data               command
	  LNXReg_s2d2(0x5D,0x07,0x00,0x03), 
	  LNXReg_s2d2(0x5D,0x01,0x00,0x0C), LNXReg_s2d2(0x5D,0x02,0x00,0x14), 
	  LNXReg_s2d2(0x5D,0x03,0x04,0x02), LNXReg_s2d2(0x5D,0x04,0x05,0x00), 
	  LNXReg_s2d2(0x5D,0x05,0x00,0x20), LNXReg_s2d2(0x5D,0x06,0x00,0x30),
	  LNXReg_s2d2(0x5D,0x09,0x01,0x00), 
	  LNXReg_s2d2(0x5D,0x0B,0x00,0x00),
	  LNXReg_s2d2(0x5D,0x0C,0x00,0x00), 
	  LNXReg_s2d2(0x5D,0x1E,0x80,0x00), LNXReg_s2d2(0x5D,0x20,0x13,0x04),
	  LNXReg_s2d2(0x5D,0x2B,0x00,0x08), LNXReg_s2d2(0x5D,0x2C,0x00,0x08), LNXReg_s2d2(0x5D,0x2D,0x00,0x08), 
	  LNXReg_s2d2(0x5D,0x2E,0x00,0x08), LNXReg_s2d2(0x5D,0x35,0x30,0x00),
	  LNXReg_s2d2(0x5D,0x5F,0xA3,0x1D), LNXReg_s2d2(0x5D,0x60,0x00,0x00), LNXReg_s2d2(0x5D,0x61,0x00,0x00), 
	  LNXReg_s2d2(0x5D,0x62,0x04,0x11), LNXReg_s2d2(0x5D,0x63,0x00,0x00), LNXReg_s2d2(0x5D,0x64,0x00,0x00),
    LNXReg_s2d2(0x5D,0xf1,0x00,0x01),
	  LNXReg_s2d2(0x5D,0x07,0x00,0x02), 
	{END_REG, 0x00}
};

//////////////////////////////////////////////////////////////////////
// Micron MT9V011
//////////////////////////////////////////////////////////////////////
struct topro_sregs topro_init_micron_MT9V011[] =
{
	{SIF_TYPE,0x04},
	{SIF_CONTROL,0x00},
	{MCLK_SEL, 0x01},
	{CLK_CFG, 0x32},
	{PCLK_CFG, 0x25},
	{ISP_MODE, 0x00},
	{VIDEO_TIMING, 0x11},
	{VIDEO_PTN, 0x02},
//	{GAGEN_CTL, 0x01},
	{GDIFF_THRLD, 0x80},
	{MCLK_CFG, 0x03},
  {END_REG, 0x00}

};

struct topro_sregs topro_vga_micron_MT9V011[] =
{
	{CFA_PIXEL_START_L,0x06},   {CFA_PIXEL_START_H,0x00},
	{CFA_LINE_START_L,0x01},   {CFA_LINE_START_H,0x00},
	{CFA_FRAME_WIDTH_L,0x7F},	{CFA_FRAME_WIDTH_H,0x02},
	{CFA_FRAME_HEIGHT_L,0xDF},	{CFA_FRAME_HEIGHT_H,0x01},	   
	{END_REG, 0x00}
};

struct topro_sregs topro_qvga_micron_MT9V011[] =
{
	{CFA_PIXEL_START_L,0x06},   {CFA_PIXEL_START_H,0x00},
	{CFA_LINE_START_L,0x01},   {CFA_LINE_START_H,0x00},
	{CFA_FRAME_WIDTH_L,0x7F},	{CFA_FRAME_WIDTH_H,0x02},
	{CFA_FRAME_HEIGHT_L,0xDF},	{CFA_FRAME_HEIGHT_H,0x01},
	{END_REG, 0x00}
};
struct topro_sregs topro_qcif_micron_MT9V011[] =   //TP6800_QCIF
{
	{CFA_PIXEL_START_L,0x06},   {CFA_PIXEL_START_H,0x00},
	{CFA_LINE_START_L,0x01},   {CFA_LINE_START_H,0x00},
	{CFA_FRAME_WIDTH_L,0x5F},	{CFA_FRAME_WIDTH_H,0x01},
	{CFA_FRAME_HEIGHT_L,0x1F},	{CFA_FRAME_HEIGHT_H,0x01},
	{END_REG, 0x00}
};
struct topro_sregs topro_i2c_micron_MT9V011[] =
{  
  // device address  word address       data               command
	{SIF_ADDR_S1,0x5d},{SIF_ADDR_S2,0x07},{SIF_TX_DATA1,0x30},{SIF_TX_DATA2,0x03},{SIF_CONTROL,0x01},
	{SIF_ADDR_S1,0x5d},{SIF_ADDR_S2,0x01},{SIF_TX_DATA1,0x00},{SIF_TX_DATA2,0x08},{SIF_CONTROL,0x01},
	{SIF_ADDR_S1,0x5d},{SIF_ADDR_S2,0x02},{SIF_TX_DATA1,0x00},{SIF_TX_DATA2,0x14},{SIF_CONTROL,0x01},
	{SIF_ADDR_S1,0x5d},{SIF_ADDR_S2,0x03},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0xe6},{SIF_CONTROL,0x01},
	{SIF_ADDR_S1,0x5d},{SIF_ADDR_S2,0x04},{SIF_TX_DATA1,0x02},{SIF_TX_DATA2,0x86},{SIF_CONTROL,0x01},
	{SIF_ADDR_S1,0x5d},{SIF_ADDR_S2,0x05},{SIF_TX_DATA1,0x00},{SIF_TX_DATA2,0x29},{SIF_CONTROL,0x01},
	{SIF_ADDR_S1,0x5d},{SIF_ADDR_S2,0x06},{SIF_TX_DATA1,0x00},{SIF_TX_DATA2,0x0c},{SIF_CONTROL,0x01},
	{SIF_ADDR_S1,0x5d},{SIF_ADDR_S2,0x09},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S1,0x5d},{SIF_ADDR_S2,0x0a},{SIF_TX_DATA1,0x00},{SIF_TX_DATA2,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S1,0x5d},{SIF_ADDR_S2,0x0b},{SIF_TX_DATA1,0x00},{SIF_TX_DATA2,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S1,0x5d},{SIF_ADDR_S2,0x0c},{SIF_TX_DATA1,0x00},{SIF_TX_DATA2,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S1,0x5d},{SIF_ADDR_S2,0x0d},{SIF_TX_DATA1,0x00},{SIF_TX_DATA2,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S1,0x5d},{SIF_ADDR_S2,0x1e},{SIF_TX_DATA1,0x00},{SIF_TX_DATA2,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S1,0x5d},{SIF_ADDR_S2,0x20},{SIF_TX_DATA1,0x11},{SIF_TX_DATA2,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S1,0x5d},{SIF_ADDR_S2,0x27},{SIF_TX_DATA1,0x00},{SIF_TX_DATA2,0x24},{SIF_CONTROL,0x01},
 
  {SIF_ADDR_S1,0x5d},{SIF_ADDR_S2,0x2b},{SIF_TX_DATA1,0x00},{SIF_TX_DATA2,0x30},{SIF_CONTROL,0x01},
  {SIF_ADDR_S1,0x5d},{SIF_ADDR_S2,0x2c},{SIF_TX_DATA1,0x00},{SIF_TX_DATA2,0x30},{SIF_CONTROL,0x01},
  {SIF_ADDR_S1,0x5d},{SIF_ADDR_S2,0x2d},{SIF_TX_DATA1,0x00},{SIF_TX_DATA2,0x30},{SIF_CONTROL,0x01},

  {SIF_ADDR_S1,0x5d},{SIF_ADDR_S2,0x2e},{SIF_TX_DATA1,0x00},{SIF_TX_DATA2,0x30},{SIF_CONTROL,0x01},
  {SIF_ADDR_S1,0x5d},{SIF_ADDR_S2,0x35},{SIF_TX_DATA1,0x00},{SIF_TX_DATA2,0x30},{SIF_CONTROL,0x01},
  {SIF_ADDR_S1,0x5d},{SIF_ADDR_S2,0x3e},{SIF_TX_DATA1,0x08},{SIF_TX_DATA2,0x21},{SIF_CONTROL,0x01},

  {SIF_ADDR_S1,0x5d},{SIF_ADDR_S2,0x30},{SIF_TX_DATA1,0x00},{SIF_TX_DATA2,0x05},{SIF_CONTROL,0x01},
	{SIF_ADDR_S1,0x5d},{SIF_ADDR_S2,0x31},{SIF_TX_DATA1,0x00},{SIF_TX_DATA2,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S1,0x5d},{SIF_ADDR_S2,0x32},{SIF_TX_DATA1,0x00},{SIF_TX_DATA2,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S1,0x5d},{SIF_ADDR_S2,0x34},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S1,0x5d},{SIF_ADDR_S2,0x41},{SIF_TX_DATA1,0x00},{SIF_TX_DATA2,0xd1},{SIF_CONTROL,0x01},
  {SIF_ADDR_S1,0x5d},{SIF_ADDR_S2,0x42},{SIF_TX_DATA1,0x08},{SIF_TX_DATA2,0x82},{SIF_CONTROL,0x01},

  {SIF_ADDR_S1,0x5d},{SIF_ADDR_S2,0x58},{SIF_TX_DATA1,0x00},{SIF_TX_DATA2,0x78},{SIF_CONTROL,0x01},
	{SIF_ADDR_S1,0x5d},{SIF_ADDR_S2,0x59},{SIF_TX_DATA1,0x07},{SIF_TX_DATA2,0x03},{SIF_CONTROL,0x01},
  {SIF_ADDR_S1,0x5d},{SIF_ADDR_S2,0x5b},{SIF_TX_DATA1,0x00},{SIF_TX_DATA2,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S1,0x5d},{SIF_ADDR_S2,0x5c},{SIF_TX_DATA1,0x00},{SIF_TX_DATA2,0x00},{SIF_CONTROL,0x01},
  {SIF_ADDR_S1,0x5d},{SIF_ADDR_S2,0x5d},{SIF_TX_DATA1,0x00},{SIF_TX_DATA2,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S1,0x5d},{SIF_ADDR_S2,0x5e},{SIF_TX_DATA1,0x00},{SIF_TX_DATA2,0x00},{SIF_CONTROL,0x01},
  {SIF_ADDR_S1,0x5d},{SIF_ADDR_S2,0x5f},{SIF_TX_DATA1,0xa3},{SIF_TX_DATA2,0x1d},{SIF_CONTROL,0x01},
	{SIF_ADDR_S1,0x5d},{SIF_ADDR_S2,0x60},{SIF_TX_DATA1,0x00},{SIF_TX_DATA2,0x00},{SIF_CONTROL,0x01},
  {SIF_ADDR_S1,0x5d},{SIF_ADDR_S2,0x61},{SIF_TX_DATA1,0x00},{SIF_TX_DATA2,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S1,0x5d},{SIF_ADDR_S2,0x62},{SIF_TX_DATA1,0x04},{SIF_TX_DATA2,0x11},{SIF_CONTROL,0x01},
  {SIF_ADDR_S1,0x5d},{SIF_ADDR_S2,0x63},{SIF_TX_DATA1,0x00},{SIF_TX_DATA2,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S1,0x5d},{SIF_ADDR_S2,0x64},{SIF_TX_DATA1,0x00},{SIF_TX_DATA2,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S1,0x5d},{SIF_ADDR_S2,0xf1},{SIF_TX_DATA1,0x00},{SIF_TX_DATA2,0x01},{SIF_CONTROL,0x01},
	{SIF_ADDR_S1,0x5d},{SIF_ADDR_S2,0x07},{SIF_TX_DATA1,0x30},{SIF_TX_DATA2,0x02},{SIF_CONTROL,0x01},

	{END_REG, 0x00}
};

//////////////////////////////////////////////////////////////////////
// Micron MT9V111
//////////////////////////////////////////////////////////////////////
struct topro_sregs topro_init_micron_MT9V111[] =
{
/*
	{SIF_TYPE,0x04},
	{SIF_CONTROL,0x00},
	{MCLK_SEL, 0x11},
	{CLK_CFG, 0xbb},
	{PCLK_CFG, 0x21},
	{ISP_MODE, 0x01},
	{VIDEO_TIMING, 0x11},

	{VIDEO_PTN, 0x20},
//	{GAGEN_CTL, 0x02},
	{GDIFF_THRLD, 0x80},
	{MCLK_CFG, 0x03},
*/
	{SIF_TYPE		, 0x04},
	{SIF_CONTROL		, 0x00},
	{MCLK_SEL		, 0x01},
	{CLK_CFG		, 0xbb},
	{PCLK_CFG		, 0x21},
	{ISP_MODE		, 0x01},
	{VIDEO_TIMING		, 0x11},
	{VIDEO_PTN		, 0x20},
	{GAGEN_CTL		, 0x02},
	{GDIFF_THRLD		, 0x80},
	{MCLK_CFG		, 0x23},
	{0xfc			, 0x80},
  
	{END_REG, 0x00}

};

struct topro_sregs topro_vga_micron_MT9V111[] =
{
/*
	{CFA_PIXEL_START_L,0x00},   {CFA_PIXEL_START_H,0x00},
	{CFA_LINE_START_L,0x00},   {CFA_LINE_START_H,0x00},
	{CFA_FRAME_WIDTH_L,0x7F},	{CFA_FRAME_WIDTH_H,0x02},
	{CFA_FRAME_HEIGHT_L,0xDF},	{CFA_FRAME_HEIGHT_H,0x01},
*/  
	{CFA_PIXEL_START_L	,0x00},
	{CFA_PIXEL_START_H	,0x00},
	{CFA_LINE_START_L	,0x00},
	{CFA_LINE_START_H	,0x00},
	{CFA_FRAME_WIDTH_L	,0x7F},
	{CFA_FRAME_WIDTH_H	,0x02},
	{CFA_FRAME_HEIGHT_L	,0xDF},
	{CFA_FRAME_HEIGHT_H	,0x01},
  
	{END_REG, 0x00}
};

struct topro_sregs topro_qvga_micron_MT9V111[] =
{
/*
	{CFA_PIXEL_START_L,0x00},   {CFA_PIXEL_START_H,0x00},
	{CFA_LINE_START_L,0x00},   {CFA_LINE_START_H,0x00},
	{CFA_FRAME_WIDTH_L,0x7F},	{CFA_FRAME_WIDTH_H,0x02},
	{CFA_FRAME_HEIGHT_L,0xDF},	{CFA_FRAME_HEIGHT_H,0x01},
*/
	{CFA_PIXEL_START_L	,0x00},
	{CFA_PIXEL_START_H	,0x00},
	{CFA_LINE_START_L	,0x00},
	{CFA_LINE_START_H	,0x00},
	{CFA_FRAME_WIDTH_L	,0x7F},
	{CFA_FRAME_WIDTH_H	,0x02},
	{CFA_FRAME_HEIGHT_L	,0xDF},
	{CFA_FRAME_HEIGHT_H	,0x01},
  
	{END_REG, 0x00}
};
struct topro_sregs topro_qcif_micron_MT9V111[] =   //TP6800_QCIF
{
	{CFA_PIXEL_START_L,0x00},   {CFA_PIXEL_START_H,0x00},
	{CFA_LINE_START_L,0x00},   {CFA_LINE_START_H,0x00},
	{CFA_FRAME_WIDTH_L,0x5F},	{CFA_FRAME_WIDTH_H,0x01},
	{CFA_FRAME_HEIGHT_L,0x1F},	{CFA_FRAME_HEIGHT_H,0x01},
	{END_REG, 0x00}
};
struct topro_sregs topro_i2c_micron_MT9V111[] =
{
//CELLVISION
	{SIF_ADDR_S1,0x5C},{SIF_ADDR_S2,0x01},{SIF_TX_DATA1,0x00},{SIF_TX_DATA2,0x04},{SIF_CONTROL,0x01},

	{SIF_ADDR_S1,0x5C},{SIF_ADDR_S2,0x0D},{SIF_TX_DATA1,0x00},{SIF_TX_DATA2,0x01},{SIF_CONTROL,0x01},
	{SIF_ADDR_S1,0x5C},{SIF_ADDR_S2,0x0D},{SIF_TX_DATA1,0x00},{SIF_TX_DATA2,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S1,0x5C},{SIF_ADDR_S2,0x35},{SIF_TX_DATA1,0x00},{SIF_TX_DATA2,0x2A},{SIF_CONTROL,0x01},
	{SIF_ADDR_S1,0x5C},{SIF_ADDR_S2,0x02},{SIF_TX_DATA1,0x00},{SIF_TX_DATA2,0x12},{SIF_CONTROL,0x01},
	{SIF_ADDR_S1,0x5C},{SIF_ADDR_S2,0x03},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0xE7},{SIF_CONTROL,0x01},
	{SIF_ADDR_S1,0x5C},{SIF_ADDR_S2,0x04},{SIF_TX_DATA1,0x02},{SIF_TX_DATA2,0x87},{SIF_CONTROL,0x01},
	{SIF_ADDR_S1,0x5C},{SIF_ADDR_S2,0x05},{SIF_TX_DATA1,0x00},{SIF_TX_DATA2,0x84},{SIF_CONTROL,0x01},
	{SIF_ADDR_S1,0x5C},{SIF_ADDR_S2,0x06},{SIF_TX_DATA1,0x00},{SIF_TX_DATA2,0x0A},{SIF_CONTROL,0x01},
	{SIF_ADDR_S1,0x5C},{SIF_ADDR_S2,0x07},{SIF_TX_DATA1,0x30},{SIF_TX_DATA2,0x02},{SIF_CONTROL,0x01},
	{SIF_ADDR_S1,0x5C},{SIF_ADDR_S2,0x08},{SIF_TX_DATA1,0x00},{SIF_TX_DATA2,0x06},{SIF_CONTROL,0x01},
	{SIF_ADDR_S1,0x5C},{SIF_ADDR_S2,0x09},{SIF_TX_DATA1,0x00},{SIF_TX_DATA2,0x7E},{SIF_CONTROL,0x01},
	{SIF_ADDR_S1,0x5C},{SIF_ADDR_S2,0x12},{SIF_TX_DATA1,0x00},{SIF_TX_DATA2,0xB0},{SIF_CONTROL,0x01},
	{SIF_ADDR_S1,0x5C},{SIF_ADDR_S2,0x13},{SIF_TX_DATA1,0x00},{SIF_TX_DATA2,0x7C},{SIF_CONTROL,0x01},
	{SIF_ADDR_S1,0x5C},{SIF_ADDR_S2,0x20},{SIF_TX_DATA1,0xD0},{SIF_TX_DATA2,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S1,0x5C},{SIF_ADDR_S2,0x21},{SIF_TX_DATA1,0xF4},{SIF_TX_DATA2,0x01},{SIF_CONTROL,0x01},
	{SIF_ADDR_S1,0x5C},{SIF_ADDR_S2,0x28},{SIF_TX_DATA1,0x00},{SIF_TX_DATA2,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S1,0x5C},{SIF_ADDR_S2,0x2B},{SIF_TX_DATA1,0x00},{SIF_TX_DATA2,0x2A},{SIF_CONTROL,0x01},
	{SIF_ADDR_S1,0x5C},{SIF_ADDR_S2,0x2C},{SIF_TX_DATA1,0x00},{SIF_TX_DATA2,0x40},{SIF_CONTROL,0x01},
	{SIF_ADDR_S1,0x5C},{SIF_ADDR_S2,0x2D},{SIF_TX_DATA1,0x00},{SIF_TX_DATA2,0x28},{SIF_CONTROL,0x01},
	{SIF_ADDR_S1,0x5C},{SIF_ADDR_S2,0x2E},{SIF_TX_DATA1,0x00},{SIF_TX_DATA2,0x2A},{SIF_CONTROL,0x01},
	{SIF_ADDR_S1,0x5C},{SIF_ADDR_S2,0x2F},{SIF_TX_DATA1,0xF7},{SIF_TX_DATA2,0xB0},{SIF_CONTROL,0x01},
	{SIF_ADDR_S1,0x5C},{SIF_ADDR_S2,0x30},{SIF_TX_DATA1,0x78},{SIF_TX_DATA2,0x05},{SIF_CONTROL,0x01},
	{SIF_ADDR_S1,0x5C},{SIF_ADDR_S2,0x31},{SIF_TX_DATA1,0x00},{SIF_TX_DATA2,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S1,0x5C},{SIF_ADDR_S2,0x33},{SIF_TX_DATA1,0x30},{SIF_TX_DATA2,0x0F},{SIF_CONTROL,0x01},
	{SIF_ADDR_S1,0x5C},{SIF_ADDR_S2,0x34},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S1,0x5C},{SIF_ADDR_S2,0x37},{SIF_TX_DATA1,0x00},{SIF_TX_DATA2,0x0A},{SIF_CONTROL,0x01},
	{SIF_ADDR_S1,0x5C},{SIF_ADDR_S2,0x3B},{SIF_TX_DATA1,0x00},{SIF_TX_DATA2,0x19},{SIF_CONTROL,0x01},
	{SIF_ADDR_S1,0x5C},{SIF_ADDR_S2,0x3C},{SIF_TX_DATA1,0x08},{SIF_TX_DATA2,0x20},{SIF_CONTROL,0x01},
	{SIF_ADDR_S1,0x5C},{SIF_ADDR_S2,0x3D},{SIF_TX_DATA1,0x06},{SIF_TX_DATA2,0x8F},{SIF_CONTROL,0x01},
	{SIF_ADDR_S1,0x5C},{SIF_ADDR_S2,0x3E},{SIF_TX_DATA1,0x08},{SIF_TX_DATA2,0x25},{SIF_CONTROL,0x01},
	{SIF_ADDR_S1,0x5C},{SIF_ADDR_S2,0x3F},{SIF_TX_DATA1,0x06},{SIF_TX_DATA2,0xA0},{SIF_CONTROL,0x01},
	{SIF_ADDR_S1,0x5C},{SIF_ADDR_S2,0x40},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0xE0},{SIF_CONTROL,0x01},
	{SIF_ADDR_S1,0x5C},{SIF_ADDR_S2,0x58},{SIF_TX_DATA1,0x00},{SIF_TX_DATA2,0xF8},{SIF_CONTROL,0x01},
	{SIF_ADDR_S1,0x5C},{SIF_ADDR_S2,0x59},{SIF_TX_DATA1,0x07},{SIF_TX_DATA2,0x43},{SIF_CONTROL,0x01},
	{SIF_ADDR_S1,0x5C},{SIF_ADDR_S2,0x5A},{SIF_TX_DATA1,0x04},{SIF_TX_DATA2,0x27},{SIF_CONTROL,0x01},
	{SIF_ADDR_S1,0x5C},{SIF_ADDR_S2,0x60},{SIF_TX_DATA1,0x00},{SIF_TX_DATA2,0x28},{SIF_CONTROL,0x01},
	{SIF_ADDR_S1,0x5C},{SIF_ADDR_S2,0x61},{SIF_TX_DATA1,0x00},{SIF_TX_DATA2,0x27},{SIF_CONTROL,0x01},
	{SIF_ADDR_S1,0x5C},{SIF_ADDR_S2,0x63},{SIF_TX_DATA1,0x00},{SIF_TX_DATA2,0x27},{SIF_CONTROL,0x01},
	{SIF_ADDR_S1,0x5C},{SIF_ADDR_S2,0x64},{SIF_TX_DATA1,0x00},{SIF_TX_DATA2,0x28},{SIF_CONTROL,0x01},
	{SIF_ADDR_S1,0x5C},{SIF_ADDR_S2,0xF9},{SIF_TX_DATA1,0x00},{SIF_TX_DATA2,0x2C},{SIF_CONTROL,0x01},
	{SIF_ADDR_S1,0x5C},{SIF_ADDR_S2,0x01},{SIF_TX_DATA1,0x00},{SIF_TX_DATA2,0x01},{SIF_CONTROL,0x01},
	{SIF_ADDR_S1,0x5C},{SIF_ADDR_S2,0x07},{SIF_TX_DATA1,0x00},{SIF_TX_DATA2,0x01},{SIF_CONTROL,0x01},
	{SIF_ADDR_S1,0x5C},{SIF_ADDR_S2,0x07},{SIF_TX_DATA1,0x00},{SIF_TX_DATA2,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S1,0x5C},{SIF_ADDR_S2,0x06},{SIF_TX_DATA1,0x70},{SIF_TX_DATA2,0x82},{SIF_CONTROL,0x01},
	{SIF_ADDR_S1,0x5C},{SIF_ADDR_S2,0x08},{SIF_TX_DATA1,0xC8},{SIF_TX_DATA2,0x03},{SIF_CONTROL,0x01},
	{SIF_ADDR_S1,0x5C},{SIF_ADDR_S2,0x33},{SIF_TX_DATA1,0x14},{SIF_TX_DATA2,0x11},{SIF_CONTROL,0x01},




	{SIF_ADDR_S1,0x5C},{SIF_ADDR_S2,0x37},{SIF_TX_DATA1,0x00},{SIF_TX_DATA2,0x80},{SIF_CONTROL,0x01},
	{SIF_ADDR_S1,0x5C},{SIF_ADDR_S2,0x38},{SIF_TX_DATA1,0x08},{SIF_TX_DATA2,0x78},{SIF_CONTROL,0x01},
	{SIF_ADDR_S1,0x5C},{SIF_ADDR_S2,0x39},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x22},{SIF_CONTROL,0x01},
	{SIF_ADDR_S1,0x5C},{SIF_ADDR_S2,0x3B},{SIF_TX_DATA1,0x04},{SIF_TX_DATA2,0x2C},{SIF_CONTROL,0x01},
	{SIF_ADDR_S1,0x5C},{SIF_ADDR_S2,0x3C},{SIF_TX_DATA1,0x04},{SIF_TX_DATA2,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S1,0x5C},{SIF_ADDR_S2,0x3D},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0xDA},{SIF_CONTROL,0x01},
	{SIF_ADDR_S1,0x5C},{SIF_ADDR_S2,0x3E},{SIF_TX_DATA1,0x0F},{SIF_TX_DATA2,0xFF},{SIF_CONTROL,0x01},
	{SIF_ADDR_S1,0x5C},{SIF_ADDR_S2,0x4E},{SIF_TX_DATA1,0x00},{SIF_TX_DATA2,0x10},{SIF_CONTROL,0x01},
	{SIF_ADDR_S1,0x5C},{SIF_ADDR_S2,0x59},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0xF8},{SIF_CONTROL,0x01},
	{SIF_ADDR_S1,0x5C},{SIF_ADDR_S2,0x5A},{SIF_TX_DATA1,0x02},{SIF_TX_DATA2,0x5D},{SIF_CONTROL,0x01},
	{SIF_ADDR_S1,0x5C},{SIF_ADDR_S2,0x5C},{SIF_TX_DATA1,0x20},{SIF_TX_DATA2,0x1E},{SIF_CONTROL,0x01},
	{SIF_ADDR_S1,0x5C},{SIF_ADDR_S2,0x5D},{SIF_TX_DATA1,0x27},{SIF_TX_DATA2,0x25},{SIF_CONTROL,0x01},
	{SIF_ADDR_S1,0x5C},{SIF_ADDR_S2,0x64},{SIF_TX_DATA1,0x11},{SIF_TX_DATA2,0x7D},{SIF_CONTROL,0x01},
	{SIF_ADDR_S1,0x5C},{SIF_ADDR_S2,0x9C},{SIF_TX_DATA1,0x10},{SIF_TX_DATA2,0x08},{SIF_CONTROL,0x01},
//TOPRO
/*
{SIF_ADDR_S1,0x5C},{SIF_ADDR_S2,0x01},{SIF_TX_DATA1,0x00},{SIF_TX_DATA2,0x04},{SIF_CONTROL,0x01},
{SIF_ADDR_S1,0x5C},{SIF_ADDR_S2,0x0D},{SIF_TX_DATA1,0x00},{SIF_TX_DATA2,0x01},{SIF_CONTROL,0x01},
{SIF_ADDR_S1,0x5C},{SIF_ADDR_S2,0x0D},{SIF_TX_DATA1,0x00},{SIF_TX_DATA2,0x00},{SIF_CONTROL,0x01},
{SIF_ADDR_S1,0x5C},{SIF_ADDR_S2,0x01},{SIF_TX_DATA1,0x00},{SIF_TX_DATA2,0x01},{SIF_CONTROL,0x01},
{SIF_ADDR_S1,0x5C},{SIF_ADDR_S2,0x07},{SIF_TX_DATA1,0x00},{SIF_TX_DATA2,0x01},{SIF_CONTROL,0x01},
{SIF_ADDR_S1,0x5C},{SIF_ADDR_S2,0x07},{SIF_TX_DATA1,0x00},{SIF_TX_DATA2,0x00},{SIF_CONTROL,0x01},
{SIF_ADDR_S1,0x5C},{SIF_ADDR_S2,0x01},{SIF_TX_DATA1,0x00},{SIF_TX_DATA2,0x04},{SIF_CONTROL,0x01},
{SIF_ADDR_S1,0x5C},{SIF_ADDR_S2,0x20},{SIF_TX_DATA1,0xC0},{SIF_TX_DATA2,0x00},{SIF_CONTROL,0x01},
{SIF_ADDR_S1,0x5C},{SIF_ADDR_S2,0x05},{SIF_TX_DATA1,0x00},{SIF_TX_DATA2,0x20},{SIF_CONTROL,0x01},
{SIF_ADDR_S1,0x5C},{SIF_ADDR_S2,0x21},{SIF_TX_DATA1,0xE4},{SIF_TX_DATA2,0x01},{SIF_CONTROL,0x01},
{SIF_ADDR_S1,0x5C},{SIF_ADDR_S2,0x07},{SIF_TX_DATA1,0x30},{SIF_TX_DATA2,0x02},{SIF_CONTROL,0x01},
{SIF_ADDR_S1,0x5C},{SIF_ADDR_S2,0x2F},{SIF_TX_DATA1,0xF7},{SIF_TX_DATA2,0xB0},{SIF_CONTROL,0x01},
{SIF_ADDR_S1,0x5C},{SIF_ADDR_S2,0x01},{SIF_TX_DATA1,0x00},{SIF_TX_DATA2,0x04},{SIF_CONTROL,0x01},
{SIF_ADDR_S1,0x5C},{SIF_ADDR_S2,0x08},{SIF_TX_DATA1,0x00},{SIF_TX_DATA2,0x08},{SIF_CONTROL,0x01},
{SIF_ADDR_S1,0x5C},{SIF_ADDR_S2,0x02},{SIF_TX_DATA1,0x00},{SIF_TX_DATA2,0x14},{SIF_CONTROL,0x01},
{SIF_ADDR_S1,0x5C},{SIF_ADDR_S2,0x03},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0xE7},{SIF_CONTROL,0x01},
{SIF_ADDR_S1,0x5C},{SIF_ADDR_S2,0x04},{SIF_TX_DATA1,0x02},{SIF_TX_DATA2,0x87},{SIF_CONTROL,0x01},
{SIF_ADDR_S1,0x5C},{SIF_ADDR_S2,0x06},{SIF_TX_DATA1,0x00},{SIF_TX_DATA2,0x0C},{SIF_CONTROL,0x01},
{SIF_ADDR_S1,0x5C},{SIF_ADDR_S2,0x09},{SIF_TX_DATA1,0x00},{SIF_TX_DATA2,0xCA},{SIF_CONTROL,0x01},
{SIF_ADDR_S1,0x5C},{SIF_ADDR_S2,0x0A},{SIF_TX_DATA1,0x00},{SIF_TX_DATA2,0x00},{SIF_CONTROL,0x01},
{SIF_ADDR_S1,0x5C},{SIF_ADDR_S2,0x0C},{SIF_TX_DATA1,0x00},{SIF_TX_DATA2,0x00},{SIF_CONTROL,0x01},
{SIF_ADDR_S1,0x5C},{SIF_ADDR_S2,0xF1},{SIF_TX_DATA1,0x00},{SIF_TX_DATA2,0x01},{SIF_CONTROL,0x01},
{SIF_ADDR_S1,0x5C},{SIF_ADDR_S2,0x01},{SIF_TX_DATA1,0x00},{SIF_TX_DATA2,0x01},{SIF_CONTROL,0x01},
{SIF_ADDR_S1,0x5C},{SIF_ADDR_S2,0x33},{SIF_TX_DATA1,0x14},{SIF_TX_DATA2,0x11},{SIF_CONTROL,0x01},
{SIF_ADDR_S1,0x5C},{SIF_ADDR_S2,0x06},{SIF_TX_DATA1,0x70},{SIF_TX_DATA2,0x8E},{SIF_CONTROL,0x01},
{SIF_ADDR_S1,0x5C},{SIF_ADDR_S2,0x08},{SIF_TX_DATA1,0xC9},{SIF_TX_DATA2,0x00},{SIF_CONTROL,0x01},
{SIF_ADDR_S1,0x5C},{SIF_ADDR_S2,0x05},{SIF_TX_DATA1,0x00},{SIF_TX_DATA2,0x0c},{SIF_CONTROL,0x01},
*/

{END_REG, 0x00}
};

///////////////////////////////////////////
// SHARPCCD
//////////////////////////////////////////
struct topro_sregs Sharp_CCD[] =
    {
	{SIF_TYPE,0x03},
	{SIF_CONTROL,0x00},
	{MCLK_SEL, 0x11},
	{CLK_CFG, 0x3a},
	{PCLK_CFG, 0x25},
	{ISP_MODE, 0x00},
	{VIDEO_TIMING, 0x11},
	{VIDEO_PTN, 0x00},
//	{GAGEN_CTL, 0x01},
	{GDIFF_THRLD, 0x80},
	{MCLK_CFG, 0x03},
  {END_REG,0x00}
    };

struct topro_sregs Sharp_CCD_VGA[] =
    {
	{CFA_PIXEL_START_L,0x42},   {CFA_PIXEL_START_H,0x00},

	{CFA_LINE_START_L,0x21},   {CFA_LINE_START_H,0x00},
	{CFA_FRAME_WIDTH_L,0x7F},	{CFA_FRAME_WIDTH_H,0x02},
	{CFA_FRAME_HEIGHT_L,0xDF},	{CFA_FRAME_HEIGHT_H,0x01},
  {END_REG,0x00}
    };

struct topro_sregs Sharp_CCD_QVGA[] =
    {
	{CFA_PIXEL_START_L,0x42},   {CFA_PIXEL_START_H,0x00},
	{CFA_LINE_START_L,0x21},   {CFA_LINE_START_H,0x00},
	{CFA_FRAME_WIDTH_L,0x7F},	{CFA_FRAME_WIDTH_H,0x02},
	{CFA_FRAME_HEIGHT_L,0xDF},	{CFA_FRAME_HEIGHT_H,0x01},
 {END_REG,0x00}
    };
struct topro_sregs Sharp_CCD_QCIF[] =
    {
	{CFA_PIXEL_START_L,0x42},   {CFA_PIXEL_START_H,0x00},
	{CFA_LINE_START_L,0x21},   {CFA_LINE_START_H,0x00},
	{CFA_FRAME_WIDTH_L,0x5F},	{CFA_FRAME_WIDTH_H,0x01},
	{CFA_FRAME_HEIGHT_L,0x1F},	{CFA_FRAME_HEIGHT_H,0x01},
 {END_REG,0x00}
    };

struct topro_sregs Sharp_CCD_I2C[] =
{
// Sharp CCD
{SIF_ADDR_S2,0x10},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
{SIF_ADDR_S2,0x00},{SIF_TX_DATA1,0x04},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
{SIF_ADDR_S2,0x7F},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
{SIF_ADDR_S2,0xD0},{SIF_TX_DATA1,0x81},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
{SIF_ADDR_S2,0xD1},{SIF_TX_DATA1,0x00},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
{SIF_ADDR_S2,0xD2},{SIF_TX_DATA1,0x12},{SIF_TX_DATA2,0x30},{SIF_TX_DATA3,0x01},{SIF_CONTROL,0x01},
{SIF_ADDR_S2,0xD3},{SIF_TX_DATA1,0xFF},{SIF_TX_DATA2,0x0F},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
{SIF_ADDR_S2,0xD4},{SIF_TX_DATA1,0x0D},{SIF_TX_DATA2,0xC2},{SIF_TX_DATA3,0x30},{SIF_CONTROL,0x01},
{SIF_ADDR_S2,0xD5},{SIF_TX_DATA1,0x9A},{SIF_TX_DATA2,0x03},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
{SIF_ADDR_S2,0xD6},{SIF_TX_DATA1,0x12},{SIF_TX_DATA2,0xF0},{SIF_TX_DATA3,0xFF},{SIF_CONTROL,0x01},
{SIF_ADDR_S2,0xD7},{SIF_TX_DATA1,0x00},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
{SIF_ADDR_S2,0x80},{SIF_TX_DATA1,0x0C},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},

{SIF_ADDR_S2,0x81},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x10},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
{SIF_ADDR_S2,0x82},{SIF_TX_DATA1,0x00},{SIF_TX_DATA2,0xC0},{SIF_TX_DATA3,0x30},{SIF_CONTROL,0x01},
{SIF_ADDR_S2,0x83},{SIF_TX_DATA1,0xFF},{SIF_TX_DATA2,0xFF},{SIF_TX_DATA3,0xFF},{SIF_CONTROL,0x01},
{SIF_ADDR_S2,0x84},{SIF_TX_DATA1,0x23},{SIF_TX_DATA2,0xB0},{SIF_TX_DATA3,0x06},{SIF_CONTROL,0x01},
{SIF_ADDR_S2,0x85},{SIF_TX_DATA1,0xFF},{SIF_TX_DATA2,0xFF},{SIF_TX_DATA3,0xFF},{SIF_CONTROL,0x01},

{SIF_ADDR_S2,0x86},{SIF_TX_DATA1,0xFF},{SIF_TX_DATA2,0xFF},{SIF_TX_DATA3,0xFF},{SIF_CONTROL,0x01},
{SIF_ADDR_S2,0x87},{SIF_TX_DATA1,0x0A},{SIF_TX_DATA2,0xE0},{SIF_TX_DATA3,0x01},{SIF_CONTROL,0x01},
{SIF_ADDR_S2,0x88},{SIF_TX_DATA1,0x0C},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
{SIF_ADDR_S2,0x89},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x10},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
{SIF_ADDR_S2,0x8A},{SIF_TX_DATA1,0x00},{SIF_TX_DATA2,0xC0},{SIF_TX_DATA3,0x30},{SIF_CONTROL,0x01},
{SIF_ADDR_S2,0x8B},{SIF_TX_DATA1,0xFF},{SIF_TX_DATA2,0xFF},{SIF_TX_DATA3,0xFF},{SIF_CONTROL,0x01},
{SIF_ADDR_S2,0x8C},{SIF_TX_DATA1,0x23},{SIF_TX_DATA2,0xB0},{SIF_TX_DATA3,0x06},{SIF_CONTROL,0x01},
{SIF_ADDR_S2,0x8D},{SIF_TX_DATA1,0xFF},{SIF_TX_DATA2,0xFF},{SIF_TX_DATA3,0xFF},{SIF_CONTROL,0x01},
{SIF_ADDR_S2,0x8E},{SIF_TX_DATA1,0xFF},{SIF_TX_DATA2,0xFF},{SIF_TX_DATA3,0xFF},{SIF_CONTROL,0x01},
{SIF_ADDR_S2,0x8F},{SIF_TX_DATA1,0xFF},{SIF_TX_DATA2,0xFF},{SIF_TX_DATA3,0xFF},{SIF_CONTROL,0x01},
{SIF_ADDR_S2,0x90},{SIF_TX_DATA1,0x1C},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
{SIF_ADDR_S2,0x91},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x10},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
{SIF_ADDR_S2,0x92},{SIF_TX_DATA1,0x00},{SIF_TX_DATA2,0xC0},{SIF_TX_DATA3,0x30},{SIF_CONTROL,0x01},
{SIF_ADDR_S2,0x93},{SIF_TX_DATA1,0xFF},{SIF_TX_DATA2,0xFF},{SIF_TX_DATA3,0xFF},{SIF_CONTROL,0x01},
{SIF_ADDR_S2,0x94},{SIF_TX_DATA1,0x23},{SIF_TX_DATA2,0xB0},{SIF_TX_DATA3,0x06},{SIF_CONTROL,0x01},
{SIF_ADDR_S2,0x95},{SIF_TX_DATA1,0xFF},{SIF_TX_DATA2,0xFF},{SIF_TX_DATA3,0xFF},{SIF_CONTROL,0x01},
{SIF_ADDR_S2,0x96},{SIF_TX_DATA1,0xFF},{SIF_TX_DATA2,0xFF},{SIF_TX_DATA3,0xFF},{SIF_CONTROL,0x01},
{SIF_ADDR_S2,0x97},{SIF_TX_DATA1,0xFF},{SIF_TX_DATA2,0xFF},{SIF_TX_DATA3,0xFF},{SIF_CONTROL,0x01},

{SIF_ADDR_S2,0x00},{SIF_TX_DATA1,0x3D},{SIF_TX_DATA2,0x40},{SIF_TX_DATA3,0x06},{SIF_CONTROL,0x01},
{SIF_ADDR_S2,0x01},{SIF_TX_DATA1,0x23},{SIF_TX_DATA2,0x70},{SIF_TX_DATA3,0x04},{SIF_CONTROL,0x01},
{SIF_ADDR_S2,0x02},{SIF_TX_DATA1,0xFF},{SIF_TX_DATA2,0xFF},{SIF_TX_DATA3,0x02},{SIF_CONTROL,0x01},
{SIF_ADDR_S2,0x03},{SIF_TX_DATA1,0x53},{SIF_TX_DATA2,0xF0},{SIF_TX_DATA3,0xFF},{SIF_CONTROL,0x01},
{SIF_ADDR_S2,0x04},{SIF_TX_DATA1,0x3B},{SIF_TX_DATA2,0xF0},{SIF_TX_DATA3,0x05},{SIF_CONTROL,0x01},
{SIF_ADDR_S2,0x05},{SIF_TX_DATA1,0xFF},{SIF_TX_DATA2,0x3F},{SIF_TX_DATA3,0x02},{SIF_CONTROL,0x01},
{SIF_ADDR_S2,0x06},{SIF_TX_DATA1,0x47},{SIF_TX_DATA2,0xF0},{SIF_TX_DATA3,0xFF},{SIF_CONTROL,0x01},
{SIF_ADDR_S2,0x07},{SIF_TX_DATA1,0xFF},{SIF_TX_DATA2,0xFF},{SIF_TX_DATA3,0xFF},{SIF_CONTROL,0x01},

{SIF_ADDR_S2,0x08},{SIF_TX_DATA1,0xFF},{SIF_TX_DATA2,0xFF},{SIF_TX_DATA3,0xFF},{SIF_CONTROL,0x01},
{SIF_ADDR_S2,0x09},{SIF_TX_DATA1,0xFF},{SIF_TX_DATA2,0xFF},{SIF_TX_DATA3,0xFF},{SIF_CONTROL,0x01},
{SIF_ADDR_S2,0x0A},{SIF_TX_DATA1,0x00},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
{SIF_ADDR_S2,0x0B},{SIF_TX_DATA1,0x00},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
{SIF_ADDR_S2,0x0C},{SIF_TX_DATA1,0x3D},{SIF_TX_DATA2,0x80},{SIF_TX_DATA3,0x25},{SIF_CONTROL,0x01},
{SIF_ADDR_S2,0x0D},{SIF_TX_DATA1,0x23},{SIF_TX_DATA2,0x70},{SIF_TX_DATA3,0x04},{SIF_CONTROL,0x01},
{SIF_ADDR_S2,0x0E},{SIF_TX_DATA1,0xFF},{SIF_TX_DATA2,0xFF},{SIF_TX_DATA3,0x02},{SIF_CONTROL,0x01},
{SIF_ADDR_S2,0x0F},{SIF_TX_DATA1,0x53},{SIF_TX_DATA2,0xF0},{SIF_TX_DATA3,0xFF},{SIF_CONTROL,0x01},
{SIF_ADDR_S2,0x10},{SIF_TX_DATA1,0x3B},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x24},{SIF_CONTROL,0x01},
{SIF_ADDR_S2,0x11},{SIF_TX_DATA1,0xFF},{SIF_TX_DATA2,0x3F},{SIF_TX_DATA3,0xF2},{SIF_CONTROL,0x01},
{SIF_ADDR_S2,0x12},{SIF_TX_DATA1,0x47},{SIF_TX_DATA2,0xF0},{SIF_TX_DATA3,0xFF},{SIF_CONTROL,0x01},
{SIF_ADDR_S2,0x13},{SIF_TX_DATA1,0xFF},{SIF_TX_DATA2,0xFF},{SIF_TX_DATA3,0xFF},{SIF_CONTROL,0x01},
{SIF_ADDR_S2,0x14},{SIF_TX_DATA1,0xFF},{SIF_TX_DATA2,0xFF},{SIF_TX_DATA3,0xFF},{SIF_CONTROL,0x01},
{SIF_ADDR_S2,0x15},{SIF_TX_DATA1,0xFF},{SIF_TX_DATA2,0xFF},{SIF_TX_DATA3,0xFF},{SIF_CONTROL,0x01},
{SIF_ADDR_S2,0x16},{SIF_TX_DATA1,0x00},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
{SIF_ADDR_S2,0x17},{SIF_TX_DATA1,0x00},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
{SIF_ADDR_S2,0x7F},{SIF_TX_DATA1,0x00},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
{SIF_ADDR_S2,0x40},{SIF_TX_DATA1,0xFF},{SIF_TX_DATA2,0xFF},{SIF_TX_DATA3,0xFF},{SIF_CONTROL,0x01},
{SIF_ADDR_S2,0x41},{SIF_TX_DATA1,0xFF},{SIF_TX_DATA2,0xFF},{SIF_TX_DATA3,0xFF},{SIF_CONTROL,0x01},
{SIF_ADDR_S2,0x42},{SIF_TX_DATA1,0xFF},{SIF_TX_DATA2,0xFF},{SIF_TX_DATA3,0xFF},{SIF_CONTROL,0x01},
{SIF_ADDR_S2,0x50},{SIF_TX_DATA1,0x0F},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},

{SIF_ADDR_S2,0x51},{SIF_TX_DATA1,0xE9},{SIF_TX_DATA2,0x71},{SIF_TX_DATA3,0x22},{SIF_CONTROL,0x01},
{SIF_ADDR_S2,0x52},{SIF_TX_DATA1,0xFF},{SIF_TX_DATA2,0xFF},{SIF_TX_DATA3,0xFF},{SIF_CONTROL,0x01},
{SIF_ADDR_S2,0x53},{SIF_TX_DATA1,0xFF},{SIF_TX_DATA2,0xFF},{SIF_TX_DATA3,0xFF},{SIF_CONTROL,0x01},
{SIF_ADDR_S2,0x54},{SIF_TX_DATA1,0xFF},{SIF_TX_DATA2,0xFF},{SIF_TX_DATA3,0xFF},{SIF_CONTROL,0x01},
{SIF_ADDR_S2,0x65},{SIF_TX_DATA1,0x48},{SIF_TX_DATA2,0xF0},{SIF_TX_DATA3,0x05},{SIF_CONTROL,0x01},
{SIF_ADDR_S2,0x66},{SIF_TX_DATA1,0xFF},{SIF_TX_DATA2,0xFF},{SIF_TX_DATA3,0xFF},{SIF_CONTROL,0x01},
{SIF_ADDR_S2,0x15},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
{SIF_ADDR_S2,0x14},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
{SIF_ADDR_S2,0x20},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
{SIF_ADDR_S2,0x22},{SIF_TX_DATA1,0x64},{SIF_TX_DATA2,0x20},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
{SIF_ADDR_S2,0x1B},{SIF_TX_DATA1,0x00},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x20},{SIF_CONTROL,0x01},
{SIF_ADDR_S2,0x61},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
{SIF_ADDR_S2,0x62},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
{SIF_ADDR_S2,0x63},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0xE0},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
{SIF_ADDR_S2,0x64},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
{SIF_ADDR_S2,0x67},{SIF_TX_DATA1,0x02},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
{SIF_ADDR_S2,0x68},{SIF_TX_DATA1,0x07},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
{SIF_ADDR_S2,0x69},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
{SIF_ADDR_S2,0x6B},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
{SIF_ADDR_S2,0x6C},{SIF_TX_DATA1,0x00},{SIF_TX_DATA2,0x40},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
{SIF_ADDR_S2,0x6F},{SIF_TX_DATA1,0x00},{SIF_TX_DATA2,0x70},{SIF_TX_DATA3,0x01},{SIF_CONTROL,0x01},
{SIF_ADDR_S2,0x71},{SIF_TX_DATA1,0x00},{SIF_TX_DATA2,0x90},{SIF_TX_DATA3,0x02},{SIF_CONTROL,0x01},
{SIF_ADDR_S2,0x36},{SIF_TX_DATA1,0x21},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
{SIF_ADDR_S2,0x11},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
{SIF_ADDR_S2,0x13},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
{SIF_ADDR_S2,0x01},{SIF_TX_DATA1,0x80},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
{END_REG,0x00}
};


///////////////////////////////////////////
// SONYCCD
//////////////////////////////////////////
struct topro_sregs Sony_CCD[] =
    {
	{SIF_TYPE,0x03},
	{SIF_CONTROL,0x00},
	{MCLK_SEL, 0x11},
	{CLK_CFG, 0x3a},
	{PCLK_CFG, 0x25},
	{ISP_MODE, 0x00},
	{VIDEO_TIMING, 0x11},
	{VIDEO_PTN, 0x00},
//	{GAGEN_CTL, 0x01},
	{GDIFF_THRLD, 0x80},
	{MCLK_CFG, 0x03},
  {END_REG,0x00}
    };

struct topro_sregs Sony_CCD_VGA[] =
    {
	{CFA_PIXEL_START_L,0x42},   {CFA_PIXEL_START_H,0x00},
	{CFA_LINE_START_L,0x21},   {CFA_LINE_START_H,0x00},
	{CFA_FRAME_WIDTH_L,0x7F},	{CFA_FRAME_WIDTH_H,0x02},
	{CFA_FRAME_HEIGHT_L,0xDF},	{CFA_FRAME_HEIGHT_H,0x01},
  {END_REG,0x00}
    };

struct topro_sregs Sony_CCD_QVGA[] =
    {
	{CFA_PIXEL_START_L,0x42},   {CFA_PIXEL_START_H,0x00},
	{CFA_LINE_START_L,0x21},   {CFA_LINE_START_H,0x00},
	{CFA_FRAME_WIDTH_L,0x7F},	{CFA_FRAME_WIDTH_H,0x02},
	{CFA_FRAME_HEIGHT_L,0xDF},	{CFA_FRAME_HEIGHT_H,0x01},
 {END_REG,0x00}
    };
struct topro_sregs Sony_CCD_QCIF[] =
    {
	{CFA_PIXEL_START_L,0x42},   {CFA_PIXEL_START_H,0x00},
	{CFA_LINE_START_L,0x21},   {CFA_LINE_START_H,0x00},
	{CFA_FRAME_WIDTH_L,0x5F},	{CFA_FRAME_WIDTH_H,0x01},
	{CFA_FRAME_HEIGHT_L,0x1F},	{CFA_FRAME_HEIGHT_H,0x01},
 {END_REG,0x00}
    };

struct topro_sregs Sony_CCD_I2C[] =
{
// SONY CCD
{SIF_ADDR_S2,0x10},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
{SIF_ADDR_S2,0x00},{SIF_TX_DATA1,0x04},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
{SIF_ADDR_S2,0x7F},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
{SIF_ADDR_S2,0xD0},{SIF_TX_DATA1,0x81},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
{SIF_ADDR_S2,0xD1},{SIF_TX_DATA1,0x00},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
{SIF_ADDR_S2,0xD2},{SIF_TX_DATA1,0x09},{SIF_TX_DATA2,0xA0},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
{SIF_ADDR_S2,0xD3},{SIF_TX_DATA1,0xFF},{SIF_TX_DATA2,0x0F},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
{SIF_ADDR_S2,0xD4},{SIF_TX_DATA1,0x0D},{SIF_TX_DATA2,0xC2},{SIF_TX_DATA3,0x30},{SIF_CONTROL,0x01},
{SIF_ADDR_S2,0xD5},{SIF_TX_DATA1,0x9A},{SIF_TX_DATA2,0x03},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
{SIF_ADDR_S2,0xD6},{SIF_TX_DATA1,0x09},{SIF_TX_DATA2,0xF0},{SIF_TX_DATA3,0xFF},{SIF_CONTROL,0x01},
{SIF_ADDR_S2,0xD7},{SIF_TX_DATA1,0x00},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
{SIF_ADDR_S2,0x80},{SIF_TX_DATA1,0x0C},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
{SIF_ADDR_S2,0x81},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x10},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
{SIF_ADDR_S2,0x82},{SIF_TX_DATA1,0x00},{SIF_TX_DATA2,0xC0},{SIF_TX_DATA3,0x30},{SIF_CONTROL,0x01},
{SIF_ADDR_S2,0x83},{SIF_TX_DATA1,0xFF},{SIF_TX_DATA2,0xFF},{SIF_TX_DATA3,0xFF},{SIF_CONTROL,0x01},
{SIF_ADDR_S2,0x84},{SIF_TX_DATA1,0x2B},{SIF_TX_DATA2,0x40},{SIF_TX_DATA3,0x07},{SIF_CONTROL,0x01},
{SIF_ADDR_S2,0x85},{SIF_TX_DATA1,0xFF},{SIF_TX_DATA2,0xFF},{SIF_TX_DATA3,0xFF},{SIF_CONTROL,0x01},
{SIF_ADDR_S2,0x86},{SIF_TX_DATA1,0xFF},{SIF_TX_DATA2,0xFF},{SIF_TX_DATA3,0xFF},{SIF_CONTROL,0x01},
{SIF_ADDR_S2,0x87},{SIF_TX_DATA1,0x17},{SIF_TX_DATA2,0x60},{SIF_TX_DATA3,0x02},{SIF_CONTROL,0x01},
{SIF_ADDR_S2,0x88},{SIF_TX_DATA1,0x0C},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
{SIF_ADDR_S2,0x89},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x10},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
{SIF_ADDR_S2,0x8A},{SIF_TX_DATA1,0x00},{SIF_TX_DATA2,0xC0},{SIF_TX_DATA3,0x30},{SIF_CONTROL,0x01},
{SIF_ADDR_S2,0x8B},{SIF_TX_DATA1,0xFF},{SIF_TX_DATA2,0xFF},{SIF_TX_DATA3,0xFF},{SIF_CONTROL,0x01},
{SIF_ADDR_S2,0x8C},{SIF_TX_DATA1,0x2B},{SIF_TX_DATA2,0x40},{SIF_TX_DATA3,0x07},{SIF_CONTROL,0x01},
{SIF_ADDR_S2,0x8D},{SIF_TX_DATA1,0xFF},{SIF_TX_DATA2,0xFF},{SIF_TX_DATA3,0xFF},{SIF_CONTROL,0x01},
{SIF_ADDR_S2,0x8E},{SIF_TX_DATA1,0xFF},{SIF_TX_DATA2,0xFF},{SIF_TX_DATA3,0xFF},{SIF_CONTROL,0x01},
{SIF_ADDR_S2,0x8F},{SIF_TX_DATA1,0xFF},{SIF_TX_DATA2,0xFF},{SIF_TX_DATA3,0xFF},{SIF_CONTROL,0x01},
{SIF_ADDR_S2,0x90},{SIF_TX_DATA1,0x8C},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
{SIF_ADDR_S2,0x91},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x10},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
{SIF_ADDR_S2,0x92},{SIF_TX_DATA1,0x00},{SIF_TX_DATA2,0xC0},{SIF_TX_DATA3,0x30},{SIF_CONTROL,0x01},

{SIF_ADDR_S2,0x93},{SIF_TX_DATA1,0xFF},{SIF_TX_DATA2,0xFF},{SIF_TX_DATA3,0xFF},{SIF_CONTROL,0x01},
{SIF_ADDR_S2,0x94},{SIF_TX_DATA1,0x2B},{SIF_TX_DATA2,0x40},{SIF_TX_DATA3,0x07},{SIF_CONTROL,0x01},
{SIF_ADDR_S2,0x95},{SIF_TX_DATA1,0xFF},{SIF_TX_DATA2,0xFF},{SIF_TX_DATA3,0xFF},{SIF_CONTROL,0x01},
{SIF_ADDR_S2,0x96},{SIF_TX_DATA1,0xFF},{SIF_TX_DATA2,0xFF},{SIF_TX_DATA3,0xFF},{SIF_CONTROL,0x01},
{SIF_ADDR_S2,0x97},{SIF_TX_DATA1,0xFF},{SIF_TX_DATA2,0xFF},{SIF_TX_DATA3,0xFF},{SIF_CONTROL,0x01},
{SIF_ADDR_S2,0x00},{SIF_TX_DATA1,0x3B},{SIF_TX_DATA2,0x80},{SIF_TX_DATA3,0x07},{SIF_CONTROL,0x01},
{SIF_ADDR_S2,0x01},{SIF_TX_DATA1,0x44},{SIF_TX_DATA2,0x80},{SIF_TX_DATA3,0x06},{SIF_CONTROL,0x01},
{SIF_ADDR_S2,0x02},{SIF_TX_DATA1,0xFF},{SIF_TX_DATA2,0xCF},{SIF_TX_DATA3,0x02},{SIF_CONTROL,0x01},
{SIF_ADDR_S2,0x03},{SIF_TX_DATA1,0x50},{SIF_TX_DATA2,0xF0},{SIF_TX_DATA3,0xFF},{SIF_CONTROL,0x01},
{SIF_ADDR_S2,0x04},{SIF_TX_DATA1,0x38},{SIF_TX_DATA2,0xC0},{SIF_TX_DATA3,0x05},{SIF_CONTROL,0x01},
{SIF_ADDR_S2,0x05},{SIF_TX_DATA1,0xFF},{SIF_TX_DATA2,0xCF},{SIF_TX_DATA3,0x02},{SIF_CONTROL,0x01},
{SIF_ADDR_S2,0x06},{SIF_TX_DATA1,0x50},{SIF_TX_DATA2,0xF0},{SIF_TX_DATA3,0xFF},{SIF_CONTROL,0x01},
{SIF_ADDR_S2,0x07},{SIF_TX_DATA1,0xFF},{SIF_TX_DATA2,0xFF},{SIF_TX_DATA3,0xFF},{SIF_CONTROL,0x01},

{SIF_ADDR_S2,0x08},{SIF_TX_DATA1,0xFF},{SIF_TX_DATA2,0xFF},{SIF_TX_DATA3,0xFF},{SIF_CONTROL,0x01},
{SIF_ADDR_S2,0x09},{SIF_TX_DATA1,0xFF},{SIF_TX_DATA2,0xFF},{SIF_TX_DATA3,0xFF},{SIF_CONTROL,0x01},
{SIF_ADDR_S2,0x0A},{SIF_TX_DATA1,0x00},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
{SIF_ADDR_S2,0x0B},{SIF_TX_DATA1,0x00},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
{SIF_ADDR_S2,0x60},{SIF_TX_DATA1,0x3B},{SIF_TX_DATA2,0x80},{SIF_TX_DATA3,0x25},{SIF_CONTROL,0x01},
{SIF_ADDR_S2,0x61},{SIF_TX_DATA1,0x44},{SIF_TX_DATA2,0x80},{SIF_TX_DATA3,0x06},{SIF_CONTROL,0x01},
{SIF_ADDR_S2,0x62},{SIF_TX_DATA1,0xFF},{SIF_TX_DATA2,0xFF},{SIF_TX_DATA3,0xFF},{SIF_CONTROL,0x01},
{SIF_ADDR_S2,0x63},{SIF_TX_DATA1,0x2C},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x05},{SIF_CONTROL,0x01},
{SIF_ADDR_S2,0x64},{SIF_TX_DATA1,0x74},{SIF_TX_DATA2,0x90},{SIF_TX_DATA3,0x20},{SIF_CONTROL,0x01},
{SIF_ADDR_S2,0x65},{SIF_TX_DATA1,0x38},{SIF_TX_DATA2,0xC0},{SIF_TX_DATA3,0x05},{SIF_CONTROL,0x01},
{SIF_ADDR_S2,0x66},{SIF_TX_DATA1,0xFF},{SIF_TX_DATA2,0xFF},{SIF_TX_DATA3,0xFF},{SIF_CONTROL,0x01},
{SIF_ADDR_S2,0x67},{SIF_TX_DATA1,0x2C},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x05},{SIF_CONTROL,0x01},



{SIF_ADDR_S2,0x68},{SIF_TX_DATA1,0xFF},{SIF_TX_DATA2,0xFF},{SIF_TX_DATA3,0xFF},{SIF_CONTROL,0x01},
{SIF_ADDR_S2,0x69},{SIF_TX_DATA1,0xFF},{SIF_TX_DATA2,0xFF},{SIF_TX_DATA3,0xFF},{SIF_CONTROL,0x01},
{SIF_ADDR_S2,0x6A},{SIF_TX_DATA1,0xFF},{SIF_TX_DATA2,0xFF},{SIF_TX_DATA3,0xFF},{SIF_CONTROL,0x01},
{SIF_ADDR_S2,0x6B},{SIF_TX_DATA1,0xFF},{SIF_TX_DATA2,0xFF},{SIF_TX_DATA3,0xFF},{SIF_CONTROL,0x01},
{SIF_ADDR_S2,0x6C},{SIF_TX_DATA1,0xFF},{SIF_TX_DATA2,0xFF},{SIF_TX_DATA3,0xFF},{SIF_CONTROL,0x01},
{SIF_ADDR_S2,0x6D},{SIF_TX_DATA1,0x00},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
{SIF_ADDR_S2,0x6E},{SIF_TX_DATA1,0x00},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
{SIF_ADDR_S2,0x7F},{SIF_TX_DATA1,0x00},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
{SIF_ADDR_S2,0x40},{SIF_TX_DATA1,0xFF},{SIF_TX_DATA2,0xFF},{SIF_TX_DATA3,0xFF},{SIF_CONTROL,0x01},
{SIF_ADDR_S2,0x41},{SIF_TX_DATA1,0xFF},{SIF_TX_DATA2,0xFF},{SIF_TX_DATA3,0xFF},{SIF_CONTROL,0x01},
{SIF_ADDR_S2,0x42},{SIF_TX_DATA1,0xFF},{SIF_TX_DATA2,0xFF},{SIF_TX_DATA3,0xFF},{SIF_CONTROL,0x01},
{SIF_ADDR_S2,0x50},{SIF_TX_DATA1,0x0F},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
{SIF_ADDR_S2,0x51},{SIF_TX_DATA1,0x08},{SIF_TX_DATA2,0x72},{SIF_TX_DATA3,0x22},{SIF_CONTROL,0x01},
{SIF_ADDR_S2,0x52},{SIF_TX_DATA1,0xFF},{SIF_TX_DATA2,0xFF},{SIF_TX_DATA3,0xFF},{SIF_CONTROL,0x01},
{SIF_ADDR_S2,0x53},{SIF_TX_DATA1,0xFF},{SIF_TX_DATA2,0xFF},{SIF_TX_DATA3,0xFF},{SIF_CONTROL,0x01},
{SIF_ADDR_S2,0x54},{SIF_TX_DATA1,0xFF},{SIF_TX_DATA2,0xFF},{SIF_TX_DATA3,0xFF},{SIF_CONTROL,0x01},
{SIF_ADDR_S2,0x65},{SIF_TX_DATA1,0x51},{SIF_TX_DATA2,0x80},{SIF_TX_DATA3,0x06},{SIF_CONTROL,0x01},
{SIF_ADDR_S2,0x66},{SIF_TX_DATA1,0xFF},{SIF_TX_DATA2,0xFF},{SIF_TX_DATA3,0xFF},{SIF_CONTROL,0x01},
{SIF_ADDR_S2,0x15},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
{SIF_ADDR_S2,0x14},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
{SIF_ADDR_S2,0x20},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
{SIF_ADDR_S2,0x22},{SIF_TX_DATA1,0x64},{SIF_TX_DATA2,0x20},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
{SIF_ADDR_S2,0x1B},{SIF_TX_DATA1,0x00},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x20},{SIF_CONTROL,0x01},
{SIF_ADDR_S2,0x61},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
{SIF_ADDR_S2,0x62},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
{SIF_ADDR_S2,0x63},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0xE0},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
{SIF_ADDR_S2,0x64},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
{SIF_ADDR_S2,0x67},{SIF_TX_DATA1,0x02},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
{SIF_ADDR_S2,0x68},{SIF_TX_DATA1,0x07},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},

{SIF_ADDR_S2,0x69},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
{SIF_ADDR_S2,0x6B},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
{SIF_ADDR_S2,0x6C},{SIF_TX_DATA1,0x00},{SIF_TX_DATA2,0x40},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
{SIF_ADDR_S2,0x6F},{SIF_TX_DATA1,0x00},{SIF_TX_DATA2,0x70},{SIF_TX_DATA3,0x01},{SIF_CONTROL,0x01},
{SIF_ADDR_S2,0x71},{SIF_TX_DATA1,0x00},{SIF_TX_DATA2,0x90},{SIF_TX_DATA3,0x02},{SIF_CONTROL,0x01},
{SIF_ADDR_S2,0x36},{SIF_TX_DATA1,0x13},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
{SIF_ADDR_S2,0x11},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
{SIF_ADDR_S2,0x13},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
{END_REG,0x00}
};

///////////////////////////////////////////
// TICCD
//////////////////////////////////////////

#define TI_SPI_NORMSPD			0x3A	// 250 KHz (serial interface)
#define TI_SPI_HISPEED			0x39	// 500 KHz (serial interface)
#define TI_SPI_FREESPD			0x38	// 1 MHz (serial interface)

struct topro_sregs TI_CCD[] =
{
	{SIF_TYPE,0x01},
	{SIF_CONTROL,0x00},
	{CLK_CFG,TI_SPI_NORMSPD},					// 0x3A is Normal Speed

	{PCLK_CFG,0x25},

	{ISP_MODE,0x00},
	{VIDEO_TIMING,0x11},
	{VIDEO_PTN,0x00},
	{GDIFF_THRLD,0x80},
	{FUNCTION_SEL,0x02},
	{CCIR_MODE,0x03},
	{MCLK_CFG, 0x03},
	{END_REG,0x00}
};

struct topro_sregs TI_CCD_VGA[] =
{
	{CFA_PIXEL_START_L,0x42},
	{CFA_PIXEL_START_H,0x00},
	{CFA_LINE_START_L,0x10},
	{CFA_LINE_START_H,0x00},
	{CFA_FRAME_WIDTH_L,0x7F},
	{CFA_FRAME_WIDTH_H,0x02},
	{CFA_FRAME_HEIGHT_L,0xDF},
	{CFA_FRAME_HEIGHT_H,0x01},
	{END_REG,0x00}
};

struct topro_sregs TI_CCD_QVGA[] =
{
	{CFA_PIXEL_START_L,0x42},
	{CFA_PIXEL_START_H,0x00},
	{CFA_LINE_START_L,0x10},
	{CFA_LINE_START_H,0x00},
	{CFA_FRAME_WIDTH_L,0x7F},
	{CFA_FRAME_WIDTH_H,0x02},
	{CFA_FRAME_HEIGHT_L,0xDF},
	{CFA_FRAME_HEIGHT_H,0x01},
	{END_REG,0x00}
};

unsigned char SPI16_PRE[]= {
	0x23,0xe8,
	0x24,0x00,
	0x25,0xa0,
	0x26,0x94,
	0x27,0xdc,
	0x28,0x08,

	0x29,0x48,
	0x2a,0x00,
	0x2b,0xe0,
	0x2c,0x8c,
	0x2d,0x14,
	0x2e,0x08,
	END_REG, 
	END_REG,
};

unsigned char SPI16_POST[]= {
	0x00,0x00,
	0x01,0x20,
	0x02,0x0c,
	0x03,0x00,
	0x04,0x00,
	0x05,0x00,
	//; CCD Gain (digital)
	0x06,0x00,
	0x07,0x0c,
	//; CCD Gain (analog)
	0x08,0x00,
	//;
	0x09,0x00,
	
	0x0a,0x00,0x0b,0x00,  0x0c,0x00,0x0d,0x00,  //; DAC-1 8bit, DAC-2 8bit
	
	//; Not Exist
	//; [0x0e,0x00,0x0f,0x00,]

	0x10,0x0c,0x11,0x78,0x12,0x18,0x13,0x08,0x14,0x04,0x15,0x00,0x16,0x00,0x17,0x00,0x18,0x00,
	0x19,0x00,0x1a,0x00,0x1b,0x00,0x1c,0x00,0x1d,0x00,0x1e,0x00,

	0x21,0x00,0x22,0x04,

	0x2f,0x24,0x30,0x00,0x31,0x00,0x32,0x00,0x33,0x00,0x34,0x00,0x35,0x00,0x36,0x00,0x37,0x00,0x38,0x00,
	0x39,0x00,0x3a,0x00,0x3b,0x00,0x3c,0x00,0x3d,0x00,0x3e,0x00,

	0x40,0x00,0x41,0x00,0x42,0x00,0x43,0x00,0x44,0x00,0x45,0x00,0x46,0x00,0x47,0x00,
	0x48,0x00,0x49,0x00,0x4a,0x00,0x4b,0x00,0x4c,0x00,0x4d,0x00,0x4e,0x00,0x4f,0x00,
	0x50,0x00,0x51,0x00,0x52,0x00,0x53,0x00,0x54,0x00,0x55,0x00,0x56,0x00,0x57,0x00,
	0x58,0x00,0x59,0x00,0x5a,0x00,0x5b,0x00,0x5c,0x00,0x5d,0x00,0x5e,0x00,0x5f,0x00,
	0x60,0x00,0x61,0x00,0x62,0x00,0x63,0x00,0x64,0x00,0x65,0x00,0x66,0x00,0x67,0x00,
	0x68,0x00,0x69,0x00,0x6a,0x00,0x6b,0x00,0x6c,0x00,0x6d,0x00,0x6e,0x00,0x6f,0x00,
	0x70,0x00,0x71,0x00,0x72,0x00,0x73,0x00,0x74,0x00,0x75,0x00,0x76,0x00,0x77,0x00,
	0x78,0x00,0x79,0x00,0x7a,0x00,0x7b,0x00,0x7c,0x00,0x7d,0x00,0x7e,0x00,0x7f,0x00,
	0x80,0x00,0x81,0x00,0x82,0x00,0x83,0x00,0x84,0x00,0x85,0x00,0x86,0x00,0x87,0x00,
	0x88,0x00,0x89,0x00,0x8a,0x00,0x8b,0x00,0x8c,0x48,0x8d,0x04,0x8e,0x00,0x8f,0xa4,
	0x90,0x04,0x91,0x08,0x92,0x00,0x93,0x00,0x94,0x00,0x95,0x00,0x96,0x00,0x97,0x00,
	0x98,0x04,0x99,0x00,0x9a,0x00,0x9b,0x2c,0x9c,0x00,0x9d,0x04,
	//; CCD Exposure(Temp1)
	0x9e,0x80,
	//; CCD Exposure(Temp2)
	0x9f,0x04,
	0xa0,0x00,0xa1,0x00,0xa2,0x00,0xa3,0x00,

	0x20,0x4c,
	END_REG, END_REG,
};

#if 1
unsigned char SPI32_I2C_Chap1[]= {
	0x00,0x5a,0x80,0x0c, // 0x005a 800c
	0x01,0xaa,0x80,0x1c,
	0x02,0xae,0x00,0x88, // 0x02ae 0088
	0x03,0xb2,0x80,0x5a,
	0x04,0xb6,0x00,0x01,

	0x05,0xba,0x00,0x0d,0x06,0xbe,0x80,0x0d,0x07,0xe2,0x00,0x53,
	0x08,0xe6,0x00,0x12,0x09,0x16,0x81,0x02,0x0a,0x3e,0x01,0x1f,0x0b,0x4a,0x01,0x11,
	0x0c,0x76,0x01,0x43,0x0d,0x7a,0x01,0x02,0x0e,0xaa,0x81,0x12,0x0f,0xd2,0x01,0x98,

	0x10,0xd6,0x81,0x4a,0x11,0xda,0x81,0x1d,0x12,0xde,0x01,0x0c,0x13,0x0a,0x02,0x5d,
	0x14,0x0e,0x02,0x1c,0x15,0x26,0x0c,0x8d,0x16,0x2a,0x0c,0x4f,0x17,0x2e,0x8c,0x0e,
	0x18,0x32,0x8c,0xff,0x19,0x5a,0x80,0x0c,0x1a,0xaa,0x80,0x1c,0x1b,0xae,0x00,0x88,
	0x1c,0xb2,0x80,0x5a,0x1d,0xb6,0x00,0x01,0x1e,0xbe,0x80,0x0d,0x1f,0xe2,0x00,0x53,

	0x20,0xe6,0x00,0x12,0x21,0x16,0x81,0x02,0x22,0x3e,0x01,0x1f,0x23,0x4a,0x01,0x11,
	0x24,0x76,0x01,0x43,0x25,0x7a,0x01,0x02,0x26,0xaa,0x81,0x12,0x27,0xd2,0x01,0x98,
	0x28,0xd6,0x81,0x4a,0x29,0xda,0x81,0x1d,0x2a,0xde,0x01,0x0c,0x2b,0x0e,0x02,0x1c,
	0x2c,0x2e,0x0c,0x0f,0x2d,0x32,0x8c,0xff,0x2e,0x5a,0x80,0x0c,0x2f,0xaa,0x80,0x1c,

	END_REG, END_REG,
};

unsigned char SPI32_I2C_Chap1e[]= {
	0x30,0xae,0x00,0x88,0x31,0xb2,0x80,0x5a,0x32,0xb6,0x00,0x01,0x33,0xba,0x00,0x0d,
	0x34,0xbe,0x80,0x0d,0x35,0xe2,0x00,0x53,0x36,0xe6,0x00,0x12,0x37,0x16,0x81,0x02,
	0x38,0x3e,0x01,0x1f,0x39,0x4a,0x01,0x11,0x3a,0x76,0x01,0x43,0x3b,0x7a,0x01,0x02,
	0x3c,0xaa,0x81,0x12,0x3d,0xd2,0x01,0x98,0x3e,0xd6,0x81,0x4a,0x3f,0xda,0x81,0x1d,

	0x40,0xde,0x01,0x0c,0x41,0x0a,0x02,0x5d,0x42,0x0e,0x02,0x1c,0x43,0x2e,0x0c,0x0f,
	0x44,0x32,0x8c,0xff,0x45,0x5a,0x80,0x0c,0x46,0xaa,0x80,0x1c,0x47,0xae,0x00,0x88,
	0x48,0xb2,0x80,0x5a,0x49,0xb6,0x00,0x01,0x4a,0xbe,0x80,0x0d,0x4b,0xe2,0x00,0x53,
	0x4c,0xe6,0x00,0x12,0x4d,0x16,0x81,0x02,0x4e,0x3e,0x01,0x1f,0x4f,0x4a,0x01,0x11,

	0x50,0x76,0x01,0x43,0x51,0x7a,0x01,0x02,0x52,0xaa,0x81,0x12,0x53,0xce,0x01,0x81,
	0x54,0xd2,0x01,0x98,0x55,0xd6,0x81,0x4a,0x56,0xda,0x81,0x1d,0x57,0xde,0x01,0x0c,
	0x58,0x0e,0x02,0x1c,0x59,0x22,0x88,0x49,0x5a,0x26,0x08,0x09,0x5b,0x2e,0x08,0x11,
	0x5c,0xa2,0x88,0x59,0x5d,0xa6,0x08,0x19,0x5e,0x2e,0x0c,0x0f,0x5f,0x32,0x8c,0xff,

	END_REG, END_REG,
};

unsigned char SPI32_I2C_Chap2[]= {

	0x60,0x5a,0x80,0x0c,0x61,0xaa,0x80,0x1c,0x62,0xae,0x00,0x88,0x63,0xb2,0x80,0x5a,
	0x64,0xb6,0x00,0x01,0x65,0xbe,0x80,0x0d,0x66,0xe2,0x00,0x53,0x67,0xe6,0x00,0x12,
	0x68,0x16,0x81,0x02,0x69,0x3e,0x01,0x1f,0x6a,0x4a,0x01,0x11,0x6b,0x76,0x01,0x43,
	0x6c,0x7a,0x01,0x02,0x6d,0xaa,0x81,0x12,0x6e,0xd2,0x01,0x98,0x6f,0xd6,0x81,0x4a,

	0x70,0xda,0x81,0x1d,0x71,0xde,0x01,0x0c,0x72,0x0e,0x02,0x1c,0x73,0x2a,0x0c,0x4f,
	0x74,0x2e,0x8c,0x1e,0x75,0x32,0x8c,0xff,0x76,0x5a,0x80,0x0c,0x77,0xaa,0x80,0x1c,
	0x78,0xae,0x00,0x88,0x79,0xb2,0x80,0x5a,0x7a,0xb6,0x00,0x01,0x7b,0xbe,0x80,0x0d,
	0x7c,0xe2,0x00,0x53,0x7d,0xe6,0x00,0x12,0x7e,0x16,0x81,0x02,0x7f,0x3e,0x01,0x1f,

	0x80,0x4a,0x01,0x11,0x81,0x76,0x01,0x43,0x82,0x7a,0x01,0x02,0x83,0xaa,0x81,0x12,
	0x84,0xd2,0x01,0x98,0x85,0xd6,0x81,0x4a,0x86,0xda,0x81,0x1d,0x87,0xde,0x01,0x0c,
	0x88,0x0e,0x02,0x1c,0x89,0x2e,0x0c,0x0f,0x8a,0x32,0x8c,0xff,0x8b,0x5a,0x80,0x0c,
	0x8c,0xaa,0x80,0x1c,0x8d,0xae,0x00,0x88,0x8e,0xb2,0x80,0x5a,0x8f,0xb6,0x00,0x01,

	0x90,0xbe,0x80,0x0d,0x91,0xe2,0x00,0x53,0x92,0xe6,0x00,0x12,0x93,0x16,0x81,0x02,
	0x94,0x3e,0x01,0x1f,0x95,0x4a,0x01,0x11,0x96,0x76,0x01,0x43,0x97,0x7a,0x01,0x02,
	0x98,0xaa,0x81,0x12,0x99,0xd2,0x01,0x98,0x9a,0xd6,0x81,0x4a,0x9b,0xda,0x81,0x1d,
	0x9c,0xde,0x01,0x0c,0x9d,0x0e,0x02,0x1c,0x9e,0x2a,0x0c,0x5d,0x9f,0x2e,0x0c,0x0f,

	0xa0,0x32,0x8c,0xff,0xa1,0x02,0x00,0x00,0xa2,0x02,0x00,0x00,0xa3,0x02,0x00,0x00,

	END_REG, END_REG,
	};

unsigned char SPI32_I2C_Chap2x[]= {

	0xa4,0x02,0x00,0x00,0xa5,0x02,0x00,0x00,0xa6,0x02,0x00,0x00,0xa7,0x02,0x00,0x00,
	0xa8,0x02,0x00,0x00,0xa9,0x02,0x00,0x00,0xaa,0x02,0x00,0x00,0xab,0x02,0x00,0x00,
	0xac,0x02,0x00,0x00,0xad,0x02,0x00,0x00,0xae,0x02,0x00,0x00,0xaf,0x02,0x00,0x00,

	END_REG, END_REG,
	}; 

unsigned char SPI32_I2C_Chap3[]= {

	0xb0,0x02,0x00,0x00,0xb1,0x02,0x00,0x00,0xb2,0x02,0x00,0x00,0xb3,0x02,0x00,0x00,
	0xb4,0x02,0x00,0x00,0xb5,0x02,0x00,0x00,0xb6,0x02,0x00,0x00,0xb7,0x02,0x00,0x00,
	0xb8,0x02,0x00,0x00,0xb9,0x02,0x00,0x00,0xba,0x02,0x00,0x00,0xbb,0x02,0x00,0x00,
	0xbc,0x02,0x00,0x00,0xbd,0x02,0x00,0x00,0xbe,0x02,0x00,0x00,0xbf,0x02,0x00,0x00,

	0xc0,0x02,0x00,0x00,0xc1,0x02,0x00,0x00,0xc2,0x02,0x00,0x00,0xc3,0x02,0x00,0x00,
	0xc4,0x02,0x00,0x00,0xc5,0x02,0x00,0x00,0xc6,0x02,0x00,0x00,0xc7,0x02,0x00,0x00,
	0xc8,0x02,0x00,0x00,0xc9,0x02,0x00,0x00,0xca,0x02,0x00,0x00,0xcb,0x02,0x00,0x00,
	0xcc,0x02,0x00,0x00,0xcd,0x02,0x00,0x00,0xce,0x02,0x00,0x00,0xcf,0x02,0x00,0x00,

	0xd0,0x02,0x00,0x00,0xd1,0x02,0x00,0x00,0xd2,0x02,0x00,0x00,0xd3,0x02,0x00,0x00,
	0xd4,0x02,0x00,0x00,0xd5,0x02,0x00,0x00,0xd6,0x02,0x00,0x00,0xd7,0x02,0x00,0x00,
	0xd8,0x02,0x00,0x00,0xd9,0x02,0x00,0x00,0xda,0x02,0x00,0x00,0xdb,0x02,0x00,0x00,
	0xdc,0x02,0x00,0x00,0xdd,0x02,0x00,0x00,0xde,0x02,0x00,0x00,0xdf,0x02,0x00,0x00,

	0xe0,0x02,0x00,0x00,0xe1,0x02,0x00,0x00,0xe2,0x02,0x00,0x00,0xe3,0x02,0x00,0x00,
	0xe4,0x02,0x00,0x00,0xe5,0x02,0x00,0x00,0xe6,0x02,0x00,0x00,0xe7,0x02,0x00,0x00,
	0xe8,0x02,0x00,0x00,0xe9,0x02,0x00,0x00,0xea,0x02,0x00,0x00,0xeb,0x02,0x00,0x00,
	0xec,0x02,0x00,0x00,0xed,0x02,0x00,0x00,0xee,0x02,0x00,0x00,0xef,0x02,0x00,0x00,

	0xf0,0x02,0x00,0x00,0xf1,0x02,0x00,0x00,0xf2,0x02,0x00,0x00,0xf3,0x02,0x00,0x00,
	0xf4,0x02,0x00,0x00,0xf5,0x02,0x00,0x00,0xf6,0x02,0x00,0x00,0xf7,0x02,0x00,0x00,
	0xf8,0x02,0x00,0x00,0xf9,0x02,0x00,0x00,0xfa,0x02,0x00,0x00,0xfb,0x02,0x00,0x00,
	0xfc,0x02,0x00,0x00,0xfd,0x02,0x00,0x00,0xfe,0x02,0x00,0x00,0xff,0x02,0x00,0x00,

	END_REG, END_REG,
	};

unsigned char SPI32_I2C_Chap4[]= {

	0x00,0x03,0x00,0x00,0x01,0x03,0x00,0x00,0x02,0x03,0x00,0x00,0x03,0x03,0x00,0x00,
	0x04,0x03,0x00,0x00,0x05,0x03,0x00,0x00,0x06,0x03,0x00,0x00,0x07,0x03,0x00,0x00,
	0x08,0x03,0x00,0x00,0x09,0x03,0x00,0x00,0x0a,0x03,0x00,0x00,0x0b,0x03,0x00,0x00,
	0x0c,0x03,0x00,0x00,0x0d,0x03,0x00,0x00,0x0e,0x03,0x00,0x00,0x0f,0x03,0x00,0x00,

	0x10,0x03,0x00,0x00,0x11,0x03,0x00,0x00,0x12,0x03,0x00,0x00,0x13,0x03,0x00,0x00,
	0x14,0x03,0x00,0x00,0x15,0x03,0x00,0x00,0x16,0x03,0x00,0x00,0x17,0x03,0x00,0x00,
	0x18,0x03,0x00,0x00,0x19,0x03,0x00,0x00,0x1a,0x03,0x00,0x00,0x1b,0x03,0x00,0x00,
	0x1c,0x03,0x00,0x00,0x1d,0x03,0x00,0x00,0x1e,0x03,0x00,0x00,0x1f,0x03,0x00,0x00,

	0x20,0x03,0x00,0x00,0x21,0x03,0x00,0x00,0x22,0x03,0x00,0x00,0x23,0x03,0x00,0x00,
	0x24,0x03,0x00,0x00,0x25,0x03,0x00,0x00,0x26,0x03,0x00,0x00,0x27,0x03,0x00,0x00,
	0x28,0x03,0x00,0x00,0x29,0x03,0x00,0x00,0x2a,0x03,0x00,0x00,0x2b,0x03,0x00,0x00,
	0x2c,0x03,0x00,0x00,0x2d,0x03,0x00,0x00,0x2e,0x03,0x00,0x00,0x2f,0x03,0x00,0x00,

	0x30,0x03,0x00,0x00,0x31,0x03,0x00,0x00,0x32,0x03,0x00,0x00,0x33,0x03,0x00,0x00,
	0x34,0x03,0x00,0x00,0x35,0x03,0x00,0x00,0x36,0x03,0x00,0x00,0x37,0x03,0x00,0x00,
	0x38,0x03,0x00,0x00,0x39,0x03,0x00,0x00,0x3a,0x03,0x00,0x00,0x3b,0x03,0x00,0x00,
	0x3c,0x03,0x00,0x00,0x3d,0x03,0x00,0x00,0x3e,0x03,0x00,0x00,0x3f,0x03,0x00,0x00,

	0x40,0x03,0x00,0x00,0x41,0x03,0x00,0x00,0x42,0x03,0x00,0x00,0x43,0x03,0x00,0x00,
	0x44,0x03,0x00,0x00,0x45,0x03,0x00,0x00,0x46,0x03,0x00,0x00,0x47,0x03,0x00,0x00,
	0x48,0x03,0x00,0x00,0x49,0x03,0x00,0x00,0x4a,0x03,0x00,0x00,0x4b,0x03,0x00,0x00,
	0x4c,0x03,0x00,0x00,0x4d,0x03,0x00,0x00,0x4e,0x03,0x00,0x00,0x4f,0x03,0x00,0x00,

	0x50,0x03,0x00,0x00,0x51,0x03,0x00,0x00,0x52,0x03,0x00,0x00,0x53,0x03,0x00,0x00,
	0x54,0x03,0x00,0x00,0x55,0x03,0x00,0x00,0x56,0x03,0x00,0x00,0x57,0x03,0x00,0x00,
	0x58,0x03,0x00,0x00,0x59,0x03,0x00,0x00,0x5a,0x03,0x00,0x00,0x5b,0x03,0x00,0x00,
	0x5c,0x03,0x00,0x00,0x5d,0x03,0x00,0x00,0x5e,0x03,0x00,0x00,0x5f,0x03,0x00,0x00,

	0x60,0x03,0x00,0x00,0x61,0x03,0x00,0x00,0x62,0x03,0x00,0x00,0x63,0x03,0x00,0x00,
	0x64,0x03,0x00,0x00,0x65,0x03,0x00,0x00,0x66,0x03,0x00,0x00,0x67,0x03,0x00,0x00,
	0x68,0x03,0x00,0x00,0x69,0x03,0x00,0x00,0x6a,0x03,0x00,0x00,0x6b,0x03,0x00,0x00,
	0x6c,0x03,0x00,0x00,0x6d,0x03,0x00,0x00,0x6e,0x03,0x00,0x00,0x6f,0x03,0x00,0x00,

	0x70,0x03,0x00,0x00,0x71,0x03,0x00,0x00,0x72,0x03,0x00,0x00,0x73,0x03,0x00,0x00,
	0x74,0x03,0x00,0x00,0x75,0x03,0x00,0x00,0x76,0x03,0x00,0x00,0x77,0x03,0x00,0x00,
	0x78,0x03,0x00,0x00,0x79,0x03,0x00,0x00,0x7a,0x03,0x00,0x00,0x7b,0x03,0x00,0x00,
	0x7c,0x03,0x00,0x00,0x7d,0x03,0x00,0x00,0x7e,0x03,0x00,0x00,0x7f,0x03,0x00,0x00,

	0x80,0x03,0x00,0x00,0x81,0x03,0x00,0x00,0x82,0x03,0x00,0x00,0x83,0x03,0x00,0x00,
	0x84,0x03,0x00,0x00,0x85,0x03,0x00,0x00,0x86,0x03,0x00,0x00,0x87,0x03,0x00,0x00,
	0x88,0x03,0x00,0x00,0x89,0x03,0x00,0x00,0x8a,0x03,0x00,0x00,0x8b,0x03,0x00,0x00,
	0x8c,0x03,0x00,0x00,0x8d,0x03,0x00,0x00,0x8e,0x03,0x00,0x00,0x8f,0x03,0x00,0x00,

	0x90,0x03,0x00,0x00,0x91,0x03,0x00,0x00,0x92,0x03,0x00,0x00,0x93,0x03,0x00,0x00,
	0x94,0x03,0x00,0x00,0x95,0x03,0x00,0x00,0x96,0x03,0x00,0x00,0x97,0x03,0x00,0x00,
	0x98,0x03,0x00,0x00,0x99,0x03,0x00,0x00,0x9a,0x03,0x00,0x00,0x9b,0x03,0x00,0x00,
	0x9c,0x03,0x00,0x00,0x9d,0x03,0x00,0x00,0x9e,0x03,0x00,0x00,0x9f,0x03,0x00,0x00,

	0xa0,0x03,0x00,0x00,0xa1,0x03,0x00,0x00,0xa2,0x03,0x00,0x00,0xa3,0x03,0x00,0x00,
	0xa4,0x03,0x00,0x00,0xa5,0x03,0x00,0x00,0xa6,0x03,0x00,0x00,0xa7,0x03,0x00,0x00,
	0xa8,0x03,0x00,0x00,0xa9,0x03,0x00,0x00,0xaa,0x03,0x00,0x00,0xab,0x03,0x00,0x00,
	0xac,0x03,0x00,0x00,0xad,0x03,0x00,0x00,0xae,0x03,0x00,0x00,0xaf,0x03,0x00,0x00,

	0xb0,0x03,0x00,0x00,0xb1,0x03,0x00,0x00,0xb2,0x03,0x00,0x00,0xb3,0x03,0x00,0x00,
	0xb4,0x03,0x00,0x00,0xb5,0x03,0x00,0x00,0xb6,0x03,0x00,0x00,0xb7,0x03,0x00,0x00,
	0xb8,0x03,0x00,0x00,0xb9,0x03,0x00,0x00,0xba,0x03,0x00,0x00,0xbb,0x03,0x00,0x00,
	0xbc,0x03,0x00,0x00,0xbd,0x03,0x00,0x00,0xbe,0x03,0x00,0x00,0xbf,0x03,0x00,0x00,

	0xc0,0x03,0x00,0x00,0xc1,0x03,0x00,0x00,0xc2,0x03,0x00,0x00,0xc3,0x03,0x00,0x00,
	0xc4,0x03,0x00,0x00,0xc5,0x03,0x00,0x00,0xc6,0x03,0x00,0x00,0xc7,0x03,0x00,0x00,
	0xc8,0x03,0x00,0x00,0xc9,0x03,0x00,0x00,0xca,0x03,0x00,0x00,0xcb,0x03,0x00,0x00,
	0xcc,0x03,0x00,0x00,0xcd,0x03,0x00,0x00,0xce,0x03,0x00,0x00,0xcf,0x03,0x00,0x00,

	0xd0,0x03,0x00,0x00,0xd1,0x03,0x00,0x00,0xd2,0x03,0x00,0x00,0xd3,0x03,0x00,0x00,
	0xd4,0x03,0x00,0x00,0xd5,0x03,0x00,0x00,0xd6,0x03,0x00,0x00,0xd7,0x03,0x00,0x00,
	0xd8,0x03,0x00,0x00,0xd9,0x03,0x00,0x00,0xda,0x03,0x00,0x00,0xdb,0x03,0x00,0x00,
	0xdc,0x03,0x00,0x00,0xdd,0x03,0x00,0x00,0xde,0x03,0x00,0x00,0xdf,0x03,0x00,0x00,

	0xe0,0x03,0x00,0x00,0xe1,0x03,0x00,0x00,0xe2,0x03,0x00,0x00,0xe3,0x03,0x00,0x00,
	0xe4,0x03,0x00,0x00,0xe5,0x03,0x00,0x00,0xe6,0x03,0x00,0x00,0xe7,0x03,0x00,0x00,
	0xe8,0x03,0x00,0x00,0xe9,0x03,0x00,0x00,0xea,0x03,0x00,0x00,0xeb,0x03,0x00,0x00,
	0xec,0x03,0x00,0x00,0xed,0x03,0x00,0x00,0xee,0x03,0x00,0x00,0xef,0x03,0x00,0x00,

	0xf0,0x03,0x00,0x00,0xf1,0x03,0x00,0x00,0xf2,0x03,0x00,0x00,0xf3,0x03,0x00,0x00,
	0xf4,0x03,0x00,0x00,0xf5,0x03,0x00,0x00,0xf6,0x03,0x00,0x00,0xf7,0x03,0x00,0x00,
	0xf8,0x03,0x00,0x00,0xf9,0x03,0x00,0x00,0xfa,0x03,0x00,0x00,0xfb,0x03,0x00,0x00,
	0xfc,0x03,0x00,0x00,0xfd,0x03,0x00,0x00,0xfe,0x03,0x00,0x00,0xff,0x03,0x00,0x00,

	0x00,0x01,0x00,0x00,0x01,0x01,0x00,0x00,0x02,0x01,0x00,0x00,0x03,0x01,0x00,0x00,
	0x04,0x01,0x00,0x00,0x05,0x01,0x00,0x00,0x06,0x01,0x00,0x00,0x07,0x01,0x00,0x00,
	0x08,0x01,0x00,0x00,0x09,0x01,0x00,0x00,0x0a,0x01,0x00,0x00,0x0b,0x01,0x00,0x00,
	0x0c,0x01,0x00,0x00,0x0d,0x01,0x00,0x00,0x0e,0x01,0x00,0x00,0x0f,0x01,0x00,0x00,

	0x10,0x01,0x00,0x00,0x11,0x01,0x00,0x00,0x12,0x01,0x00,0x00,0x13,0x01,0x00,0x00,
	0x14,0x01,0x00,0x00,0x15,0x01,0x00,0x00,0x16,0x01,0x00,0x00,0x17,0x01,0x00,0x00,
	0x18,0x01,0x00,0x00,0x19,0x01,0x00,0x00,0x1a,0x01,0x00,0x00,0x1b,0x01,0x00,0x00,
	0x1c,0x01,0x00,0x00,0x1d,0x01,0x00,0x00,0x1e,0x01,0x00,0x00,0x1f,0x01,0x00,0x00,

	0x20,0x01,0x00,0x00,0x21,0x01,0x00,0x00,0x22,0x01,0x00,0x00,0x23,0x01,0x00,0x00,
	0x24,0x01,0x00,0x00,0x25,0x01,0x00,0x00,0x26,0x01,0x00,0x00,0x27,0x01,0x00,0x00,
	0x28,0x01,0x00,0x00,0x29,0x01,0x00,0x00,0x2a,0x01,0x00,0x00,0x2b,0x01,0x00,0x00,
	0x2c,0x01,0x00,0x00,0x2d,0x01,0x00,0x00,0x2e,0x01,0x00,0x00,0x2f,0x01,0x00,0x00,

	0x30,0x01,0x00,0x00,0x31,0x01,0x00,0x00,0x32,0x01,0x00,0x00,0x33,0x01,0x00,0x00,
	0x34,0x01,0x00,0x00,0x35,0x01,0x00,0x00,0x36,0x01,0x00,0x00,0x37,0x01,0x00,0x00,
	0x38,0x01,0x00,0x00,0x39,0x01,0x00,0x00,0x3a,0x01,0x00,0x00,0x3b,0x01,0x00,0x00,
	0x3c,0x01,0x00,0x00,0x3d,0x01,0x00,0x00,0x3e,0x01,0x00,0x00,0x3f,0x01,0x00,0x00,

	0x40,0x01,0x00,0x00,0x41,0x01,0x00,0x00,0x42,0x01,0x00,0x00,0x43,0x01,0x00,0x00,
	0x44,0x01,0x00,0x00,0x45,0x01,0x00,0x00,0x46,0x01,0x00,0x00,0x47,0x01,0x00,0x00,
	0x48,0x01,0x00,0x00,0x49,0x01,0x00,0x00,0x4a,0x01,0x00,0x00,0x4b,0x01,0x00,0x00,
	0x4c,0x01,0x00,0x00,0x4d,0x01,0x00,0x00,0x4e,0x01,0x00,0x00,0x4f,0x01,0x00,0x00,

	0x50,0x01,0x00,0x00,0x51,0x01,0x00,0x00,0x52,0x01,0x00,0x00,0x53,0x01,0x00,0x00,
	0x54,0x01,0x00,0x00,0x55,0x01,0x00,0x00,0x56,0x01,0x00,0x00,0x57,0x01,0x00,0x00,
	0x58,0x01,0x00,0x00,0x59,0x01,0x00,0x00,0x5a,0x01,0x00,0x00,0x5b,0x01,0x00,0x00,
	0x5c,0x01,0x00,0x00,0x5d,0x01,0x00,0x00,0x5e,0x01,0x00,0x00,0x5f,0x01,0x00,0x00,

	0x60,0x01,0x00,0x00,0x61,0x01,0x00,0x00,0x62,0x01,0x00,0x00,0x63,0x01,0x00,0x00,
	0x64,0x01,0x00,0x00,0x65,0x01,0x00,0x00,0x66,0x01,0x00,0x00,0x67,0x01,0x00,0x00,
	0x68,0x01,0x00,0x00,0x69,0x01,0x00,0x00,0x6a,0x01,0x00,0x00,0x6b,0x01,0x00,0x00,
	0x6c,0x01,0x00,0x00,0x6d,0x01,0x00,0x00,0x6e,0x01,0x00,0x00,0x6f,0x01,0x00,0x00,

	0x70,0x01,0x00,0x00,0x71,0x01,0x00,0x00,0x72,0x01,0x00,0x00,0x73,0x01,0x00,0x00,
	0x74,0x01,0x00,0x00,0x75,0x01,0x00,0x00,0x76,0x01,0x00,0x00,0x77,0x01,0x00,0x00,
	0x78,0x01,0x00,0x00,0x79,0x01,0x00,0x00,0x7a,0x01,0x00,0x00,0x7b,0x01,0x00,0x00,
	0x7c,0x01,0x00,0x00,0x7d,0x01,0x00,0x00,0x7e,0x01,0x00,0x00,0x7f,0x01,0x00,0x00,
	END_REG, END_REG,
};
unsigned char SPI32_I2C_Chap5[]= {

	0x80,0x05,0x40,0x06,0x81,0x05,0x00,0x88,0x82,0x05,0x00,0x98,0x83,0x25,0x00,0x18,
	0x84,0x29,0x40,0x11,0x85,0x2d,0x80,0x1d,0x86,0x3d,0xc0,0x22,0x87,0x41,0x80,0x0b,
	//0x88,0x35,0x08,0x00,0x89,0x35,0x08,0xf8,

	0x88,0xfd,0x07,0x00, //(new: 188, 1ff)
	0x89,0xfd,0x07,0xf8,	

	0x8a,0x01,0x00,0x00,0x8b,0x01,0x00,0x00,
	0x8c,0x01,0x00,0x00,0x8d,0x01,0x00,0x00,0x8e,0x01,0x00,0x00,0x8f,0x01,0x00,0x00,

	END_REG, END_REG,
}; 

unsigned char SPI32_I2C_Chap5x[]= {

	0x90,0x01,0x00,0x00,0x91,0x01,0x00,0x00,0x92,0x01,0x00,0x00,0x93,0x01,0x00,0x00,
	0x94,0x01,0x00,0x00,0x95,0x01,0x00,0x00,0x96,0x01,0x00,0x00,0x97,0x01,0x00,0x00,
	0x98,0x01,0x00,0x00,0x99,0x01,0x00,0x00,0x9a,0x01,0x00,0x00,0x9b,0x01,0x00,0x00,
	0x9c,0x01,0x00,0x00,0x9d,0x01,0x00,0x00,0x9e,0x01,0x00,0x00,0x9f,0x01,0x00,0x00,

	0xa0,0x01,0x00,0x00,0xa1,0x01,0x00,0x00,0xa2,0x01,0x00,0x00,0xa3,0x01,0x00,0x00,
	0xa4,0x01,0x00,0x00,0xa5,0x01,0x00,0x00,0xa6,0x01,0x00,0x00,0xa7,0x01,0x00,0x00,
	0xa8,0x01,0x00,0x00,0xa9,0x01,0x00,0x00,0xaa,0x01,0x00,0x00,0xab,0x01,0x00,0x00,
	0xac,0x01,0x00,0x00,0xad,0x01,0x00,0x00,0xae,0x01,0x00,0x00,0xaf,0x01,0x00,0x00,

	0xb0,0x01,0x00,0x00,0xb1,0x01,0x00,0x00,0xb2,0x01,0x00,0x00,0xb3,0x01,0x00,0x00,
	0xb4,0x01,0x00,0x00,0xb5,0x01,0x00,0x00,0xb6,0x01,0x00,0x00,0xb7,0x01,0x00,0x00,
	0xb8,0x01,0x00,0x00,0xb9,0x01,0x00,0x00,0xba,0x01,0x00,0x00,0xbb,0x01,0x00,0x00,
	0xbc,0x01,0x00,0x00,0xbd,0x01,0x00,0x00,0xbe,0x01,0x00,0x00,0xbf,0x01,0x00,0x00,

	0xc0,0x01,0x00,0x00,0xc1,0x01,0x00,0x00,0xc2,0x01,0x00,0x00,0xc3,0x01,0x00,0x00,
	0xc4,0x01,0x00,0x00,0xc5,0x01,0x00,0x00,0xc6,0x01,0x00,0x00,0xc7,0x01,0x00,0x00,
	0xc8,0x01,0x00,0x00,0xc9,0x01,0x00,0x00,0xca,0x01,0x00,0x00,0xcb,0x01,0x00,0x00,
	0xcc,0x01,0x00,0x00,0xcd,0x01,0x00,0x00,0xce,0x01,0x00,0x00,0xcf,0x01,0x00,0x00,

	0xd0,0x01,0x00,0x00,0xd1,0x01,0x00,0x00,0xd2,0x01,0x00,0x00,0xd3,0x01,0x00,0x00,
	0xd4,0x01,0x00,0x00,0xd5,0x01,0x00,0x00,0xd6,0x01,0x00,0x00,0xd7,0x01,0x00,0x00,
	0xd8,0x01,0x00,0x00,0xd9,0x01,0x00,0x00,0xda,0x01,0x00,0x00,0xdb,0x01,0x00,0x00,
	0xdc,0x01,0x00,0x00,0xdd,0x01,0x00,0x00,0xde,0x01,0x00,0x00,0xdf,0x01,0x00,0x00,

	0xe0,0x01,0x00,0x00,0xe1,0x01,0x00,0x00,0xe2,0x01,0x00,0x00,0xe3,0x01,0x00,0x00,
	0xe4,0x01,0x00,0x00,0xe5,0x01,0x00,0x00,0xe6,0x01,0x00,0x00,0xe7,0x01,0x00,0x00,
	0xe8,0x01,0x00,0x00,0xe9,0x01,0x00,0x00,0xea,0x01,0x00,0x00,0xeb,0x01,0x00,0x00,
	0xec,0x01,0x00,0x00,0xed,0x01,0x00,0x00,0xee,0x01,0x00,0x00,0xef,0x01,0x00,0x00,

	0xf0,0x01,0x00,0x00,0xf1,0x01,0x00,0x00,0xf2,0x01,0x00,0x00,0xf3,0x01,0x00,0x00,
	0xf4,0x01,0x00,0x00,0xf5,0x01,0x00,0x00,0xf6,0x01,0x00,0x00,0xf7,0x01,0x00,0x00,
	0xf8,0x01,0x00,0x00,0xf9,0x01,0x00,0x00,0xfa,0x01,0x00,0x00,0xfb,0x01,0x00,0x00,
	0xfc,0x01,0x00,0x00,0xfd,0x01,0x00,0x00,0xfe,0x01,0x00,0x00,0xff,0x01,0x00,0x00,

	END_REG, END_REG,
}; 

#else

/*
#if 0
struct topro_sregs TI_CCD_SPI16_PRE[] =
  {
  {SIF_TYPE,0x01},
	{SIF_ADDR_S2,0x23},{SIF_TX_DATA1,0xe8},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0x24},{SIF_TX_DATA1,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0x25},{SIF_TX_DATA1,0xa0},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0x26},{SIF_TX_DATA1,0x94},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0x27},{SIF_TX_DATA1,0xdc},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0x28},{SIF_TX_DATA1,0x08},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0x29},{SIF_TX_DATA1,0x48},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0x2a},{SIF_TX_DATA1,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0x2b},{SIF_TX_DATA1,0xe0},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0x2c},{SIF_TX_DATA1,0x8c},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0x2d},{SIF_TX_DATA1,0x14},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0x2e},{SIF_TX_DATA1,0x08},{SIF_CONTROL,0x01},
	{END_REG,0x00}
  };
#endif
#if 0
struct topro_sregs TI_CCD_SPI16_POST[] =
  {
  {SIF_TYPE,0x01},
	{SIF_ADDR_S2,0x00},{SIF_TX_DATA1,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0x01},{SIF_TX_DATA1,0x20},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0x02},{SIF_TX_DATA1,0x0c},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0x03},{SIF_TX_DATA1,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0x04},{SIF_TX_DATA1,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0x05},{SIF_TX_DATA1,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0x06},{SIF_TX_DATA1,0x00},{SIF_CONTROL,0x01},
	//; CCD Gain
	{SIF_ADDR_S2,0x07},{SIF_TX_DATA1,0x0c},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0x08},{SIF_TX_DATA1,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0x09},{SIF_TX_DATA1,0x00},{SIF_CONTROL,0x01},

	{SIF_ADDR_S2,0x0a},{SIF_TX_DATA1,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x0b},{SIF_TX_DATA1,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x0c},{SIF_TX_DATA1,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x0d},{SIF_TX_DATA1,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x0e},{SIF_TX_DATA1,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x0f},{SIF_TX_DATA1,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x10},{SIF_TX_DATA1,0x0c},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x11},{SIF_TX_DATA1,0x78},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x12},{SIF_TX_DATA1,0x18},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x13},{SIF_TX_DATA1,0x08},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0x14},{SIF_TX_DATA1,0x04},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x15},{SIF_TX_DATA1,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x16},{SIF_TX_DATA1,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x17},{SIF_TX_DATA1,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x18},{SIF_TX_DATA1,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x19},{SIF_TX_DATA1,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x1a},{SIF_TX_DATA1,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x1b},{SIF_TX_DATA1,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x1c},{SIF_TX_DATA1,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x1d},{SIF_TX_DATA1,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0x1e},{SIF_TX_DATA1,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x21},{SIF_TX_DATA1,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x22},{SIF_TX_DATA1,0x04},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x2f},{SIF_TX_DATA1,0x24},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x30},{SIF_TX_DATA1,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x31},{SIF_TX_DATA1,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x32},{SIF_TX_DATA1,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x33},{SIF_TX_DATA1,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x34},{SIF_TX_DATA1,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x35},{SIF_TX_DATA1,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0x36},{SIF_TX_DATA1,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x37},{SIF_TX_DATA1,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x38},{SIF_TX_DATA1,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x39},{SIF_TX_DATA1,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x3a},{SIF_TX_DATA1,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x3b},{SIF_TX_DATA1,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x3c},{SIF_TX_DATA1,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x3d},{SIF_TX_DATA1,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x3e},{SIF_TX_DATA1,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x40},{SIF_TX_DATA1,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0x41},{SIF_TX_DATA1,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x42},{SIF_TX_DATA1,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x43},{SIF_TX_DATA1,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x44},{SIF_TX_DATA1,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x45},{SIF_TX_DATA1,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x46},{SIF_TX_DATA1,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x47},{SIF_TX_DATA1,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x48},{SIF_TX_DATA1,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x49},{SIF_TX_DATA1,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x4a},{SIF_TX_DATA1,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0x4b},{SIF_TX_DATA1,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x4c},{SIF_TX_DATA1,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x4d},{SIF_TX_DATA1,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x4e},{SIF_TX_DATA1,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x4f},{SIF_TX_DATA1,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x50},{SIF_TX_DATA1,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x51},{SIF_TX_DATA1,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x52},{SIF_TX_DATA1,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x53},{SIF_TX_DATA1,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x54},{SIF_TX_DATA1,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0x55},{SIF_TX_DATA1,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x56},{SIF_TX_DATA1,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x57},{SIF_TX_DATA1,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x58},{SIF_TX_DATA1,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x59},{SIF_TX_DATA1,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x5a},{SIF_TX_DATA1,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x5b},{SIF_TX_DATA1,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x5c},{SIF_TX_DATA1,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x5d},{SIF_TX_DATA1,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x5e},{SIF_TX_DATA1,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0x5f},{SIF_TX_DATA1,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x60},{SIF_TX_DATA1,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x61},{SIF_TX_DATA1,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x62},{SIF_TX_DATA1,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x63},{SIF_TX_DATA1,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x64},{SIF_TX_DATA1,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x65},{SIF_TX_DATA1,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x66},{SIF_TX_DATA1,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x67},{SIF_TX_DATA1,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x68},{SIF_TX_DATA1,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0x69},{SIF_TX_DATA1,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x6a},{SIF_TX_DATA1,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x6b},{SIF_TX_DATA1,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x6c},{SIF_TX_DATA1,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x6d},{SIF_TX_DATA1,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x6e},{SIF_TX_DATA1,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x6f},{SIF_TX_DATA1,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x70},{SIF_TX_DATA1,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x71},{SIF_TX_DATA1,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x72},{SIF_TX_DATA1,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0x73},{SIF_TX_DATA1,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x74},{SIF_TX_DATA1,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x75},{SIF_TX_DATA1,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x76},{SIF_TX_DATA1,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x77},{SIF_TX_DATA1,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x78},{SIF_TX_DATA1,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x79},{SIF_TX_DATA1,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x7a},{SIF_TX_DATA1,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x7b},{SIF_TX_DATA1,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x7c},{SIF_TX_DATA1,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0x7d},{SIF_TX_DATA1,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x7e},{SIF_TX_DATA1,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x7f},{SIF_TX_DATA1,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x80},{SIF_TX_DATA1,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x81},{SIF_TX_DATA1,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x82},{SIF_TX_DATA1,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x83},{SIF_TX_DATA1,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x84},{SIF_TX_DATA1,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x85},{SIF_TX_DATA1,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x86},{SIF_TX_DATA1,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0x87},{SIF_TX_DATA1,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x88},{SIF_TX_DATA1,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x89},{SIF_TX_DATA1,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x8a},{SIF_TX_DATA1,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x8b},{SIF_TX_DATA1,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x8c},{SIF_TX_DATA1,0x48},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x8d},{SIF_TX_DATA1,0x04},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x8e},{SIF_TX_DATA1,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x8f},{SIF_TX_DATA1,0xa4},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x90},{SIF_TX_DATA1,0x04},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0x91},{SIF_TX_DATA1,0x08},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x92},{SIF_TX_DATA1,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x93},{SIF_TX_DATA1,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x94},{SIF_TX_DATA1,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x95},{SIF_TX_DATA1,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x96},{SIF_TX_DATA1,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x97},{SIF_TX_DATA1,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x98},{SIF_TX_DATA1,0x04},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x99},{SIF_TX_DATA1,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x9a},{SIF_TX_DATA1,0x00},{SIF_CONTROL,0x01},

	{SIF_ADDR_S2,0x9b},{SIF_TX_DATA1,0x2c},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x9c},{SIF_TX_DATA1,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x9d},{SIF_TX_DATA1,0x04},{SIF_CONTROL,0x01},
	//; CCD Exposure(Temp1)
	{SIF_ADDR_S2,0x9e},{SIF_TX_DATA1,0x80},{SIF_CONTROL,0x01},
	//; CCD Exposure(Temp2)
	{SIF_ADDR_S2,0x9f},{SIF_TX_DATA1,0x04},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0xa0},{SIF_TX_DATA1,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xa1},{SIF_TX_DATA1,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xa2},{SIF_TX_DATA1,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xa3},{SIF_TX_DATA1,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x20},{SIF_TX_DATA1,0x4c},{SIF_CONTROL,0x01},
	{END_REG,0x00}
  };
#endif
*/


#if 0
struct topro_sregs TI_CCD_I2C[] =
  {
  {SIF_TYPE,0x03},
	{SIF_ADDR_S2,0x00},{SIF_TX_DATA1,0x5a},{SIF_TX_DATA2,0x80},{SIF_TX_DATA3,0x0c},{SIF_CONTROL,0x01}, // 0x005a 800c
	{SIF_ADDR_S2,0x01},{SIF_TX_DATA1,0xaa},{SIF_TX_DATA2,0x80},{SIF_TX_DATA3,0x1c},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0x02},{SIF_TX_DATA1,0xae},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x88},{SIF_CONTROL,0x01}, // 0x02ae 
	{SIF_ADDR_S2,0x03},{SIF_TX_DATA1,0xb2},{SIF_TX_DATA2,0x80},{SIF_TX_DATA3,0x5a},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0x04},{SIF_TX_DATA1,0xb6},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x01},{SIF_CONTROL,0x01},

	{SIF_ADDR_S2,0x05},{SIF_TX_DATA1,0xba},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x0d},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x06},{SIF_TX_DATA1,0xbe},{SIF_TX_DATA2,0x80},{SIF_TX_DATA3,0x0d},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x07},{SIF_TX_DATA1,0xe2},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x53},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x08},{SIF_TX_DATA1,0xe6},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x12},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x09},{SIF_TX_DATA1,0x16},{SIF_TX_DATA2,0x81},{SIF_TX_DATA3,0x02},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0x0a},{SIF_TX_DATA1,0x3e},{SIF_TX_DATA2,0x01},{SIF_TX_DATA3,0x1f},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x0b},{SIF_TX_DATA1,0x4a},{SIF_TX_DATA2,0x01},{SIF_TX_DATA3,0x11},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x0c},{SIF_TX_DATA1,0x76},{SIF_TX_DATA2,0x01},{SIF_TX_DATA3,0x43},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x0d},{SIF_TX_DATA1,0x7a},{SIF_TX_DATA2,0x01},{SIF_TX_DATA3,0x02},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x0e},{SIF_TX_DATA1,0xaa},{SIF_TX_DATA2,0x81},{SIF_TX_DATA3,0x12},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0x0f},{SIF_TX_DATA1,0xd2},{SIF_TX_DATA2,0x01},{SIF_TX_DATA3,0x98},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x10},{SIF_TX_DATA1,0xd6},{SIF_TX_DATA2,0x81},{SIF_TX_DATA3,0x4a},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x11},{SIF_TX_DATA1,0xda},{SIF_TX_DATA2,0x81},{SIF_TX_DATA3,0x1d},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x12},{SIF_TX_DATA1,0xde},{SIF_TX_DATA2,0x01},{SIF_TX_DATA3,0x0c},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x13},{SIF_TX_DATA1,0x0a},{SIF_TX_DATA2,0x02},{SIF_TX_DATA3,0x5d},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0x14},{SIF_TX_DATA1,0x0e},{SIF_TX_DATA2,0x02},{SIF_TX_DATA3,0x1c},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x15},{SIF_TX_DATA1,0x26},{SIF_TX_DATA2,0x0c},{SIF_TX_DATA3,0x8d},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x16},{SIF_TX_DATA1,0x2a},{SIF_TX_DATA2,0x0c},{SIF_TX_DATA3,0x4f},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x17},{SIF_TX_DATA1,0x2e},{SIF_TX_DATA2,0x8c},{SIF_TX_DATA3,0x0e},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x18},{SIF_TX_DATA1,0x32},{SIF_TX_DATA2,0x8c},{SIF_TX_DATA3,0xff},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0x19},{SIF_TX_DATA1,0x5a},{SIF_TX_DATA2,0x80},{SIF_TX_DATA3,0x0c},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x1a},{SIF_TX_DATA1,0xaa},{SIF_TX_DATA2,0x80},{SIF_TX_DATA3,0x1c},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x1b},{SIF_TX_DATA1,0xae},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x88},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x1c},{SIF_TX_DATA1,0xb2},{SIF_TX_DATA2,0x80},{SIF_TX_DATA3,0x5a},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x1d},{SIF_TX_DATA1,0xb6},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x01},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0x1e},{SIF_TX_DATA1,0xbe},{SIF_TX_DATA2,0x80},{SIF_TX_DATA3,0x0d},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x1f},{SIF_TX_DATA1,0xe2},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x53},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x20},{SIF_TX_DATA1,0xe6},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x12},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x21},{SIF_TX_DATA1,0x16},{SIF_TX_DATA2,0x81},{SIF_TX_DATA3,0x02},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x22},{SIF_TX_DATA1,0x3e},{SIF_TX_DATA2,0x01},{SIF_TX_DATA3,0x1f},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0x23},{SIF_TX_DATA1,0x4a},{SIF_TX_DATA2,0x01},{SIF_TX_DATA3,0x11},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x24},{SIF_TX_DATA1,0x76},{SIF_TX_DATA2,0x01},{SIF_TX_DATA3,0x43},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x25},{SIF_TX_DATA1,0x7a},{SIF_TX_DATA2,0x01},{SIF_TX_DATA3,0x02},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x26},{SIF_TX_DATA1,0xaa},{SIF_TX_DATA2,0x81},{SIF_TX_DATA3,0x12},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x27},{SIF_TX_DATA1,0xd2},{SIF_TX_DATA2,0x01},{SIF_TX_DATA3,0x98},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0x28},{SIF_TX_DATA1,0xd6},{SIF_TX_DATA2,0x81},{SIF_TX_DATA3,0x4a},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x29},{SIF_TX_DATA1,0xda},{SIF_TX_DATA2,0x81},{SIF_TX_DATA3,0x1d},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x2a},{SIF_TX_DATA1,0xde},{SIF_TX_DATA2,0x01},{SIF_TX_DATA3,0x0c},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x2b},{SIF_TX_DATA1,0x0e},{SIF_TX_DATA2,0x02},{SIF_TX_DATA3,0x1c},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x2c},{SIF_TX_DATA1,0x2e},{SIF_TX_DATA2,0x0c},{SIF_TX_DATA3,0x0f},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0x2d},{SIF_TX_DATA1,0x32},{SIF_TX_DATA2,0x8c},{SIF_TX_DATA3,0xff},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x2e},{SIF_TX_DATA1,0x5a},{SIF_TX_DATA2,0x80},{SIF_TX_DATA3,0x0c},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x2f},{SIF_TX_DATA1,0xaa},{SIF_TX_DATA2,0x80},{SIF_TX_DATA3,0x1c},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x30},{SIF_TX_DATA1,0xae},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x88},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x31},{SIF_TX_DATA1,0xb2},{SIF_TX_DATA2,0x80},{SIF_TX_DATA3,0x5a},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0x32},{SIF_TX_DATA1,0xb6},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x01},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x33},{SIF_TX_DATA1,0xba},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x0d},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x34},{SIF_TX_DATA1,0xbe},{SIF_TX_DATA2,0x80},{SIF_TX_DATA3,0x0d},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x35},{SIF_TX_DATA1,0xe2},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x53},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x36},{SIF_TX_DATA1,0xe6},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x12},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0x37},{SIF_TX_DATA1,0x16},{SIF_TX_DATA2,0x81},{SIF_TX_DATA3,0x02},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x38},{SIF_TX_DATA1,0x3e},{SIF_TX_DATA2,0x01},{SIF_TX_DATA3,0x1f},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x39},{SIF_TX_DATA1,0x4a},{SIF_TX_DATA2,0x01},{SIF_TX_DATA3,0x11},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x3a},{SIF_TX_DATA1,0x76},{SIF_TX_DATA2,0x01},{SIF_TX_DATA3,0x43},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x3b},{SIF_TX_DATA1,0x7a},{SIF_TX_DATA2,0x01},{SIF_TX_DATA3,0x02},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0x3c},{SIF_TX_DATA1,0xaa},{SIF_TX_DATA2,0x81},{SIF_TX_DATA3,0x12},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x3d},{SIF_TX_DATA1,0xd2},{SIF_TX_DATA2,0x01},{SIF_TX_DATA3,0x98},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x3e},{SIF_TX_DATA1,0xd6},{SIF_TX_DATA2,0x81},{SIF_TX_DATA3,0x4a},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x3f},{SIF_TX_DATA1,0xda},{SIF_TX_DATA2,0x81},{SIF_TX_DATA3,0x1d},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x40},{SIF_TX_DATA1,0xde},{SIF_TX_DATA2,0x01},{SIF_TX_DATA3,0x0c},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0x41},{SIF_TX_DATA1,0x0a},{SIF_TX_DATA2,0x02},{SIF_TX_DATA3,0x5d},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x42},{SIF_TX_DATA1,0x0e},{SIF_TX_DATA2,0x02},{SIF_TX_DATA3,0x1c},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x43},{SIF_TX_DATA1,0x2e},{SIF_TX_DATA2,0x0c},{SIF_TX_DATA3,0x0f},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x44},{SIF_TX_DATA1,0x32},{SIF_TX_DATA2,0x8c},{SIF_TX_DATA3,0xff},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x45},{SIF_TX_DATA1,0x5a},{SIF_TX_DATA2,0x80},{SIF_TX_DATA3,0x0c},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0x46},{SIF_TX_DATA1,0xaa},{SIF_TX_DATA2,0x80},{SIF_TX_DATA3,0x1c},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x47},{SIF_TX_DATA1,0xae},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x88},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x48},{SIF_TX_DATA1,0xb2},{SIF_TX_DATA2,0x80},{SIF_TX_DATA3,0x5a},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x49},{SIF_TX_DATA1,0xb6},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x01},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x4a},{SIF_TX_DATA1,0xbe},{SIF_TX_DATA2,0x80},{SIF_TX_DATA3,0x0d},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0x4b},{SIF_TX_DATA1,0xe2},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x53},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x4c},{SIF_TX_DATA1,0xe6},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x12},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x4d},{SIF_TX_DATA1,0x16},{SIF_TX_DATA2,0x81},{SIF_TX_DATA3,0x02},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x4e},{SIF_TX_DATA1,0x3e},{SIF_TX_DATA2,0x01},{SIF_TX_DATA3,0x1f},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x4f},{SIF_TX_DATA1,0x4a},{SIF_TX_DATA2,0x01},{SIF_TX_DATA3,0x11},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0x50},{SIF_TX_DATA1,0x76},{SIF_TX_DATA2,0x01},{SIF_TX_DATA3,0x43},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x51},{SIF_TX_DATA1,0x7a},{SIF_TX_DATA2,0x01},{SIF_TX_DATA3,0x02},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x52},{SIF_TX_DATA1,0xaa},{SIF_TX_DATA2,0x81},{SIF_TX_DATA3,0x12},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x53},{SIF_TX_DATA1,0xce},{SIF_TX_DATA2,0x01},{SIF_TX_DATA3,0x81},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x54},{SIF_TX_DATA1,0xd2},{SIF_TX_DATA2,0x01},{SIF_TX_DATA3,0x98},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0x55},{SIF_TX_DATA1,0xd6},{SIF_TX_DATA2,0x81},{SIF_TX_DATA3,0x4a},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x56},{SIF_TX_DATA1,0xda},{SIF_TX_DATA2,0x81},{SIF_TX_DATA3,0x1d},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x57},{SIF_TX_DATA1,0xde},{SIF_TX_DATA2,0x01},{SIF_TX_DATA3,0x0c},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x58},{SIF_TX_DATA1,0x0e},{SIF_TX_DATA2,0x02},{SIF_TX_DATA3,0x1c},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x59},{SIF_TX_DATA1,0x22},{SIF_TX_DATA2,0x88},{SIF_TX_DATA3,0x49},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0x5a},{SIF_TX_DATA1,0x26},{SIF_TX_DATA2,0x08},{SIF_TX_DATA3,0x09},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x5b},{SIF_TX_DATA1,0x2e},{SIF_TX_DATA2,0x08},{SIF_TX_DATA3,0x11},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x5c},{SIF_TX_DATA1,0xa2},{SIF_TX_DATA2,0x88},{SIF_TX_DATA3,0x59},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x5d},{SIF_TX_DATA1,0xa6},{SIF_TX_DATA2,0x08},{SIF_TX_DATA3,0x19},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x5e},{SIF_TX_DATA1,0x2e},{SIF_TX_DATA2,0x0c},{SIF_TX_DATA3,0x0f},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0x5f},{SIF_TX_DATA1,0x32},{SIF_TX_DATA2,0x8c},{SIF_TX_DATA3,0xff},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x60},{SIF_TX_DATA1,0x5a},{SIF_TX_DATA2,0x80},{SIF_TX_DATA3,0x0c},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x61},{SIF_TX_DATA1,0xaa},{SIF_TX_DATA2,0x80},{SIF_TX_DATA3,0x1c},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x62},{SIF_TX_DATA1,0xae},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x88},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x63},{SIF_TX_DATA1,0xb2},{SIF_TX_DATA2,0x80},{SIF_TX_DATA3,0x5a},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0x64},{SIF_TX_DATA1,0xb6},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x01},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x65},{SIF_TX_DATA1,0xbe},{SIF_TX_DATA2,0x80},{SIF_TX_DATA3,0x0d},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x66},{SIF_TX_DATA1,0xe2},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x53},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x67},{SIF_TX_DATA1,0xe6},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x12},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x68},{SIF_TX_DATA1,0x16},{SIF_TX_DATA2,0x81},{SIF_TX_DATA3,0x02},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0x69},{SIF_TX_DATA1,0x3e},{SIF_TX_DATA2,0x01},{SIF_TX_DATA3,0x1f},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x6a},{SIF_TX_DATA1,0x4a},{SIF_TX_DATA2,0x01},{SIF_TX_DATA3,0x11},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x6b},{SIF_TX_DATA1,0x76},{SIF_TX_DATA2,0x01},{SIF_TX_DATA3,0x43},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x6c},{SIF_TX_DATA1,0x7a},{SIF_TX_DATA2,0x01},{SIF_TX_DATA3,0x02},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x6d},{SIF_TX_DATA1,0xaa},{SIF_TX_DATA2,0x81},{SIF_TX_DATA3,0x12},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0x6e},{SIF_TX_DATA1,0xd2},{SIF_TX_DATA2,0x01},{SIF_TX_DATA3,0x98},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x6f},{SIF_TX_DATA1,0xd6},{SIF_TX_DATA2,0x81},{SIF_TX_DATA3,0x4a},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x70},{SIF_TX_DATA1,0xda},{SIF_TX_DATA2,0x81},{SIF_TX_DATA3,0x1d},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x71},{SIF_TX_DATA1,0xde},{SIF_TX_DATA2,0x01},{SIF_TX_DATA3,0x0c},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x72},{SIF_TX_DATA1,0x0e},{SIF_TX_DATA2,0x02},{SIF_TX_DATA3,0x1c},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0x73},{SIF_TX_DATA1,0x2a},{SIF_TX_DATA2,0x0c},{SIF_TX_DATA3,0x4f},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x74},{SIF_TX_DATA1,0x2e},{SIF_TX_DATA2,0x8c},{SIF_TX_DATA3,0x1e},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x75},{SIF_TX_DATA1,0x32},{SIF_TX_DATA2,0x8c},{SIF_TX_DATA3,0xff},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x76},{SIF_TX_DATA1,0x5a},{SIF_TX_DATA2,0x80},{SIF_TX_DATA3,0x0c},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x77},{SIF_TX_DATA1,0xaa},{SIF_TX_DATA2,0x80},{SIF_TX_DATA3,0x1c},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0x78},{SIF_TX_DATA1,0xae},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x88},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x79},{SIF_TX_DATA1,0xb2},{SIF_TX_DATA2,0x80},{SIF_TX_DATA3,0x5a},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x7a},{SIF_TX_DATA1,0xb6},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x01},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x7b},{SIF_TX_DATA1,0xbe},{SIF_TX_DATA2,0x80},{SIF_TX_DATA3,0x0d},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x7c},{SIF_TX_DATA1,0xe2},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x53},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0x7d},{SIF_TX_DATA1,0xe6},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x12},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x7e},{SIF_TX_DATA1,0x16},{SIF_TX_DATA2,0x81},{SIF_TX_DATA3,0x02},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x7f},{SIF_TX_DATA1,0x3e},{SIF_TX_DATA2,0x01},{SIF_TX_DATA3,0x1f},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x80},{SIF_TX_DATA1,0x4a},{SIF_TX_DATA2,0x01},{SIF_TX_DATA3,0x11},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x81},{SIF_TX_DATA1,0x76},{SIF_TX_DATA2,0x01},{SIF_TX_DATA3,0x43},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0x82},{SIF_TX_DATA1,0x7a},{SIF_TX_DATA2,0x01},{SIF_TX_DATA3,0x02},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x83},{SIF_TX_DATA1,0xaa},{SIF_TX_DATA2,0x81},{SIF_TX_DATA3,0x12},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x84},{SIF_TX_DATA1,0xd2},{SIF_TX_DATA2,0x01},{SIF_TX_DATA3,0x98},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x85},{SIF_TX_DATA1,0xd6},{SIF_TX_DATA2,0x81},{SIF_TX_DATA3,0x4a},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x86},{SIF_TX_DATA1,0xda},{SIF_TX_DATA2,0x81},{SIF_TX_DATA3,0x1d},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0x87},{SIF_TX_DATA1,0xde},{SIF_TX_DATA2,0x01},{SIF_TX_DATA3,0x0c},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x88},{SIF_TX_DATA1,0x0e},{SIF_TX_DATA2,0x02},{SIF_TX_DATA3,0x1c},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x89},{SIF_TX_DATA1,0x2e},{SIF_TX_DATA2,0x0c},{SIF_TX_DATA3,0x0f},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x8a},{SIF_TX_DATA1,0x32},{SIF_TX_DATA2,0x8c},{SIF_TX_DATA3,0xff},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x8b},{SIF_TX_DATA1,0x5a},{SIF_TX_DATA2,0x80},{SIF_TX_DATA3,0x0c},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0x8c},{SIF_TX_DATA1,0xaa},{SIF_TX_DATA2,0x80},{SIF_TX_DATA3,0x1c},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x8d},{SIF_TX_DATA1,0xae},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x88},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x8e},{SIF_TX_DATA1,0xb2},{SIF_TX_DATA2,0x80},{SIF_TX_DATA3,0x5a},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x8f},{SIF_TX_DATA1,0xb6},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x01},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x90},{SIF_TX_DATA1,0xbe},{SIF_TX_DATA2,0x80},{SIF_TX_DATA3,0x0d},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0x91},{SIF_TX_DATA1,0xe2},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x53},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x92},{SIF_TX_DATA1,0xe6},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x12},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x93},{SIF_TX_DATA1,0x16},{SIF_TX_DATA2,0x81},{SIF_TX_DATA3,0x02},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x94},{SIF_TX_DATA1,0x3e},{SIF_TX_DATA2,0x01},{SIF_TX_DATA3,0x1f},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x95},{SIF_TX_DATA1,0x4a},{SIF_TX_DATA2,0x01},{SIF_TX_DATA3,0x11},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0x96},{SIF_TX_DATA1,0x76},{SIF_TX_DATA2,0x01},{SIF_TX_DATA3,0x43},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x97},{SIF_TX_DATA1,0x7a},{SIF_TX_DATA2,0x01},{SIF_TX_DATA3,0x02},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x98},{SIF_TX_DATA1,0xaa},{SIF_TX_DATA2,0x81},{SIF_TX_DATA3,0x12},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x99},{SIF_TX_DATA1,0xd2},{SIF_TX_DATA2,0x01},{SIF_TX_DATA3,0x98},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x9a},{SIF_TX_DATA1,0xd6},{SIF_TX_DATA2,0x81},{SIF_TX_DATA3,0x4a},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0x9b},{SIF_TX_DATA1,0xda},{SIF_TX_DATA2,0x81},{SIF_TX_DATA3,0x1d},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x9c},{SIF_TX_DATA1,0xde},{SIF_TX_DATA2,0x01},{SIF_TX_DATA3,0x0c},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x9d},{SIF_TX_DATA1,0x0e},{SIF_TX_DATA2,0x02},{SIF_TX_DATA3,0x1c},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x9e},{SIF_TX_DATA1,0x2a},{SIF_TX_DATA2,0x0c},{SIF_TX_DATA3,0x5d},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x9f},{SIF_TX_DATA1,0x2e},{SIF_TX_DATA2,0x0c},{SIF_TX_DATA3,0x0f},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0xa0},{SIF_TX_DATA1,0x32},{SIF_TX_DATA2,0x8c},{SIF_TX_DATA3,0xff},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xa1},{SIF_TX_DATA1,0x02},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xa2},{SIF_TX_DATA1,0x02},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xa3},{SIF_TX_DATA1,0x02},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xa4},{SIF_TX_DATA1,0x02},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0xa5},{SIF_TX_DATA1,0x02},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xa6},{SIF_TX_DATA1,0x02},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xa7},{SIF_TX_DATA1,0x02},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xa8},{SIF_TX_DATA1,0x02},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xa9},{SIF_TX_DATA1,0x02},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0xaa},{SIF_TX_DATA1,0x02},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xab},{SIF_TX_DATA1,0x02},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xac},{SIF_TX_DATA1,0x02},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xad},{SIF_TX_DATA1,0x02},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xae},{SIF_TX_DATA1,0x02},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0xaf},{SIF_TX_DATA1,0x02},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xb0},{SIF_TX_DATA1,0x02},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xb1},{SIF_TX_DATA1,0x02},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xb2},{SIF_TX_DATA1,0x02},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xb3},{SIF_TX_DATA1,0x02},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0xb4},{SIF_TX_DATA1,0x02},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xb5},{SIF_TX_DATA1,0x02},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xb6},{SIF_TX_DATA1,0x02},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xb7},{SIF_TX_DATA1,0x02},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xb8},{SIF_TX_DATA1,0x02},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0xb9},{SIF_TX_DATA1,0x02},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xba},{SIF_TX_DATA1,0x02},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xbb},{SIF_TX_DATA1,0x02},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xbc},{SIF_TX_DATA1,0x02},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xbd},{SIF_TX_DATA1,0x02},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0xbe},{SIF_TX_DATA1,0x02},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xbf},{SIF_TX_DATA1,0x02},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xc0},{SIF_TX_DATA1,0x02},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xc1},{SIF_TX_DATA1,0x02},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xc2},{SIF_TX_DATA1,0x02},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0xc3},{SIF_TX_DATA1,0x02},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xc4},{SIF_TX_DATA1,0x02},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xc5},{SIF_TX_DATA1,0x02},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xc6},{SIF_TX_DATA1,0x02},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xc7},{SIF_TX_DATA1,0x02},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0xc8},{SIF_TX_DATA1,0x02},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xc9},{SIF_TX_DATA1,0x02},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xca},{SIF_TX_DATA1,0x02},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xcb},{SIF_TX_DATA1,0x02},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xcc},{SIF_TX_DATA1,0x02},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0xcd},{SIF_TX_DATA1,0x02},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xce},{SIF_TX_DATA1,0x02},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xcf},{SIF_TX_DATA1,0x02},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xd0},{SIF_TX_DATA1,0x02},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xd1},{SIF_TX_DATA1,0x02},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0xd2},{SIF_TX_DATA1,0x02},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xd3},{SIF_TX_DATA1,0x02},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xd4},{SIF_TX_DATA1,0x02},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xd5},{SIF_TX_DATA1,0x02},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xd6},{SIF_TX_DATA1,0x02},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0xd7},{SIF_TX_DATA1,0x02},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xd8},{SIF_TX_DATA1,0x02},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xd9},{SIF_TX_DATA1,0x02},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xda},{SIF_TX_DATA1,0x02},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xdb},{SIF_TX_DATA1,0x02},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0xdc},{SIF_TX_DATA1,0x02},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xdd},{SIF_TX_DATA1,0x02},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xde},{SIF_TX_DATA1,0x02},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xdf},{SIF_TX_DATA1,0x02},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xe0},{SIF_TX_DATA1,0x02},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0xe1},{SIF_TX_DATA1,0x02},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xe2},{SIF_TX_DATA1,0x02},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xe3},{SIF_TX_DATA1,0x02},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xe4},{SIF_TX_DATA1,0x02},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xe5},{SIF_TX_DATA1,0x02},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0xe6},{SIF_TX_DATA1,0x02},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xe7},{SIF_TX_DATA1,0x02},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xe8},{SIF_TX_DATA1,0x02},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xe9},{SIF_TX_DATA1,0x02},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xea},{SIF_TX_DATA1,0x02},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0xeb},{SIF_TX_DATA1,0x02},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xec},{SIF_TX_DATA1,0x02},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xed},{SIF_TX_DATA1,0x02},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xee},{SIF_TX_DATA1,0x02},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xef},{SIF_TX_DATA1,0x02},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0xf0},{SIF_TX_DATA1,0x02},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xf1},{SIF_TX_DATA1,0x02},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xf2},{SIF_TX_DATA1,0x02},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xf3},{SIF_TX_DATA1,0x02},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xf4},{SIF_TX_DATA1,0x02},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0xf5},{SIF_TX_DATA1,0x02},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xf6},{SIF_TX_DATA1,0x02},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xf7},{SIF_TX_DATA1,0x02},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xf8},{SIF_TX_DATA1,0x02},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xf9},{SIF_TX_DATA1,0x02},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0xfa},{SIF_TX_DATA1,0x02},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xfb},{SIF_TX_DATA1,0x02},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xfc},{SIF_TX_DATA1,0x02},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xfd},{SIF_TX_DATA1,0x02},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xfe},{SIF_TX_DATA1,0x02},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0xff},{SIF_TX_DATA1,0x02},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x00},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x01},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x02},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x03},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0x04},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x05},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x06},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x07},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x08},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0x09},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x0a},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x0b},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x0c},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x0d},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0x0e},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x0f},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x10},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x11},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x12},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0x13},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x14},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x15},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x16},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x17},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0x18},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x19},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x1a},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x1b},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x1c},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0x1d},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x1e},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x1f},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x20},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x21},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0x22},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x23},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x24},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x25},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x26},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0x27},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x28},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x29},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x2a},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x2b},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0x2c},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x2d},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x2e},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x2f},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x30},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0x31},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x32},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x33},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x34},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x35},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0x36},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x37},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x38},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x39},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x3a},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0x3b},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x3c},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x3d},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x3e},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x3f},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0x40},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x41},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x42},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x43},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x44},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0x45},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x46},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x47},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x48},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x49},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0x4a},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x4b},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x4c},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x4d},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x4e},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0x4f},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x50},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x51},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x52},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x53},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0x54},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x55},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x56},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x57},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x58},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0x59},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x5a},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x5b},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x5c},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x5d},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0x5e},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x5f},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x60},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x61},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x62},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0x63},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x64},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x65},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x66},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x67},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0x68},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x69},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x6a},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x6b},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x6c},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0x6d},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x6e},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x6f},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x70},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x71},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0x72},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x73},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x74},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x75},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x76},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0x77},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x78},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x79},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x7a},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x7b},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0x7c},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x7d},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x7e},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x7f},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x80},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0x81},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x82},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x83},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x84},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x85},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0x86},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x87},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x88},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x89},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x8a},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0x8b},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x8c},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x8d},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x8e},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x8f},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0x90},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x91},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x92},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x93},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x94},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0x95},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x96},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x97},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x98},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x99},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0x9a},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x9b},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x9c},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x9d},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x9e},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0x9f},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xa0},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xa1},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xa2},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xa3},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0xa4},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xa5},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xa6},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xa7},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xa8},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0xa9},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xaa},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xab},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xac},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xad},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0xae},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xaf},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xb0},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xb1},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xb2},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0xb3},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xb4},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xb5},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xb6},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xb7},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0xb8},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xb9},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xba},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xbb},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xbc},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0xbd},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xbe},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xbf},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xc0},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xc1},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0xc2},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xc3},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xc4},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xc5},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xc6},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0xc7},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xc8},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xc9},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xca},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xcb},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0xcc},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xcd},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xce},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xcf},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xd0},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0xd1},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xd2},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xd3},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xd4},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xd5},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0xd6},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xd7},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xd8},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xd9},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xda},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0xdb},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xdc},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xdd},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xde},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xdf},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0xe0},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xe1},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xe2},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xe3},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xe4},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0xe5},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xe6},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xe7},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xe8},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xe9},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0xea},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xeb},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xec},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xed},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xee},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0xef},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xf0},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xf1},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xf2},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xf3},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0xf4},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xf5},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xf6},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xf7},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xf8},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0xf9},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xfa},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xfb},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xfc},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xfd},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0xfe},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xff},{SIF_TX_DATA1,0x03},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x00},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x01},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x02},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0x03},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x04},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x05},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x06},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x07},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0x08},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x09},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x0a},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x0b},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x0c},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0x0d},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x0e},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x0f},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x10},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x11},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0x12},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x13},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x14},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x15},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x16},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0x17},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x18},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x19},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x1a},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x1b},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0x1c},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x1d},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x1e},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x1f},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x20},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0x21},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x22},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x23},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x24},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x25},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0x26},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x27},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x28},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x29},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x2a},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0x2b},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x2c},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x2d},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x2e},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x2f},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0x30},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x31},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x32},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x33},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x34},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0x35},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x36},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x37},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x38},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x39},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0x3a},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x3b},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x3c},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x3d},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x3e},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0x3f},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x40},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x41},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x42},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x43},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0x44},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x45},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x46},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x47},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x48},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0x49},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x4a},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x4b},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x4c},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x4d},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0x4e},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x4f},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x50},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x51},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x52},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0x53},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x54},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x55},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x56},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x57},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0x58},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x59},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x5a},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x5b},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x5c},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0x5d},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x5e},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x5f},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x60},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x61},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0x62},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x63},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x64},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x65},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x66},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0x67},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x68},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x69},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x6a},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x6b},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0x6c},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x6d},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x6e},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x6f},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x70},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0x71},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x72},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x73},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x74},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x75},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0x76},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x77},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x78},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x79},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x7a},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0x7b},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x7c},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x7d},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x7e},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x7f},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0x80},{SIF_TX_DATA1,0x05},{SIF_TX_DATA2,0x40},{SIF_TX_DATA3,0x06},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x81},{SIF_TX_DATA1,0x05},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x88},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x82},{SIF_TX_DATA1,0x05},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x98},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x83},{SIF_TX_DATA1,0x25},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x18},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x84},{SIF_TX_DATA1,0x29},{SIF_TX_DATA2,0x40},{SIF_TX_DATA3,0x11},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0x85},{SIF_TX_DATA1,0x2d},{SIF_TX_DATA2,0x80},{SIF_TX_DATA3,0x1d},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x86},{SIF_TX_DATA1,0x3d},{SIF_TX_DATA2,0xc0},{SIF_TX_DATA3,0x22},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x87},{SIF_TX_DATA1,0x41},{SIF_TX_DATA2,0x80},{SIF_TX_DATA3,0x0b},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x88},{SIF_TX_DATA1,0x35},{SIF_TX_DATA2,0x08},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x89},{SIF_TX_DATA1,0x35},{SIF_TX_DATA2,0x08},{SIF_TX_DATA3,0xf8},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0x8a},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x8b},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x8c},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x8d},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x8e},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0x8f},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x90},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x91},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x92},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x93},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0x94},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x95},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x96},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x97},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x98},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0x99},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x9a},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x9b},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x9c},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x9d},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0x9e},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0x9f},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xa0},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xa1},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xa2},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0xa3},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xa4},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xa5},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xa6},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xa7},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0xa8},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xa9},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xaa},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xab},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xac},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0xad},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xae},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xaf},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xb0},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xb1},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0xb2},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xb3},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xb4},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xb5},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xb6},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0xb7},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xb8},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xb9},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xba},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xbb},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0xbc},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xbd},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xbe},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xbf},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xc0},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0xc1},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xc2},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xc3},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xc4},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xc5},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0xc6},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xc7},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xc8},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xc9},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xca},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0xcb},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xcc},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xcd},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xce},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xcf},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0xd0},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xd1},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xd2},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xd3},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xd4},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0xd5},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xd6},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xd7},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xd8},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xd9},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0xda},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xdb},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xdc},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xdd},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xde},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0xdf},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xe0},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xe1},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xe2},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xe3},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0xe4},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xe5},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xe6},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xe7},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xe8},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0xe9},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xea},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xeb},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xec},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xed},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0xee},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xef},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xf0},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xf1},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xf2},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0xf3},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xf4},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xf5},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xf6},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xf7},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0xf8},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xf9},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xfa},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xfb},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xfc},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S2,0xfd},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xfe},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xff},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
	{END_REG,0x00}  
  };
#endif

/*
unsigned char SPI32_I2C[]= {
	0x00,0x5a,0x80,0x0c, // 0x005a 800c
	0x01,0xaa,0x80,0x1c,
	0x02,0xae,0x00,0x88, // 0x02ae 
	0x03,0xb2,0x80,0x5a,
	0x04,0xb6,0x00,0x01,

	0x05,0xba,0x00,0x0d,0x06,0xbe,0x80,0x0d,0x07,0xe2,0x00,0x53,0x08,0xe6,0x00,0x12,0x09,0x16,0x81,0x02,
	0x0a,0x3e,0x01,0x1f,0x0b,0x4a,0x01,0x11,0x0c,0x76,0x01,0x43,0x0d,0x7a,0x01,0x02,0x0e,0xaa,0x81,0x12,
	0x0f,0xd2,0x01,0x98,0x10,0xd6,0x81,0x4a,0x11,0xda,0x81,0x1d,0x12,0xde,0x01,0x0c,0x13,0x0a,0x02,0x5d,
	0x14,0x0e,0x02,0x1c,0x15,0x26,0x0c,0x8d,0x16,0x2a,0x0c,0x4f,0x17,0x2e,0x8c,0x0e,0x18,0x32,0x8c,0xff,
	0x19,0x5a,0x80,0x0c,0x1a,0xaa,0x80,0x1c,0x1b,0xae,0x00,0x88,0x1c,0xb2,0x80,0x5a,0x1d,0xb6,0x00,0x01,
	0x1e,0xbe,0x80,0x0d,0x1f,0xe2,0x00,0x53,0x20,0xe6,0x00,0x12,0x21,0x16,0x81,0x02,0x22,0x3e,0x01,0x1f,
	0x23,0x4a,0x01,0x11,0x24,0x76,0x01,0x43,0x25,0x7a,0x01,0x02,0x26,0xaa,0x81,0x12,0x27,0xd2,0x01,0x98,
	0x28,0xd6,0x81,0x4a,0x29,0xda,0x81,0x1d,0x2a,0xde,0x01,0x0c,0x2b,0x0e,0x02,0x1c,0x2c,0x2e,0x0c,0x0f,
	0x2d,0x32,0x8c,0xff,0x2e,0x5a,0x80,0x0c,0x2f,0xaa,0x80,0x1c,0x30,0xae,0x00,0x88,0x31,0xb2,0x80,0x5a,
	0x32,0xb6,0x00,0x01,0x33,0xba,0x00,0x0d,0x34,0xbe,0x80,0x0d,0x35,0xe2,0x00,0x53,0x36,0xe6,0x00,0x12,
	0x37,0x16,0x81,0x02,0x38,0x3e,0x01,0x1f,0x39,0x4a,0x01,0x11,0x3a,0x76,0x01,0x43,0x3b,0x7a,0x01,0x02,
	0x3c,0xaa,0x81,0x12,0x3d,0xd2,0x01,0x98,0x3e,0xd6,0x81,0x4a,0x3f,0xda,0x81,0x1d,0x40,0xde,0x01,0x0c,
	0x41,0x0a,0x02,0x5d,0x42,0x0e,0x02,0x1c,0x43,0x2e,0x0c,0x0f,0x44,0x32,0x8c,0xff,0x45,0x5a,0x80,0x0c,
	0x46,0xaa,0x80,0x1c,0x47,0xae,0x00,0x88,0x48,0xb2,0x80,0x5a,0x49,0xb6,0x00,0x01,0x4a,0xbe,0x80,0x0d,
	0x4b,0xe2,0x00,0x53,0x4c,0xe6,0x00,0x12,0x4d,0x16,0x81,0x02,0x4e,0x3e,0x01,0x1f,0x4f,0x4a,0x01,0x11,
	0x50,0x76,0x01,0x43,0x51,0x7a,0x01,0x02,0x52,0xaa,0x81,0x12,0x53,0xce,0x01,0x81,0x54,0xd2,0x01,0x98,
	0x55,0xd6,0x81,0x4a,0x56,0xda,0x81,0x1d,0x57,0xde,0x01,0x0c,0x58,0x0e,0x02,0x1c,0x59,0x22,0x88,0x49,
	0x5a,0x26,0x08,0x09,0x5b,0x2e,0x08,0x11,0x5c,0xa2,0x88,0x59,0x5d,0xa6,0x08,0x19,0x5e,0x2e,0x0c,0x0f,
	0x5f,0x32,0x8c,0xff,0x60,0x5a,0x80,0x0c,0x61,0xaa,0x80,0x1c,0x62,0xae,0x00,0x88,0x63,0xb2,0x80,0x5a,
	0x64,0xb6,0x00,0x01,0x65,0xbe,0x80,0x0d,0x66,0xe2,0x00,0x53,0x67,0xe6,0x00,0x12,0x68,0x16,0x81,0x02,
	0x69,0x3e,0x01,0x1f,0x6a,0x4a,0x01,0x11,0x6b,0x76,0x01,0x43,0x6c,0x7a,0x01,0x02,0x6d,0xaa,0x81,0x12,
	0x6e,0xd2,0x01,0x98,0x6f,0xd6,0x81,0x4a,0x70,0xda,0x81,0x1d,0x71,0xde,0x01,0x0c,0x72,0x0e,0x02,0x1c,
	0x73,0x2a,0x0c,0x4f,0x74,0x2e,0x8c,0x1e,0x75,0x32,0x8c,0xff,0x76,0x5a,0x80,0x0c,0x77,0xaa,0x80,0x1c,
	0x78,0xae,0x00,0x88,0x79,0xb2,0x80,0x5a,0x7a,0xb6,0x00,0x01,0x7b,0xbe,0x80,0x0d,0x7c,0xe2,0x00,0x53,
	0x7d,0xe6,0x00,0x12,0x7e,0x16,0x81,0x02,0x7f,0x3e,0x01,0x1f,0x80,0x4a,0x01,0x11,0x81,0x76,0x01,0x43,
	0x82,0x7a,0x01,0x02,0x83,0xaa,0x81,0x12,0x84,0xd2,0x01,0x98,0x85,0xd6,0x81,0x4a,0x86,0xda,0x81,0x1d,
	0x87,0xde,0x01,0x0c,0x88,0x0e,0x02,0x1c,0x89,0x2e,0x0c,0x0f,0x8a,0x32,0x8c,0xff,0x8b,0x5a,0x80,0x0c,
	0x8c,0xaa,0x80,0x1c,0x8d,0xae,0x00,0x88,0x8e,0xb2,0x80,0x5a,0x8f,0xb6,0x00,0x01,0x90,0xbe,0x80,0x0d,
	0x91,0xe2,0x00,0x53,0x92,0xe6,0x00,0x12,0x93,0x16,0x81,0x02,0x94,0x3e,0x01,0x1f,0x95,0x4a,0x01,0x11,
	0x96,0x76,0x01,0x43,0x97,0x7a,0x01,0x02,0x98,0xaa,0x81,0x12,0x99,0xd2,0x01,0x98,0x9a,0xd6,0x81,0x4a,
	0x9b,0xda,0x81,0x1d,0x9c,0xde,0x01,0x0c,0x9d,0x0e,0x02,0x1c,0x9e,0x2a,0x0c,0x5d,0x9f,0x2e,0x0c,0x0f,
	0xa0,0x32,0x8c,0xff,0xa1,0x02,0x00,0x00,0xa2,0x02,0x00,0x00,0xa3,0x02,0x00,0x00,0xa4,0x02,0x00,0x00,
	0xa5,0x02,0x00,0x00,0xa6,0x02,0x00,0x00,0xa7,0x02,0x00,0x00,0xa8,0x02,0x00,0x00,0xa9,0x02,0x00,0x00,
	0xaa,0x02,0x00,0x00,0xab,0x02,0x00,0x00,0xac,0x02,0x00,0x00,0xad,0x02,0x00,0x00,0xae,0x02,0x00,0x00,
	0xaf,0x02,0x00,0x00,0xb0,0x02,0x00,0x00,0xb1,0x02,0x00,0x00,0xb2,0x02,0x00,0x00,0xb3,0x02,0x00,0x00,
	0xb4,0x02,0x00,0x00,0xb5,0x02,0x00,0x00,0xb6,0x02,0x00,0x00,0xb7,0x02,0x00,0x00,0xb8,0x02,0x00,0x00,
	0xb9,0x02,0x00,0x00,0xba,0x02,0x00,0x00,0xbb,0x02,0x00,0x00,0xbc,0x02,0x00,0x00,0xbd,0x02,0x00,0x00,
	0xbe,0x02,0x00,0x00,0xbf,0x02,0x00,0x00,0xc0,0x02,0x00,0x00,0xc1,0x02,0x00,0x00,0xc2,0x02,0x00,0x00,
	0xc3,0x02,0x00,0x00,0xc4,0x02,0x00,0x00,0xc5,0x02,0x00,0x00,0xc6,0x02,0x00,0x00,0xc7,0x02,0x00,0x00,
	0xc8,0x02,0x00,0x00,0xc9,0x02,0x00,0x00,0xca,0x02,0x00,0x00,0xcb,0x02,0x00,0x00,0xcc,0x02,0x00,0x00,
	0xcd,0x02,0x00,0x00,0xce,0x02,0x00,0x00,0xcf,0x02,0x00,0x00,0xd0,0x02,0x00,0x00,0xd1,0x02,0x00,0x00,
	0xd2,0x02,0x00,0x00,0xd3,0x02,0x00,0x00,0xd4,0x02,0x00,0x00,0xd5,0x02,0x00,0x00,0xd6,0x02,0x00,0x00,
	0xd7,0x02,0x00,0x00,0xd8,0x02,0x00,0x00,0xd9,0x02,0x00,0x00,0xda,0x02,0x00,0x00,0xdb,0x02,0x00,0x00,
	0xdc,0x02,0x00,0x00,0xdd,0x02,0x00,0x00,0xde,0x02,0x00,0x00,0xdf,0x02,0x00,0x00,0xe0,0x02,0x00,0x00,
	0xe1,0x02,0x00,0x00,0xe2,0x02,0x00,0x00,0xe3,0x02,0x00,0x00,0xe4,0x02,0x00,0x00,0xe5,0x02,0x00,0x00,
	0xe6,0x02,0x00,0x00,0xe7,0x02,0x00,0x00,0xe8,0x02,0x00,0x00,0xe9,0x02,0x00,0x00,0xea,0x02,0x00,0x00,
	0xeb,0x02,0x00,0x00,0xec,0x02,0x00,0x00,0xed,0x02,0x00,0x00,0xee,0x02,0x00,0x00,0xef,0x02,0x00,0x00,
	0xf0,0x02,0x00,0x00,0xf1,0x02,0x00,0x00,0xf2,0x02,0x00,0x00,0xf3,0x02,0x00,0x00,0xf4,0x02,0x00,0x00,
	0xf5,0x02,0x00,0x00,0xf6,0x02,0x00,0x00,0xf7,0x02,0x00,0x00,0xf8,0x02,0x00,0x00,0xf9,0x02,0x00,0x00,
	0xfa,0x02,0x00,0x00,0xfb,0x02,0x00,0x00,0xfc,0x02,0x00,0x00,0xfd,0x02,0x00,0x00,0xfe,0x02,0x00,0x00,
	0xff,0x02,0x00,0x00,0x00,0x03,0x00,0x00,0x01,0x03,0x00,0x00,0x02,0x03,0x00,0x00,0x03,0x03,0x00,0x00,
	0x04,0x03,0x00,0x00,0x05,0x03,0x00,0x00,0x06,0x03,0x00,0x00,0x07,0x03,0x00,0x00,0x08,0x03,0x00,0x00,
	0x09,0x03,0x00,0x00,0x0a,0x03,0x00,0x00,0x0b,0x03,0x00,0x00,0x0c,0x03,0x00,0x00,0x0d,0x03,0x00,0x00,
	0x0e,0x03,0x00,0x00,0x0f,0x03,0x00,0x00,0x10,0x03,0x00,0x00,0x11,0x03,0x00,0x00,0x12,0x03,0x00,0x00,
	0x13,0x03,0x00,0x00,0x14,0x03,0x00,0x00,0x15,0x03,0x00,0x00,0x16,0x03,0x00,0x00,0x17,0x03,0x00,0x00,
	0x18,0x03,0x00,0x00,0x19,0x03,0x00,0x00,0x1a,0x03,0x00,0x00,0x1b,0x03,0x00,0x00,0x1c,0x03,0x00,0x00,
	0x1d,0x03,0x00,0x00,0x1e,0x03,0x00,0x00,0x1f,0x03,0x00,0x00,0x20,0x03,0x00,0x00,0x21,0x03,0x00,0x00,
	0x22,0x03,0x00,0x00,0x23,0x03,0x00,0x00,0x24,0x03,0x00,0x00,0x25,0x03,0x00,0x00,0x26,0x03,0x00,0x00,
	0x27,0x03,0x00,0x00,0x28,0x03,0x00,0x00,0x29,0x03,0x00,0x00,0x2a,0x03,0x00,0x00,0x2b,0x03,0x00,0x00,
	0x2c,0x03,0x00,0x00,0x2d,0x03,0x00,0x00,0x2e,0x03,0x00,0x00,0x2f,0x03,0x00,0x00,0x30,0x03,0x00,0x00,
	0x31,0x03,0x00,0x00,0x32,0x03,0x00,0x00,0x33,0x03,0x00,0x00,0x34,0x03,0x00,0x00,0x35,0x03,0x00,0x00,
	0x36,0x03,0x00,0x00,0x37,0x03,0x00,0x00,0x38,0x03,0x00,0x00,0x39,0x03,0x00,0x00,0x3a,0x03,0x00,0x00,
	0x3b,0x03,0x00,0x00,0x3c,0x03,0x00,0x00,0x3d,0x03,0x00,0x00,0x3e,0x03,0x00,0x00,0x3f,0x03,0x00,0x00,
	0x40,0x03,0x00,0x00,0x41,0x03,0x00,0x00,0x42,0x03,0x00,0x00,0x43,0x03,0x00,0x00,0x44,0x03,0x00,0x00,
	0x45,0x03,0x00,0x00,0x46,0x03,0x00,0x00,0x47,0x03,0x00,0x00,0x48,0x03,0x00,0x00,0x49,0x03,0x00,0x00,
	0x4a,0x03,0x00,0x00,0x4b,0x03,0x00,0x00,0x4c,0x03,0x00,0x00,0x4d,0x03,0x00,0x00,0x4e,0x03,0x00,0x00,
	0x4f,0x03,0x00,0x00,0x50,0x03,0x00,0x00,0x51,0x03,0x00,0x00,0x52,0x03,0x00,0x00,0x53,0x03,0x00,0x00,
	0x54,0x03,0x00,0x00,0x55,0x03,0x00,0x00,0x56,0x03,0x00,0x00,0x57,0x03,0x00,0x00,0x58,0x03,0x00,0x00,
	0x59,0x03,0x00,0x00,0x5a,0x03,0x00,0x00,0x5b,0x03,0x00,0x00,0x5c,0x03,0x00,0x00,0x5d,0x03,0x00,0x00,
	0x5e,0x03,0x00,0x00,0x5f,0x03,0x00,0x00,0x60,0x03,0x00,0x00,0x61,0x03,0x00,0x00,0x62,0x03,0x00,0x00,
	0x63,0x03,0x00,0x00,0x64,0x03,0x00,0x00,0x65,0x03,0x00,0x00,0x66,0x03,0x00,0x00,0x67,0x03,0x00,0x00,
	0x68,0x03,0x00,0x00,0x69,0x03,0x00,0x00,0x6a,0x03,0x00,0x00,0x6b,0x03,0x00,0x00,0x6c,0x03,0x00,0x00,
	0x6d,0x03,0x00,0x00,0x6e,0x03,0x00,0x00,0x6f,0x03,0x00,0x00,0x70,0x03,0x00,0x00,0x71,0x03,0x00,0x00,
	0x72,0x03,0x00,0x00,0x73,0x03,0x00,0x00,0x74,0x03,0x00,0x00,0x75,0x03,0x00,0x00,0x76,0x03,0x00,0x00,
	0x77,0x03,0x00,0x00,0x78,0x03,0x00,0x00,0x79,0x03,0x00,0x00,0x7a,0x03,0x00,0x00,0x7b,0x03,0x00,0x00,
	0x7c,0x03,0x00,0x00,0x7d,0x03,0x00,0x00,0x7e,0x03,0x00,0x00,0x7f,0x03,0x00,0x00,0x80,0x03,0x00,0x00,
	0x81,0x03,0x00,0x00,0x82,0x03,0x00,0x00,0x83,0x03,0x00,0x00,0x84,0x03,0x00,0x00,0x85,0x03,0x00,0x00,
	0x86,0x03,0x00,0x00,0x87,0x03,0x00,0x00,0x88,0x03,0x00,0x00,0x89,0x03,0x00,0x00,0x8a,0x03,0x00,0x00,
	0x8b,0x03,0x00,0x00,0x8c,0x03,0x00,0x00,0x8d,0x03,0x00,0x00,0x8e,0x03,0x00,0x00,0x8f,0x03,0x00,0x00,
	0x90,0x03,0x00,0x00,0x91,0x03,0x00,0x00,0x92,0x03,0x00,0x00,0x93,0x03,0x00,0x00,0x94,0x03,0x00,0x00,
	0x95,0x03,0x00,0x00,0x96,0x03,0x00,0x00,0x97,0x03,0x00,0x00,0x98,0x03,0x00,0x00,0x99,0x03,0x00,0x00,
	0x9a,0x03,0x00,0x00,0x9b,0x03,0x00,0x00,0x9c,0x03,0x00,0x00,0x9d,0x03,0x00,0x00,0x9e,0x03,0x00,0x00,
	0x9f,0x03,0x00,0x00,0xa0,0x03,0x00,0x00,0xa1,0x03,0x00,0x00,0xa2,0x03,0x00,0x00,0xa3,0x03,0x00,0x00,
	0xa4,0x03,0x00,0x00,0xa5,0x03,0x00,0x00,0xa6,0x03,0x00,0x00,0xa7,0x03,0x00,0x00,0xa8,0x03,0x00,0x00,
	0xa9,0x03,0x00,0x00,0xaa,0x03,0x00,0x00,0xab,0x03,0x00,0x00,0xac,0x03,0x00,0x00,0xad,0x03,0x00,0x00,
	0xae,0x03,0x00,0x00,0xaf,0x03,0x00,0x00,0xb0,0x03,0x00,0x00,0xb1,0x03,0x00,0x00,0xb2,0x03,0x00,0x00,
	0xb3,0x03,0x00,0x00,0xb4,0x03,0x00,0x00,0xb5,0x03,0x00,0x00,0xb6,0x03,0x00,0x00,0xb7,0x03,0x00,0x00,
	0xb8,0x03,0x00,0x00,0xb9,0x03,0x00,0x00,0xba,0x03,0x00,0x00,0xbb,0x03,0x00,0x00,0xbc,0x03,0x00,0x00,
	0xbd,0x03,0x00,0x00,0xbe,0x03,0x00,0x00,0xbf,0x03,0x00,0x00,0xc0,0x03,0x00,0x00,0xc1,0x03,0x00,0x00,
	0xc2,0x03,0x00,0x00,0xc3,0x03,0x00,0x00,0xc4,0x03,0x00,0x00,0xc5,0x03,0x00,0x00,0xc6,0x03,0x00,0x00,
	0xc7,0x03,0x00,0x00,0xc8,0x03,0x00,0x00,0xc9,0x03,0x00,0x00,0xca,0x03,0x00,0x00,0xcb,0x03,0x00,0x00,
	0xcc,0x03,0x00,0x00,0xcd,0x03,0x00,0x00,0xce,0x03,0x00,0x00,0xcf,0x03,0x00,0x00,0xd0,0x03,0x00,0x00,
	0xd1,0x03,0x00,0x00,0xd2,0x03,0x00,0x00,0xd3,0x03,0x00,0x00,0xd4,0x03,0x00,0x00,0xd5,0x03,0x00,0x00,
	0xd6,0x03,0x00,0x00,0xd7,0x03,0x00,0x00,0xd8,0x03,0x00,0x00,0xd9,0x03,0x00,0x00,0xda,0x03,0x00,0x00,
	0xdb,0x03,0x00,0x00,0xdc,0x03,0x00,0x00,0xdd,0x03,0x00,0x00,0xde,0x03,0x00,0x00,0xdf,0x03,0x00,0x00,
	0xe0,0x03,0x00,0x00,0xe1,0x03,0x00,0x00,0xe2,0x03,0x00,0x00,0xe3,0x03,0x00,0x00,0xe4,0x03,0x00,0x00,
	0xe5,0x03,0x00,0x00,0xe6,0x03,0x00,0x00,0xe7,0x03,0x00,0x00,0xe8,0x03,0x00,0x00,0xe9,0x03,0x00,0x00,
	0xea,0x03,0x00,0x00,0xeb,0x03,0x00,0x00,0xec,0x03,0x00,0x00,0xed,0x03,0x00,0x00,0xee,0x03,0x00,0x00,
	0xef,0x03,0x00,0x00,0xf0,0x03,0x00,0x00,0xf1,0x03,0x00,0x00,0xf2,0x03,0x00,0x00,0xf3,0x03,0x00,0x00,
	0xf4,0x03,0x00,0x00,0xf5,0x03,0x00,0x00,0xf6,0x03,0x00,0x00,0xf7,0x03,0x00,0x00,0xf8,0x03,0x00,0x00,
	0xf9,0x03,0x00,0x00,0xfa,0x03,0x00,0x00,0xfb,0x03,0x00,0x00,0xfc,0x03,0x00,0x00,0xfd,0x03,0x00,0x00,
	0xfe,0x03,0x00,0x00,0xff,0x03,0x00,0x00,0x00,0x01,0x00,0x00,0x01,0x01,0x00,0x00,0x02,0x01,0x00,0x00,
	0x03,0x01,0x00,0x00,0x04,0x01,0x00,0x00,0x05,0x01,0x00,0x00,0x06,0x01,0x00,0x00,0x07,0x01,0x00,0x00,
	0x08,0x01,0x00,0x00,0x09,0x01,0x00,0x00,0x0a,0x01,0x00,0x00,0x0b,0x01,0x00,0x00,0x0c,0x01,0x00,0x00,
	0x0d,0x01,0x00,0x00,0x0e,0x01,0x00,0x00,0x0f,0x01,0x00,0x00,0x10,0x01,0x00,0x00,0x11,0x01,0x00,0x00,
	0x12,0x01,0x00,0x00,0x13,0x01,0x00,0x00,0x14,0x01,0x00,0x00,0x15,0x01,0x00,0x00,0x16,0x01,0x00,0x00,
	0x17,0x01,0x00,0x00,0x18,0x01,0x00,0x00,0x19,0x01,0x00,0x00,0x1a,0x01,0x00,0x00,0x1b,0x01,0x00,0x00,
	0x1c,0x01,0x00,0x00,0x1d,0x01,0x00,0x00,0x1e,0x01,0x00,0x00,0x1f,0x01,0x00,0x00,0x20,0x01,0x00,0x00,
	0x21,0x01,0x00,0x00,0x22,0x01,0x00,0x00,0x23,0x01,0x00,0x00,0x24,0x01,0x00,0x00,0x25,0x01,0x00,0x00,
	0x26,0x01,0x00,0x00,0x27,0x01,0x00,0x00,0x28,0x01,0x00,0x00,0x29,0x01,0x00,0x00,0x2a,0x01,0x00,0x00,
	0x2b,0x01,0x00,0x00,0x2c,0x01,0x00,0x00,0x2d,0x01,0x00,0x00,0x2e,0x01,0x00,0x00,0x2f,0x01,0x00,0x00,
	0x30,0x01,0x00,0x00,0x31,0x01,0x00,0x00,0x32,0x01,0x00,0x00,0x33,0x01,0x00,0x00,0x34,0x01,0x00,0x00,
	0x35,0x01,0x00,0x00,0x36,0x01,0x00,0x00,0x37,0x01,0x00,0x00,0x38,0x01,0x00,0x00,0x39,0x01,0x00,0x00,
	0x3a,0x01,0x00,0x00,0x3b,0x01,0x00,0x00,0x3c,0x01,0x00,0x00,0x3d,0x01,0x00,0x00,0x3e,0x01,0x00,0x00,
	0x3f,0x01,0x00,0x00,0x40,0x01,0x00,0x00,0x41,0x01,0x00,0x00,0x42,0x01,0x00,0x00,0x43,0x01,0x00,0x00,
	0x44,0x01,0x00,0x00,0x45,0x01,0x00,0x00,0x46,0x01,0x00,0x00,0x47,0x01,0x00,0x00,0x48,0x01,0x00,0x00,
	0x49,0x01,0x00,0x00,0x4a,0x01,0x00,0x00,0x4b,0x01,0x00,0x00,0x4c,0x01,0x00,0x00,0x4d,0x01,0x00,0x00,
	0x4e,0x01,0x00,0x00,0x4f,0x01,0x00,0x00,0x50,0x01,0x00,0x00,0x51,0x01,0x00,0x00,0x52,0x01,0x00,0x00,
	0x53,0x01,0x00,0x00,0x54,0x01,0x00,0x00,0x55,0x01,0x00,0x00,0x56,0x01,0x00,0x00,0x57,0x01,0x00,0x00,
	0x58,0x01,0x00,0x00,0x59,0x01,0x00,0x00,0x5a,0x01,0x00,0x00,0x5b,0x01,0x00,0x00,0x5c,0x01,0x00,0x00,
	0x5d,0x01,0x00,0x00,0x5e,0x01,0x00,0x00,0x5f,0x01,0x00,0x00,0x60,0x01,0x00,0x00,0x61,0x01,0x00,0x00,
	0x62,0x01,0x00,0x00,0x63,0x01,0x00,0x00,0x64,0x01,0x00,0x00,0x65,0x01,0x00,0x00,0x66,0x01,0x00,0x00,
	0x67,0x01,0x00,0x00,0x68,0x01,0x00,0x00,0x69,0x01,0x00,0x00,0x6a,0x01,0x00,0x00,0x6b,0x01,0x00,0x00,
	0x6c,0x01,0x00,0x00,0x6d,0x01,0x00,0x00,0x6e,0x01,0x00,0x00,0x6f,0x01,0x00,0x00,0x70,0x01,0x00,0x00,
	0x71,0x01,0x00,0x00,0x72,0x01,0x00,0x00,0x73,0x01,0x00,0x00,0x74,0x01,0x00,0x00,0x75,0x01,0x00,0x00,
	0x76,0x01,0x00,0x00,0x77,0x01,0x00,0x00,0x78,0x01,0x00,0x00,0x79,0x01,0x00,0x00,0x7a,0x01,0x00,0x00,
	0x7b,0x01,0x00,0x00,0x7c,0x01,0x00,0x00,0x7d,0x01,0x00,0x00,0x7e,0x01,0x00,0x00,0x7f,0x01,0x00,0x00,
	0x80,0x05,0x40,0x06,0x81,0x05,0x00,0x88,0x82,0x05,0x00,0x98,0x83,0x25,0x00,0x18,0x84,0x29,0x40,0x11,
	0x85,0x2d,0x80,0x1d,0x86,0x3d,0xc0,0x22,0x87,0x41,0x80,0x0b,0x88,0x35,0x08,0x00,0x89,0x35,0x08,0xf8,
	0x8a,0x01,0x00,0x00,0x8b,0x01,0x00,0x00,0x8c,0x01,0x00,0x00,0x8d,0x01,0x00,0x00,0x8e,0x01,0x00,0x00,
	0x8f,0x01,0x00,0x00,0x90,0x01,0x00,0x00,0x91,0x01,0x00,0x00,0x92,0x01,0x00,0x00,0x93,0x01,0x00,0x00,
	0x94,0x01,0x00,0x00,0x95,0x01,0x00,0x00,0x96,0x01,0x00,0x00,0x97,0x01,0x00,0x00,0x98,0x01,0x00,0x00,
	0x99,0x01,0x00,0x00,0x9a,0x01,0x00,0x00,0x9b,0x01,0x00,0x00,0x9c,0x01,0x00,0x00,0x9d,0x01,0x00,0x00,
	0x9e,0x01,0x00,0x00,0x9f,0x01,0x00,0x00,0xa0,0x01,0x00,0x00,0xa1,0x01,0x00,0x00,0xa2,0x01,0x00,0x00,
	0xa3,0x01,0x00,0x00,0xa4,0x01,0x00,0x00,0xa5,0x01,0x00,0x00,0xa6,0x01,0x00,0x00,0xa7,0x01,0x00,0x00,
	0xa8,0x01,0x00,0x00,0xa9,0x01,0x00,0x00,0xaa,0x01,0x00,0x00,0xab,0x01,0x00,0x00,0xac,0x01,0x00,0x00,
	0xad,0x01,0x00,0x00,0xae,0x01,0x00,0x00,0xaf,0x01,0x00,0x00,0xb0,0x01,0x00,0x00,0xb1,0x01,0x00,0x00,
	0xb2,0x01,0x00,0x00,0xb3,0x01,0x00,0x00,0xb4,0x01,0x00,0x00,0xb5,0x01,0x00,0x00,0xb6,0x01,0x00,0x00,
	0xb7,0x01,0x00,0x00,0xb8,0x01,0x00,0x00,0xb9,0x01,0x00,0x00,0xba,0x01,0x00,0x00,0xbb,0x01,0x00,0x00,
	0xbc,0x01,0x00,0x00,0xbd,0x01,0x00,0x00,0xbe,0x01,0x00,0x00,0xbf,0x01,0x00,0x00,0xc0,0x01,0x00,0x00,
	0xc1,0x01,0x00,0x00,0xc2,0x01,0x00,0x00,0xc3,0x01,0x00,0x00,0xc4,0x01,0x00,0x00,0xc5,0x01,0x00,0x00,
	0xc6,0x01,0x00,0x00,0xc7,0x01,0x00,0x00,0xc8,0x01,0x00,0x00,0xc9,0x01,0x00,0x00,0xca,0x01,0x00,0x00,
	0xcb,0x01,0x00,0x00,0xcc,0x01,0x00,0x00,0xcd,0x01,0x00,0x00,0xce,0x01,0x00,0x00,0xcf,0x01,0x00,0x00,
	0xd0,0x01,0x00,0x00,0xd1,0x01,0x00,0x00,0xd2,0x01,0x00,0x00,0xd3,0x01,0x00,0x00,0xd4,0x01,0x00,0x00,
	0xd5,0x01,0x00,0x00,0xd6,0x01,0x00,0x00,0xd7,0x01,0x00,0x00,0xd8,0x01,0x00,0x00,0xd9,0x01,0x00,0x00,
	0xda,0x01,0x00,0x00,0xdb,0x01,0x00,0x00,0xdc,0x01,0x00,0x00,0xdd,0x01,0x00,0x00,0xde,0x01,0x00,0x00,
	0xdf,0x01,0x00,0x00,0xe0,0x01,0x00,0x00,0xe1,0x01,0x00,0x00,0xe2,0x01,0x00,0x00,0xe3,0x01,0x00,0x00,
	0xe4,0x01,0x00,0x00,0xe5,0x01,0x00,0x00,0xe6,0x01,0x00,0x00,0xe7,0x01,0x00,0x00,0xe8,0x01,0x00,0x00,
	0xe9,0x01,0x00,0x00,0xea,0x01,0x00,0x00,0xeb,0x01,0x00,0x00,0xec,0x01,0x00,0x00,0xed,0x01,0x00,0x00,
	0xee,0x01,0x00,0x00,0xef,0x01,0x00,0x00,0xf0,0x01,0x00,0x00,0xf1,0x01,0x00,0x00,0xf2,0x01,0x00,0x00,
	0xf3,0x01,0x00,0x00,0xf4,0x01,0x00,0x00,0xf5,0x01,0x00,0x00,0xf6,0x01,0x00,0x00,0xf7,0x01,0x00,0x00,
	0xf8,0x01,0x00,0x00,0xf9,0x01,0x00,0x00,0xfa,0x01,0x00,0x00,0xfb,0x01,0x00,0x00,0xfc,0x01,0x00,0x00,
	0xfd,0x01,0x00,0x00,0xfe,0x01,0x00,0x00,0xff,0x01,0x00,0x00,
	END_REG, END_REG,
}; 
*/
//;  -->{SIF_ADDR_S2,0xfd},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xfe},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},{SIF_ADDR_S2,0xff},{SIF_TX_DATA1,0x01},{SIF_TX_DATA2,0x00},{SIF_TX_DATA3,0x00},{SIF_CONTROL,0x01},
#endif

//////////////////////////////////////////////////////////////////////
// GAIN
//////////////////////////////////////////////////////////////////////
unsigned char new_gain[] =
{
#if 0
	// Y Gain
	0x5f,0x00,
	0x9f,0x00,
	0x65,0x00,

	// U Gain
	0xac,0x03,
	0xc5,0x02,
	0x97,0x01,


	// V Gain

	0x18,0x01,
	0xee,0x02,
	0xf2,0x03

#elif 0

	// Y Gain
	0x4d,0x00,
	0x96,0x00,
	0x1d,0x00,


	// U Gain
	0xd5,0x03,
	0xab,0x03,
	0x80,0x00,

	// V Gain
	0x80,0x00,
	0x95,0x03,
	0xeb,0x03
	
#elif 1	//MT9V011

#ifdef ISSC
	// Y Gain
	0x4d,0x00,
	0x96,0x00,
	0x1d,0x00,

	// U Gain
	0xB5,0x03,
	0x6B,0x03,
	0xE0,0x00,

	// V Gain
	0xE0,0x00,
	0x45,0x03,
	0xDB,0x03
#else
	// Y Gain
	0x4d,0x00,
	0x96,0x00,
	0x1d,0x00,

	// U Gain
	0xB5,0x03,
	0x6B,0x03,
	0xE0,0x00,

	// V Gain
	0xE0,0x00,
	0x45,0x03,
	0xDB,0x03
#endif

#else // TAS

	// Y Gain
	0x59,0x00,
	0xc7,0x00,
	0x42,0x00,


	// U Gain
	0x90,0x03,
	0x18,0x03,
	0x60,0x01,


	// V Gain
	0x00,0x01,
	0x05,0x03,
	0xda,0x03

#endif
};

#endif


